// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include "beep.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "Timer Beep";

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "TIMERBEEP";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  switch (msg)
  {
    case WM_CREATE:
    {
      // ᪠ ⠩  ࢠ 1000 
      WinStartTimer(hab, hWnd, ID_APP_TIMER1, 1000);

      // ᪠ ⠩  ࢠ 3000 
      WinStartTimer(hab, hWnd, ID_APP_TIMER2, 3000);
      return FALSE;
    }

    case WM_DESTROY:
    {
      // ⠭ ⠩
      WinStopTimer(hab, hWnd, ID_APP_TIMER1);
      WinStopTimer(hab, hWnd, ID_APP_TIMER2);
      return 0;
    }

    case WM_TIMER:
    {
      //   ⠩ 뤠 㪮
      // ᨣ ᢮   ⥫쭮
      switch(SHORT1FROMMP(mp1))
      {
        case ID_APP_TIMER1:
        {
          DosBeep(1000, 100);
          break;
        }

        case ID_APP_TIMER2:
        {
          DosBeep(400, 300);
          break;
        }

        default:
          return(WinDefWindowProc(hWnd, msg, mp1, mp2));
      }

      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

