#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <ctype.h>

typedef struct _EBPB_ 
{
  unsigned sectsize;
  char clustsize;
  unsigned ressecs;
  char fatcnt;
  unsigned rootsize;
  unsigned totsecs;
  char media;
  unsigned fatsize;
  unsigned seccnt;
  unsigned headcnt;
  unsigned hiddensec_low;
  unsigned hiddensec_hi;
  unsigned long drvsecs;
} EBPB;

typedef struct _BOOT_
{
  char jmp[3];
  char oem[8];
  EBPB bpb;
  char drive;
  char reserved;
  char signature;
  unsigned volser_lo;
  unsigned volser_hi;
  char label[11];
  char fat_format[8];
  char boot_code[450];
} BOOT;

int getboot(BOOT far *boot, int drive);

int main(void)
{
  char boot[512];
  BOOT far* boot_rec = (BOOT far*)boot;
  int i, status;
  char drive;

  printf("\n⥭ 㧮筮  ᪮ ᪠"
    "\n   (C)஫ ., 1995\n");

  // 訢 ,  ண 室
  // 믮 ⥭ 㧮筮 
  printf(
    "\n 祭 ᪠,  ᬮ"
    "\n㧮筮  (A, B, ...):");
  drive = getche();

  // 塞  ᪮
  drive = toupper(drive) - 'A';

  // ⠥ 㧮   
    status = getboot((BOOT far*)boot_rec, drive);

  // ᫨ ந諠 訡 (ਬ, ࠢ쭮
  // 㪠 祭 ᪠),
  // 蠥 ࠡ ணࠬ
  if(status)
  {
    printf("\n訡  ⥭ 㧮筮 ᥪ");
    return(-1);
  }

  printf("\nন 㧮筮 "
    "ᥪ  ᪠ %c", drive + 'A');
  printf("\n"
    "\nOEM -     DOS - ");

  for(i = 0; i < 8; i++)
    printf("%c", boot_rec->oem[i]);

  printf("\n ᪠                       - %x"
    "\nਧ ७ BOOT-   - %c"
    "\n਩  ᪠              - %04X-%04X"
    "\n⪠ ᪠                       - ",
    (unsigned char)boot_rec->drive,
    boot_rec->signature,
    boot_rec->volser_hi,
    boot_rec->volser_lo);

  for(i = 0; i < 11; i++)
    printf("%c", boot_rec->label[i]);

  printf("\nଠ FAT                        - ");
  for(i = 0; i < 8; i++)
    printf("%c", boot_rec->fat_format[i]);

  printf("\n\nଠ  BPB:");
  printf("\n⢮ ⮢  ᥪ       - %d"
    "\n⢮ ᥪ஢      - %d"
    "\n१ࢨ஢ ᥪ஢          - %d"
    "\n⢮  FAT              - %d"
    "\n. ⢮ 䠩  ୥ ⠫ - %d"
    "\n饥 ⢮ ᥪ஢  ᪥          - %d"
    "\n-⥫ ।              - %x"
    "\n⢮ ᥪ஢  FAT         - %d",
    boot_rec->bpb.sectsize, boot_rec->bpb.clustsize,
    boot_rec->bpb.ressecs,  boot_rec->bpb.fatcnt,
    boot_rec->bpb.rootsize, boot_rec->bpb.totsecs,
    (unsigned char)boot_rec->bpb.media,
    boot_rec->bpb.fatsize);

  printf("\n\nଠ  ७ BPB:");
  printf("\n஢  ஦               - %d"
    "\n⢮                 - %d"
    "\n ᥪ஢  ᪠ < 32 M  - %d"
    "\n ᥪ஢  ᪠ >= 32 M - %d"
    "\nᥣ ᥪ஢  ᪥           - %u",
    boot_rec->bpb.seccnt, boot_rec->bpb.headcnt,
    boot_rec->bpb.hiddensec_low,
    boot_rec->bpb.hiddensec_hi,
    boot_rec->bpb.totsecs);

  return 0;
}

/**
* getboot
*
*  㧮 
*
* int getmboot(BOOT far *boot, int drive);
*
*  boot   - 㪠⥫  ,  
*           㤥 ⠭ 㧮筠 
*
*  drive  -  䨧᪮ 
*           (0 -  , 1 - ன, ...)
**/

int getboot(BOOT far *boot, int drive)
{
  union REGS reg;
  struct SREGS segreg;

  reg.x.ax  = drive;
  reg.x.bx  = FP_OFF(boot);
  segreg.ds = FP_SEG(boot);
  reg.x.cx  = 1;
  reg.x.dx  = 0;
  int86x(0x25, &reg, &reg, &segreg);

  //   ⥪ ⠢襥 ⠬ ᫥
  // 맮 뢠 ᫮
  asm pop ax
  return(reg.x.cflag);
}
