/**
*.Name      disk_cfg
*
*.Title     । 䨣 ᪮ ⥬
*
*.Descr     㭪  , 뢠
*           䨣 ᪮ ⥬:
*
*              typedef struct _DISK_CONFIG_ {
*                 int  n_floppy;
*                 int  n_hard;
*                 int  t_floppy1;
*                 int  t_floppy2;
*                 int  t_hard1;
*                 int  t_hard2;
*              } DISK_CONFIG;
*
*.Proto     void disk_cfg(DISK_CONFIG* cfg);
*
*.Params        DISK_CONFIG* cfg - 㪠⥫  塞
*                                  
*
*.Return    祣
*
*.Sample    discshow.c
**/

#include <stdio.h>
#include <dos.h>
#include "sysp.h"

void disk_cfg(DISK_CONFIG* cfg) {

	char unsigned _far *modptr;
	char unsigned pc_type;
	char cfg_byte;
	int  cfg_word;

	union REGS inregs, outregs;


// ।塞 ⨯ 

	modptr = FP_MAKE(0xf000,0xfffe);
	pc_type = *modptr;

//  ᨬ  ⨯  롨ࠥ
// ᯮᮡ । 䨣樨 ᪮
// ⥬

	switch (pc_type) {

		case 0xfc:

//  IBM AT 뢠 䨣 ᪮
// ⥬  -

// 뢠  䨣樨

			outp(0x70, 0x14);
			cfg_byte = inp(0x71);

// ।塞 ⢮ ⠭ 䫮-᪮

			if((cfg_byte & 1) == 0) {

// ᫨ 訩   䨣樨 ࠢ 0,
// 䫮-᪨  ⠭

				cfg->n_floppy  = 0;
				cfg->t_floppy1 = 0;
				cfg->t_floppy2 = 0;

			}
			else {

// ।塞 ⢮ ⠭
// 䫮-᪮

				cfg->n_floppy = ((cfg_byte >> 6) & 3) + 1;

// ।塞 ⨯ 䫮-᪮

				outp(0x70, 0x10);
				cfg_byte = inp(0x71);

				cfg->t_floppy2 = cfg_byte & 0xf;
				cfg->t_floppy1 = (cfg_byte >> 4) & 0xf;

			}

// ।塞 䨣 ⪨ ᪮

			outp(0x70, 0x12);
			cfg_byte = inp(0x71);

			if(cfg_byte == 0) {

// ᫨  ࠤ ࠢ , ⥬
//  ᮤন ⪨ ᪮

				cfg->n_hard  = 0;
				cfg->t_hard1 = 0;
				cfg->t_hard2 = 0;
			}
			else {

// ।塞 ⨯ ࢮ ᪠ - ᪠ C:

				if((cfg_byte & 0xf) != 0xf)
					cfg->t_hard1 = cfg_byte & 0xf;

				else {
					outp(0x70, 0x19);
					cfg->t_hard1 = inp(0x71);
				}

// ।塞 ⨯ ண ᪠ - ᪠ D:

				if((cfg_byte & 0xf0) != 0xf0)
					cfg->t_hard2 = (cfg_byte >> 4) & 0xf;

				else {
					outp(0x70, 0x1a);
					cfg->t_hard2 = inp(0x71);
				}

			}

// 塞 ⢮ ⠭
//  ⥬ ⪨ ᪮

			cfg->n_hard = 0;
			if(cfg->t_hard1 != 0) cfg->n_hard++;
			if(cfg->t_hard2 != 0) cfg->n_hard++;

//   ᮢ⨬  IBM AT 設 
// । ⨯ ᪠, ⠪   - 
// ⨯ ᪠ ⠭ 祭 0, ᬮ  ,
//   ⠭ (ਬ 設 Bondwell,
//  -300).  ⠪   ।
// 稥 ⪮ ᪠, ᯮ ᫮
// 䨣樨, 頥 뢠 INT 11h.

			if(cfg->n_hard == 0) {

				int86(0x11, &inregs, &outregs);
				cfg_word = outregs.x.ax;

// ।塞 稥 ⪮ ᪠

				if((cfg_word & 1) != 0) {

					cfg->n_hard =  1;

// ⠥,  ⨯ ᯮ㥬 ⪮
// ᪠ ।

					cfg->t_hard1 = 0;
					cfg->t_hard2 = 0;

				}
			}

		break;

		default:

//  ⠫ ⨯ ஢ 뢠
// 뢠 INT 11h, ᯮ㥬 頥
// ⨬ 뢠  䨣樨

			int86(0x11, &inregs, &outregs);
			cfg_word = outregs.x.ax;

// ।塞 ⢮ ⠭
// 䫮-᪮

			cfg->n_floppy = ((cfg_word >> 6) & 3) + 1;

// ⠥,  ⨯ ᯮ㥬 䫮-᪠
// ।

			cfg->t_floppy1 = 0;
			cfg->t_floppy2 = 0;

// ।塞 稥 ⪮ ᪠

			if((cfg_word & 1) != 0) {

				cfg->n_hard =  1;

// ⠥,  ⨯ ᯮ㥬 ⪮
// ᪠ ।

				cfg->t_hard1 = 0;
				cfg->t_hard2 = 0;

			}

		break;

	}

}
