include sysp.inc

	.MODEL  tiny
	 DOSSEG
	.STACK  100h

	 .DATA

msg   DB 13,10,"   HMA", 13, 10
		DB       "Copyright (C)Frolov A.,1991",13,10,13,10
		DB "$"

noHMM    DB 13,10,"ࠩ HIMEM.SYS  ⠭", 13, 10, "$"
yesHMM   DB 13,10,"ࠩ HIMEM.SYS ⠭, ", "$"
errmsg   DB 13,10,"訡   ", "$"
okmsg    DB 13,10,"ᯥ!!!", "$"
hmareq   DB 13,10,"訢  HMA", "$"
hmarel   DB 13,10,"᢮  HMA", "$"
enA20    DB 13,10,"뢠  A20", "$"
dsA20    DB 13,10,"뢠  A20", "$"

HMMEntry dd ?

HMAStart dd ?

	.CODE
	.STARTUP

	mov     ah, 9h                ; 뢮 
	mov     dx, OFFSET msg
	int     21h

; ஢塞, ⠭  ࠩ HIMEM.SYS

	mov   ax, 4300h
	int   2fh
	cmp   al, 80h
	je    HMM_installed

; ᫨  ⠭, 뢮 ᮮ饭  蠥
; ࠡ ணࠬ

	mov   ah, 9h
	mov   dx, OFFSET noHMM
	int   21h
	jmp   terminate

HMM_installed:

	mov   ah, 9h
	mov   dx, OFFSET yesHMM
	int   21h

; 砥  ࠢ饩 㭪樨 ࠩ

	mov   ax, 4310h
	int   2fh
	mov   word ptr cs:[HMMEntry][0], bx
	mov   word ptr cs:[HMMEntry][2], es

; 訢  HMA

	mov   ah, 9h
	mov   dx, OFFSET hmareq
	int   21h

	mov   ax,0100h
	mov   dx,0ffffh
	call  cs:[HMMEntry]
	or    ax, ax
	jnz   hmareq_ok
	jmp   error

hmareq_ok:
	mov   ah, 9h
	mov   dx, OFFSET okmsg
	int   21h

; 뢠  A20

	mov   ah, 9h
	mov   dx, OFFSET enA20
	int   21h

	mov   ax,0300h
	call  cs:[HMMEntry]
	or    ax, ax
	jnz   enA20_ok
	jmp   error

enA20_ok:
	mov   ah, 9h
	mov   dx, OFFSET okmsg
	int   21h

; 뢠   ᫮ HMAStart
;  砫  HMA

	mov   word ptr cs:[HMAStart][0], 0010h
	mov   word ptr cs:[HMAStart][2], 0ffffh

; 㥬   HMA 楤, 
; 㤥 ⠬ 믮

	cld
	lea   si, begin_HMA_code
	mov   di, 0010h

	mov   ax, cs
	mov   ds, ax

	mov   ax, 0ffffh
	mov   es, ax

	mov   cx, HMA_code_size
	rep movsb

; 뢠 楤, 室   HMA

	call  cs:[HMAStart]

; 뢠  A20

	mov   ah, 9h
	mov   dx, OFFSET dsA20
	int   21h

	mov   ax,0400h
	call  cs:[HMMEntry]
	or    ax, ax
	jnz   dsA20_ok
	jmp   error

dsA20_ok:

	mov   ah, 9h
	mov   dx, OFFSET okmsg
	int   21h

; ᢮  HMA

	mov   ah, 9h
	mov   dx, OFFSET hmarel
	int   21h

	mov   ax,0200h
	call  cs:[HMMEntry]
	or    ax, ax
	jz    error

	mov   ah, 9h
	mov   dx, OFFSET okmsg
	int   21h

	jmp   terminate

error:

	push  bx
	mov   ah, 9h
	mov   dx, OFFSET errmsg
	int   21h

	pop   ax
	call  Print_word

terminate:

	.EXIT   0



; 뢮  ࠭ ᮤন ॣ AX

Print_word proc near
;--------------------
	  push ax
	  push bx
	  push dx
;
	  push ax
	  mov cl,8
	  rol ax,cl
	  call Byte_to_hex
	  mov bx,dx
	  @@out_ch bh
	  @@out_ch bl
;
	  pop ax
	  call Byte_to_hex
	  mov bx,dx
	  @@out_ch bh
	  @@out_ch bl
;
	  pop dx
	  pop bx
	  pop ax
	  ret
Print_word endp
;
Byte_to_hex proc near
;--------------------
; al - input byte
; dx - output hex
;--------------------
	  push ds
	  push cx
	  push bx
;
	  lea bx,tabl
	  mov dx,cs
	  mov ds,dx
;
	  push ax
	  and al,0fh
	  xlat
	  mov dl,al
;
	  pop ax
	  mov cl,4
	  shr al,cl
	  xlat
	  mov dh,al
;
	  pop bx
	  pop cx
	  pop ds
	  ret
;
tabl db '0123456789ABCDEF'
Byte_to_hex endp


;  楤 ।祭 
; 믮   HMA.
;    ࠧ 
; 㪮 ᨣ.

begin_HMA_code:

	BEEP
	BEEP
	BEEP
	retf

end_HMA_code:

;  ᠭ  楤,
; ।祭  믮 
;  HMA

HMA_code_size dw $-begin_HMA_code

		  END
