// ----------------------------------------
//     
// ----------------------------------------

#define STRICT
#include <windows.h>
#include "string.hpp"

//    
void Error(void);

#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine,
	int       nCmdShow)
{
  //     
	BYTE szAppName[20];
	BYTE szWindowName[80];
	BYTE szMsg[80];
  BYTE szBuf[80];
  int  cb;

	//     IDS_APPNAME
	cb = LoadString(hInstance, IDS_APPNAME,
	  szAppName, sizeof(szAppName));

	//     0 ,
	//  ,    .
	//       
	//      
	if(!cb)
	{
			Error(); return -1;
  }

	//     IDS_WINDOWNAME
	cb = LoadString(hInstance, IDS_WINDOWNAME,
	  szWindowName, sizeof(szWindowName));

	if(!cb)
	{
			Error(); return -1;
  }

	//     IDS_MESSAGE
	cb = LoadString(hInstance, IDS_MESSAGE,
	  szMsg, sizeof(szMsg));

	if(!cb)
	{
			Error(); return -1;
  }

  //     
	wsprintf(szBuf, szMsg, (LPSTR)szAppName, 1994);

	//  ,   
  //   1994
	MessageBox(NULL, szBuf, szWindowName,
	  MB_OK | MB_ICONINFORMATION);

	return 0;
}

// --------------------------------------------
//     
// --------------------------------------------
void Error(void)
{
	MessageBox(NULL, "   ",
	  "Error", MB_OK | MB_ICONSTOP);
}