// =====================================================
//  ,    MS-DOS
// share.exe,    
// =====================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <dos.h>

#pragma argsused

int ShareLoaded(void);

int PASCAL
WinMain(HINSTANCE hInstance,
   HINSTANCE hPrevInstance,
   LPSTR     lpszCmdLine, int nCmdShow)
{
  int rc;

  // ,   share.exe
  rc = ShareLoaded();

  if (!rc) {
    //     -1,   
    //     , 
    //   
    if(rc == -1)
    {
      MessageBox(NULL, "File creation error", "", MB_OK);
    }

    //     0, share.exe  
    else
    {
      MessageBox(NULL, "Share NOT loaded", "", MB_OK);
    }
  }

  //     1, share.exe 
  else
  {
    MessageBox(NULL, "Share loaded", "SHARE Test", MB_OK);
  }

  return 0;
}

// -------------------------------------------------------
//  ShareLoaded
// ,    share.exe
// -------------------------------------------------------

int ShareLoaded(void)
{
  HFILE hfTempFile;
  OFSTRUCT ofs;
  char szBuf[144];
  union REGS regs;
  int rc;

  //      
  GetTempFileName(0, "tst", 0, szBuf);
  hfTempFile = _lcreat(szBuf, 0);

  //     ,  -1
  if (hfTempFile == HFILE_ERROR) {
    return(-1);
  }

  //      

  regs.x.bx = hfTempFile; //  
  regs.h.ah = 0x5c;       //   MS-DOS
  regs.h.al = 0;          //   
  regs.x.cx = 0;          // CX:DX -   
  regs.x.dx = 0;
  regs.x.si = 0;          // SI:DI -   
  regs.x.di = 1;

  //   MS-DOS
  intdos(&regs, &regs);

  //    ,  
  // . ,    
  //  share.exe  
  if(regs.x.cflag == 1)
  {
    rc = 0;
  }

  //    ,
  //      
  else
  {
    regs.x.bx = hfTempFile;
    regs.h.ah = 0x5c;
    regs.h.al = 1;    //   
    regs.x.cx = 0;
    regs.x.dx = 0;
    regs.x.si = 0;
    regs.x.di = 1;
    intdos(&regs, &regs);
    rc = 1;
  }

  //   
  _lclose(hfTempFile);

  //   
  OpenFile(szBuf, &ofs, OF_DELETE);

  return rc;
}