// ================================================
// DLL- kbhook.dll
//    ,
//      
//  .
//    3   <Control>,
//   
// ================================================

#define  STRICT
#include <windows.h>
#include "kbhook.hpp"

// -----------------------------------------------
//  
// -----------------------------------------------

//   DLL-
static HINSTANCE hInst;

//   , 
// 
static HWND hwndClient;

//  
static HHOOK hhook = 0;
static HHOOK hhookMsg = 0;

//     
static BOOL bCyrillic = FALSE;

//   
static BOOL bHooked = FALSE;

//  
static int nHotKeyCount = 0;

//     
BYTE aKeyStates[256];

//    ,
//     
static char far * lpXlatTable;
static char far * lpXlatTableCaps;

//    
static HRSRC   hResource;
static HRSRC   hResourceCaps;

//   
static HGLOBAL hXlatTable;
static HGLOBAL hXlatTableCaps;

// -----------------------------------------------
//  
// -----------------------------------------------

extern "C"
LRESULT CALLBACK KbHookProc(int code,
  WPARAM wParam, LPARAM lParam);

extern "C"
LRESULT CALLBACK MsgHookProc(int code,
  WPARAM wParam, LPARAM lParam);

// ========================================================
//  LibMain
//      
//  DLL-  
// ========================================================

#pragma argsused
int CALLBACK
LibMain(HINSTANCE hInstance,
                  WORD wDataSegment,
                  WORD wHeapSize,
                  LPSTR lpszCmdLine)
{
  //     
  //  LibEntry   .
  //   .
  if(wHeapSize != 0)
    //   
    UnlockData(0);

  //    DLL-
  hInst = hInstance;

  //   
  hResource   = FindResource(hInstance, "XlatTable", "XLAT");
  hResourceCaps = FindResource(hInstance, "XlatTableCaps", "XLAT");

  //   
  hXlatTable  = LoadResource(hInstance, hResource);
  hXlatTableCaps  = LoadResource(hInstance, hResourceCaps);

  //    ,   
  lpXlatTable = (char far *)LockResource(hXlatTable);
  lpXlatTableCaps = (char far *)LockResource(hXlatTableCaps);

  //    NULL,   
  //      
  if(lpXlatTable == NULL || lpXlatTableCaps == NULL)
  {
    return(0);
  }

  //   <Caps Lock>.  
  //       aKeyStates 
  // ,     
  // ,      
  GetKeyboardState(aKeyStates);
  aKeyStates[VK_CAPITAL] = 0;
  SetKeyboardState(aKeyStates);

  //  1.  ,  
  // DLL-  
  return 1;
}

// ========================================================
//  WEP
//      
//  DLL-  
// ========================================================

#pragma argsused
int CALLBACK
WEP(int bSystemExit)
{
  //    
  UnlockResource(hXlatTable);
  FreeResource(hXlatTable);
  UnlockResource(hXlatTableCaps);
  FreeResource(hXlatTableCaps);

  return 1;
}

// ========================================================
//  SetKbHook
//     ,
//   ,   
//  
// ========================================================

extern "C"
void WINAPI _export SetKbHook(HWND hwnd)
{
  //   
  //   ,    
  //   
  if(!bHooked)
  {
    //    ,
    //   
    hhook = SetWindowsHookEx(WH_KEYBOARD,
      (HOOKPROC)KbHookProc,
      hInst, NULL); 

    //    
    //  
    hhookMsg = SetWindowsHookEx(WH_GETMESSAGE,
      (HOOKPROC)MsgHookProc,
      hInst, NULL);

    //    
    bHooked = TRUE;

    //    ,
    //  
    hwndClient = hwnd;
  }
}

// ========================================================
//  RemoveKbHook
//   
// ========================================================

extern "C"
void WINAPI _export RemoveKbHook(void)
{
  //    ,
  //  
  if(bHooked)
  {
    UnhookWindowsHookEx(hhookMsg);
    UnhookWindowsHookEx(hhook);
  }
}

// ========================================================
//  KbHookProc
//    
// ========================================================

extern "C"
LRESULT CALLBACK KbHookProc(int code,
  WPARAM wParam, LPARAM lParam)
{
  //    .  
  //  code  ,  
  //  CallNextHookEx  
  if(code < 0)
  {
    CallNextHookEx(hhook, code, wParam, lParam);
    return 0;
  }

  //      <Control>,
  // ,     
  //   
  if(wParam  == VK_CONTROL)
  { 
    if(!(HIWORD(lParam) & 0x8000))
    {
      nHotKeyCount++;

      //   <Control>   
      //  ,    
      //   bCyrillic  
      //  , 
      //  DLL-
      if(nHotKeyCount == 3)
      {
        nHotKeyCount = 0;
        bCyrillic = ~bCyrillic;

        //   , 
        // .    wParam
        //     bCyrillic
        PostMessage(hwndClient, WM_KBHOOK,
          (WPARAM)bCyrillic, 0L);
      }
    }
  }

  //    <Control>   
  //  ,  
  else
  {
    nHotKeyCount = 0;
  }

  //     
  return CallNextHookEx(hhook, code, wParam, lParam);
}

// ========================================================
//  KbHookProc
//     
// ========================================================

extern "C"
LRESULT CALLBACK MsgHookProc(int code,
  WPARAM wParam, LPARAM lParam)
{
  LPMSG lpmsg;
  WPARAM wMsgParam;

  //    .  
  //  code  ,  
  //  CallNextHookEx  
  if(code < 0)
  {
    CallNextHookEx(hhook, code, wParam, lParam);
    return 0;
  }

  //     MSG,
  //     
  lpmsg = (LPMSG)lParam;

  //    
  wMsgParam = lpmsg->wParam;

  //    
  // WM_KEYDOWN   WM_CHAR
  BOOL bChange = FALSE;

  //    WM_KEYDOWN,
  //      
  //    
  if(lpmsg->message == WM_KEYDOWN)
  {
    //     
    //  
    if(bCyrillic)
    {
      //   , 
      //  ,   bChange
      switch(wMsgParam)
      {
        //  "" 
        case 0xdb: // ""
        case 0xdd: // ""
        case 0xba: // ""
        case 0xde: // ""
        case 0xbc: // ""
        case 0xbe: // ""
        case 0xbf: // ""
        {
          bChange = TRUE;
          break;
        }

        //   
        default:
        {
          if((lpmsg->wParam <= 0x5d && lpmsg->wParam > 0x2f))
            bChange = TRUE;
        }
      }

      //   ,  
      // ,    WM_KEYDOWN 
      //  WM_CHAR
      if(bChange)
      {
        //    
        lpmsg->message = WM_CHAR;

        //    
        // <Caps Lock>  <Shift>
        if(GetKeyState(VK_CAPITAL) & 0x1)
        {
          if(GetKeyState(VK_SHIFT) & 0x8000)
          {
            //     
            lpmsg->wParam =
              lpXlatTable[(lpmsg->wParam) & 0xff];
          }
          else
          {
            //     
            lpmsg->wParam =
              lpXlatTableCaps[(lpmsg->wParam) & 0xff];
          }
        }
        else
        {
          if(GetKeyState(VK_SHIFT) & 0x8000)
          {
            //     
            lpmsg->wParam = lpXlatTableCaps[(lpmsg->wParam) & 0xff];
          }
          else
          {
            //     
            lpmsg->wParam = lpXlatTable[(lpmsg->wParam) & 0xff];
          }
        }

        //   
        bChange = FALSE;
      }
    }
  }

  //     
  //  
  CallNextHookEx(hhook, code, wParam, lParam);

  return 0;
}
