// ----------------------------------------
//    bitmap
//     
// ----------------------------------------

#define STRICT
#include <windows.h>

void DrawBitmapRop(HDC hDC, int x, int y, HBITMAP hBitmap, DWORD dwRop)
{
  HBITMAP hbm, hOldbm;
  HDC hMemDC;
  BITMAP bm;
  POINT  ptSize, ptOrg;

  //   , 
  //   
  hMemDC = CreateCompatibleDC(hDC);

  //   bitmap   
  hOldbm = (HBITMAP)SelectObject(hMemDC, hBitmap);

  //    ,  
  if (hOldbm)
  {
    //      
    //  ,   
    //  
    SetMapMode(hMemDC, GetMapMode(hDC));

    //   
    GetObject(hBitmap, sizeof(BITMAP), (LPSTR) &bm);

    ptSize.x = bm.bmWidth;   // 
    ptSize.y = bm.bmHeight;  // 

    //     
    //   
    DPtoLP(hDC, &ptSize, 1);

    ptOrg.x = 0;
    ptOrg.y = 0;

    //     
    //   
    DPtoLP(hMemDC, &ptOrg, 1);

    //   bitmap
    BitBlt(hDC, x, y, ptSize.x, ptSize.y,
	   hMemDC, ptOrg.x, ptOrg.y, dwRop);

    //   
    SelectObject(hMemDC, hOldbm);
  }

  //   
  DeleteDC(hMemDC);
}

