// ----------------------------------------
//  
// MessageBeep  sndPlaySound
// ----------------------------------------
#define STRICT
#include <windows.h>
#include <mmsystem.h>

#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpszCmdLine, int nCmdShow)
{
   HANDLE hWaveRes, hRes;
   LPSTR lpRes;
   BOOL rc;
   HFILE hf;
   DWORD dwFileSize;
   HGLOBAL hWave;
   char huge *lpBuf;

   //  ,  
   // SystemQuestion  [sound]  win.ini
   MessageBeep(MB_ICONQUESTION);

   MessageBox(NULL, ",  ?",
     "SndPlay", MB_OK | MB_ICONQUESTION);

   //   sndplay.snd   
   rc = sndPlaySound((LPSTR)"sndplay.wav", SND_SYNC);
   if(!rc)
   {
     MessageBeep(MB_ICONHAND);
     MessageBox(NULL, "    sndplay.wav",
       "SndPlay", MB_OK | MB_ICONHAND);
     return -1;
   }

   //      
   //   

   //   
   hWaveRes = FindResource(hInstance, "APP_SOUND", "WAVE");
   if(hWaveRes)
   {
     //    
     hRes = LoadResource(hInstance, (HRSRC)hWaveRes);
     if(hRes)
     {
       //    , 
       //   
       lpRes = (LPSTR)LockResource(hRes);
       if(lpRes)
       {
         //    
         rc = sndPlaySound(lpRes, SND_MEMORY | SND_ASYNC | SND_LOOP);

         MessageBox(NULL,
           "    OK",
           "SndPlay", MB_OK | MB_ICONINFORMATION);

         //  
         sndPlaySound(NULL, 0);

         //    
         UnlockResource(hRes);
         FreeResource(hRes);

         //     
         // wav-     

         //  wav-
         hf = _lopen((LPSTR)"uff.wav", OF_READ);

         //   
         dwFileSize = _llseek(hf, 0l, 2);
         _llseek(hf, 0l, 0);

         //    ,
         //     
         hWave = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, dwFileSize);

         //   
         lpBuf = (char huge *)GlobalLock(hWave);
         if(lpBuf != NULL)
         {
           //      
           _hread(hf, lpBuf, dwFileSize);

           //   ,   
           rc = sndPlaySound((LPCSTR)lpBuf, SND_MEMORY | SND_SYNC);
           if(!rc)
           {
             MessageBeep(MB_ICONHAND);
             MessageBox(NULL, "    uff.wav",
               "SndPlay", MB_OK | MB_ICONHAND);
           }

           //    
           GlobalUnlock(hWave);
           GlobalFree(hWave);

           //  
           _lclose(hf);
         }
       }
     }
   }
   return 0;
}