// GET_WORD.C
//

// (C) ஫ .., 1995
//  E-mail: frolov@glas.apc.org


#include <string.h>
#include <time.h>

#include "common.h"
#include "modem.h"
#include "get_word.h"
#include "timer.h"
#include "tools.h"
#include "total.h"



// WriteStr
// ࠡ⪠ ࠢ ᨬ
static unsigned WriteStr(register char *s)  {

	register char last = '\0';
	int no_CR  = FALSE;
	unsigned char digit;

	while (*s) {
		if (last == '\\') {
			last = *s;

			switch (*s) {

				// প   ᥪ㭤

				case 'd':
				case 'D':
					Sleep(2);
					break;

				//  । ᨬ ॢ ⪨   ப

				case 'c':
				case 'C':
					no_CR = TRUE;
					break;

				// । ᨬ  ⪨

				case 'r':
				case 'R':
					SlowWrite("\r", 1);
					break;

				// । ᨬ ॢ ⪨

				case 'n':
				case 'N':
					SlowWrite("\n", 1);
					break;

				// প 500 ᥪ㭤

				case 'p':
				case 'P':
					Delay(500);
					break;

				default:
					SlowWrite(s, 1);
					last = '\0';
			}
		}
		else if (*s != '\\')
			SlowWrite(s, 1);

		else
			last = *s;
		s++;
	}

	return no_CR;
}



// SendStr
// ᫠ ப   ।稪,
//  ⮬ ࠡ뢠 ᫥騥 ࠢ騥 ᨬ:

// d (D) - প   ᥪ㭤
// c (C) -  । ᨬ ॢ ⪨   ப
// r (R) - । ᨬ  ⪨
// n (N) - । ᨬ ॢ ⪨
// p (P) - প 500 ᥪ㭤

void SendStr(char *str) {

	if(!equal(str,"")) {
		if(!WriteStr(str))
			SlowWrite("\r", 1);
	}
	else
		SlowWrite("\r", 1);

	return;
}
