#define DARK_BLUE		RGB(0,0,127)	//  
#define DARK_GREEN	RGB(0,127,0)	//  

//  \376 \377

#define CM_EXIT	101
#define CM_ABOUT	102

//  WM_CONNECT
#define WM_CONNECT	WM_USER

//     
#define INQUEUE	4096
#define OUTQUEUE	4096

// ASCII-
#define ASCII_BELL	0x07
#define ASCII_BACK	0x08	
#define ASCII_LF		0x0A
#define ASCII_CR		0x0D

// \377      
#ifdef MAIN_MODULE
	HINSTANCE hInst;
	int idOpenCommPort;
#else
// \377\377  ,    
	extern int idOpenCommPort;
	extern HINSTANCE hInst;
#endif


// \377 
void 		About(HWND hwnd);
BOOL		InitApp(HINSTANCE hInstance);
LRESULT	UserChat(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT	CALLBACK _export WndProc (HWND hWnd, UINT message,
                                  WPARAM wParam, LPARAM lParam);

// COMMSG.CPP
int ProcessCommNotify(HWND hWnd, int nComID, int nNotification);


// COMMPORT.CPP
int InitCommPort( HWND hwnd);
int CloseCommPort( int nComID );
int ReadCommPort( int nComID , LPSTR Data , int nMaxLength );
//int WriteCommPort( int nComID , LPSTR Data , int nLength );


// TTY.CPP
void InitTTY(HWND hWnd);
void WriteTTY(LPSTR lpOutString, HWND hwnd, COLORREF rgbColor);

void SetFocusTTY(HWND hwnd);
void KillFocusTTY(HWND hwnd);