#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

void print_info(struct find_t *find);
char *time_conv(unsigned time, char *char_buf);
char *date_conv(unsigned date, char *char_buf);

#pragma argsused
int main(int argc, char *argv[])
{
  struct find_t find;

  // 室  䠩, 㤮⢮騩  ᪠.
  //  ⢥  ᯮ㥬 ࠧ, 祭
  //   ப.  ᪠ ᯮ㥬 䠩  묨
  // ਡ⠬
  if(!_dos_findfirst(argv[1], 0xffff, &find))
  {
    printf("\n"
     "\n 䠩    .         ६     "
     "\n------------ ----- ----------  --------  ------");

    // 뢮 ଠ  ࢮ  䠩  ࠭
    print_info(&find);
  }
  else
  {
    printf(" ࠧ  ᪠ 䠩 !");
    return(-1);
  }

  // 뢮 ଠ  ⠫  䠩
  while(!_dos_findnext(&find)) print_info( &find );
  return(0);
}

// 㭪  뢮 ଠ樨   䠩
void print_info(struct find_t *pfind)
{
  char timebuf[10], datebuf[12];

  // ८ࠧ㥬 ଠ   ६ ᫥  䠩
  date_conv(pfind->wr_date, datebuf);
  time_conv(pfind->wr_time, timebuf);

  // 뢮 ᮤন ਯ 䠩
  printf("\n%-12s",pfind->name);
  printf(" %02X    %8s  %8s %8ld ",
    pfind->attrib, datebuf, timebuf, pfind->size);
}

// 㭪 ८ࠧ ଠ ६
char *time_conv(unsigned t, char *buf)
{
  int h, m;

  h = (t >> 11) & 0x1f;
  m = (t >> 5) & 0x3f;
  sprintf(buf, "%2.2d:%02.2d:%02.2d",
    h, m, (t & 0x1f) * 2);
  return buf;
}

// 㭪 ८ࠧ ଠ 
char *date_conv(unsigned d, char *buf)
{
  sprintf(buf, "%2.2d.%02.2d.%04.2d",
    d & 0x1f,(d >> 5) & 0x0f, (d >> 9) + 1980);
  return buf;
}
