#include <io.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <dos.h>

union REGS inregs, outregs;
struct SREGS segregs;

int main(void)
{
  char buf[100];
  int io_handle;

  // 뢠 ன⢮   IODRIVER
  if((io_handle = open("IODRIVER", O_RDWR)) == - 1)
  {
    // ᫨   㤠, 뢮  訡
    printf("Open: 訡 %d", errno);
    return errno;
  }

  // ⠥ 8   ன⢠   buf
  if(read(io_handle, buf, 8) == -1)
  {
    // ᫨  ⥭ ந諠 訡,
    // 뢮  
    printf("Read: 訡 %d", errno);
    return errno;
  }

  // 뢠 ⠭ ப 㫥
  //  ᫥饣 뢮 㭪樥 printf
  buf[8] = 0;
  printf("\n⠭ ப: <%s>", buf);

  // 뢮 ⮫쪮  ⠭ 
  // ⭮    ன⢮

  if(write(io_handle, buf, 8) == -1)
  {
    // ᫨   ந諠 訡,
    // 뢮  
    printf("Write: 訡 %d", errno);
    return errno;
  }

  // 砥 ଠ  ன⢥
  inregs.h.ah = 0x44;
  inregs.h.al = 0;
  inregs.x.bx = io_handle;
  intdos( &inregs, &outregs );
  if(outregs.x.cflag == 1)
  {
    //  訡 뢮  
    printf("IOCTL: 訡 %x\n", &outregs.x.ax);
    return(-1);
  }

  // 뢮 䨣 ன⢠  ࠭
  printf("\n䨣 ன⢠:  %04X\n",
     outregs.x.dx);

  // ⠭  5 (४砥 ࠩ
  //   ०  묨
  inregs.x.dx = (outregs.x.dx | 0x0020) & 0x00ff;

  // ⠭ 䨣 ன⢠
  inregs.h.ah = 0x44;
  inregs.h.al = 1;
  inregs.x.bx = io_handle;
  intdos(&inregs, &outregs);
  if(outregs.x.cflag == 1)
  {
    // 뢮  訡
    printf("IOCTL: 訡 %x\n",&outregs.x.ax);
    return(-1);
  }

  // 뢮 䨣 ன⢠
  printf("\n䨣 ன⢠:  %04X\n",
    outregs.x.dx);

  // ⠥ 8   ன⢠   buf
  //   믮  筮 ०
  if(read(io_handle, buf, 8) == -1)
  {
    // ᫨  ⥭ ந諠 訡,
    // 뢮  
    printf("Read: 訡 %d",errno);
    return errno;
  }

  // 뢠 ⠭ ப 㫥
  //  ᫥饣 뢮 㭪樥 printf
  buf[8] = 0;

  printf("\n⠭ ப: <%s>", buf);

  // 뢮 ⮫쪮  ⠭ 
  // ⭮    ன⢮
  if(write(io_handle, buf, 8) == -1)
  {
    // ᫨   ந諠 訡,
    // 뢮  
    printf("Write: 訡 %d", errno);
    return errno;
  }

  // 뢠 ன⢮
  close(io_handle);

  return(0);
}

