#include <io.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <dos.h>

union REGS inregs, outregs;
struct SREGS segregs;

int main(void)
{
  int io_handle;

  struct
  {
    unsigned days;
    unsigned char min;
    unsigned char hours;
    unsigned char sec_per_100;
    unsigned char sec;
  } clock_buf;

  // 뢠 ன⢮   CLOCK$
  if((io_handle = open("CLOCK$", O_RDWR)) == - 1)
  {
    // ᫨  ன⢮  㤠, 뢮
    //  訡
    printf("Open: 訡 %d", errno);
    return errno;
  }

  // ।塞 䨣 ன⢠
  inregs.h.ah = 0x44;
  inregs.h.al = 0;
  inregs.x.bx = io_handle;
  intdos(&inregs, &outregs);

  if(outregs.x.cflag == 1)
  {
    //   訡 뢮  
    printf("IOCTL: 訡 %x\n", &outregs.x.ax);
    return(-1);
  }

  // ⠭  5 (४砥 ࠩ
  //   ०  묨)
  inregs.x.dx = (outregs.x.dx | 0x0020) & 0x00ff;

  // ⠭ ᫮ 䨣樨 ன⢠
  inregs.h.ah = 0x44;
  inregs.h.al = 1;
  inregs.x.bx = io_handle;
  intdos( &inregs, &outregs );

  if(outregs.x.cflag == 1)
  {
    //   訡 뢮  
    printf("IOCTL: 訡 %x\n", &outregs.x.ax);
    return(-1);
  }

  // 뢮 ᫮ 䨣樨 ன⢠
  printf("\n䨣 ன⢠:  %04X\n",
     outregs.x.dx);

  // ⠥ 6   ன⢠   buf
  //  믮  筮 ०
  if(read(io_handle, &clock_buf, 6) == -1)
  {
    // ᫨  ⥭ ந諠 訡,
    // 뢮  
    printf("Read: 訡 %d",errno);
    return errno;
  }

  printf("\n祭  ࠩ ᮢ CLOCK$:"
   "\n"
   "\n諮  ᫥ 01.01.80:  %d"
   "\n:                      %d"
   "\n:                        %d"
   "\n㭤:                     %d"
   "\n  ᥪ㭤:          %d"
   "\n",
   clock_buf.days, clock_buf.min, clock_buf.hours,
   clock_buf.sec,  clock_buf.sec_per_100);

   // 뢠 ன⢮
   close(io_handle);

   return(0);
}

