#include <stdio.h>
#include <conio.h>
#include <dos.h>

// ᠭ 㭪権
void	main(void);
int	SetPowerState( unsigned char );
int	GetPowerState( unsigned char* );
int	PowerCapabilities( unsigned char*, unsigned char*, unsigned char*);
int	AnalyseResult(union REGS);

#define ON	0x00
#define OFF	0x04
#define STANDBY	0x01
#define SUSPEND	0x02
#define REDUCED	0x08

//======================================================================
//  㭪
//======================================================================
void main(void) {

	int 	uiResult;
	unsigned char 	ucMode, ucModes,
						ucMinorVer, ucMajorVer;

	// ।塞  ࠢ ࣮ॡ
	uiResult = PowerCapabilities( &ucModes, &ucMajorVer, &ucMinorVer );

	printf("\n\n Copyright (C)Frolov G.V.,1995. E-mail: frolov@glas.apc.org\n");

	if(uiResult==0) {
		printf("\n  VBE Power Management %d.%d",
				(int)ucMajorVer, (int)ucMinorVer );

		printf("\n ন ०:\n"
				"STANDBY - %s\n"
				"SUSPEND - %s\n"
				"OFF - %s\n"
				"REDUCED - %s\n",
				(ucModes & STANDBY)?	"" : "",
				(ucModes & SUSPEND)?	"" : "",
				(ucModes & OFF)?		"" : "",
				(ucModes & REDUCED)?	"" : ""
		);
	}

	else if(uiResult < 0) {
		printf("\n  ࠢ ࣮ॡ  ন" );
		return;
	}

	else if(uiResult > 0) {
		printf("\n 訡  맮 㭪樨 VBE Power Management" );
		return;
	}

	// ।塞 ⥪騩 ०
	uiResult = GetPowerState( &ucMode );
	printf("\n 㭪 GetPowerState 頥 %d", uiResult );
	printf("\n GetPowerState = %x", ucMode );

	printf("\n 騩 ०: %s\n",
		(ucMode & STANDBY)	?	"STANDBY" :
		(ucMode & SUSPEND)	?	"SUSPEND" :
		(ucMode & OFF)			?	"OFF" :
		(ucMode & REDUCED)	?	"REDUCED" : "।"
	);

	printf("\n\n ᫥    ᨬ ࠦ (० STANDBY)"
			 "\n  த ࠡ   "	);

	//  ⨥  
	getch();

	// ᨬ ࠭ 
	uiResult = SetPowerState( STANDBY );
	printf("\n 㭪 SetPowerState( STANDBY ) 頥 %d", uiResult );

	//  ⨥  
	getch();

	// 砥 
	uiResult = SetPowerState( ON );
	printf("\n 㭪 SetPowerState( ON ) 頥 %d", uiResult );

	return;
}

//=================================================
// 㭪 SetPowerState
// ⠭ ०   
//=================================================
int
SetPowerState( unsigned char ucMode )
{
	union REGS regs;
	int	iResult;

	regs.h.ah = 0x4f;
	regs.h.al = 0x10;
	regs.h.bl = 0x01;
	regs.h.bh = ucMode;
	int86(0x10, &regs, &regs);

	iResult = AnalyseResult(regs);

	return iResult;
}

//=================================================
// 㭪 GetPowerState
// । ⥪騩 ० 
//=================================================
int
GetPowerState( unsigned char *ucMode )
{
	union REGS regs;
	int	iResult;

	regs.h.ah = 0x4f;
	regs.h.al = 0x10;
	regs.h.bl = 0x02;

	int86(0x10, &regs, &regs);

	*ucMode = regs.h.bh;

	iResult = AnalyseResult(regs);

	return iResult;
}

//=================================================
// 㭪 PowerCapabilities
// ।  ⥬
//=================================================
int
PowerCapabilities( unsigned char *ucModes,
						 unsigned char *ucMajorVer,
						 unsigned char *ucMinorVer)
{
	union REGS regs;
	struct SREGS segregs;
	int	iResult;

	regs.h.ah = 0x4f;
	regs.h.al = 0x10;
	regs.h.bl = 0x00;

	segregs.es = 0x00;
	regs.x.di = 0x00;

	int86x(0x10, &regs, &regs, &segregs);

	*ucModes = regs.h.bh;
	*ucMinorVer = regs.h.bl & 0x0F; // 訩
	*ucMajorVer = (regs.h.bl & 0xF0) >> 4; // 訩

	iResult = AnalyseResult(regs);

	return iResult;
}

//=================================================
// 㭪 AnalyseResult
//  १, 頥 㭪ﬨ
// Power VBE
//=================================================
int
AnalyseResult(union REGS regs)
{
	int	iResult;

	// 㭪 VBE Power Management 訫 ᯥ譮
	if((regs.h.al == 0x4f) && (regs.h.ah == 0))
		iResult = 0;

	//
	else if(regs.h.al != 0x4f)
		iResult = -1;

	//
	else
		iResult = 1;

	return iResult;
}
