//	ଠ  VBE  
typedef struct
{
	// ন ᥬ ﬨ VBE
	char						cSignature[4];
	unsigned short			usVersion;
	char far 				*fpInfoOEM;
	unsigned char			ucCapabilities[4];
	unsigned short	far 	*fpModeTable;

	// ন VBE ᨨ 1.2
	unsigned short	usTotalMemory;

	// ন VBE ᨨ 2.0
	unsigned short	usRevVersion;
	char far 		*fpOEMName;
	char far			*fpOEMProductName;
	char far			*fpOEMRevVersion;
	char				cReserv[222];
	char				cOEMData[256];
}	VESAINFO;

// ࠪ⨪ ० 
typedef struct
{
	unsigned short	usModeAttr;
	unsigned char	ucWinAAttr;
	unsigned char	ucWinBAttr;
	unsigned short	usWinGranularity;
	unsigned short	usWinSize;
	unsigned short	usBegSegA;
	unsigned short	usBegSegB;
	void far			*fpWinFunc;
	unsigned short	usBytesPerScanLine;

	// ন VBE ᨨ 1.2
	unsigned short	usSizeX;
	unsigned short	usSizeY;
	unsigned char	ucCharSizeX;
	unsigned char	ucCharSizeY;
	unsigned char	ucNumPlanes;
	unsigned char	ucNumPixelBits;
	unsigned char	ucBanksNum;
	unsigned char	ucTypeMemModel;
	unsigned char	ucBankSize;
	unsigned char	ucPageNum;
	unsigned char	ucReserv1;

	unsigned char	ucRedSize;
	unsigned char	ucRedField;
	unsigned char	ucGreenSize;
	unsigned char	ucGreenField;
	unsigned char	ucBlueSize;
	unsigned char	ucBlueField;
	unsigned char	ucResSize;
	unsigned char	ucResField;

	unsigned char	ucDACInfo;

	// ন VBE ᨨ 2.0
	unsigned char far	*VideoBuff;
	unsigned char far	*ScrOffset;
	unsigned short		usScrSize;
	unsigned char		ucReserv2[206];
}	VESAMODEINFO;

/* video state parameters */
typedef struct
{
	unsigned short	usMode;	    /* 16-bit video mode number */
	unsigned short	ussegVBuf;	    /* display start segment */
	unsigned short	usofsVBuf;	    /* display start offset */
	unsigned short	usPPB;	    /* pixels per byte */
	unsigned short	uscbRow;	    /* bytes per logical row */
	unsigned short	usCX;	    /* logical buffer dimensions */
	unsigned short	usCY;
	unsigned short	usSX;	    /* screen dimensions */
	unsigned short	usSY;
	unsigned short	usX;	    /* logical pixel origin */
	unsigned short	usY;
	unsigned short	usofsXY;	    /* byte offset of origin pixel */
	unsigned short	usVNSkip;	    /* skip count for vert nondisplay timer */
	unsigned char	ucBPP;	    /* bits per pixel */
	unsigned char	ucRMW;	    /* Graphics Controller raster op bits */
}	VIDEOSTATEPARAMS;
