#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include "vesa.h"

// ᠭ 㭪権
int	main( int argc, char * argv[] );
int	GetBaseVESAInfo(FILE*);
int	AnalyseResult(union REGS);

//  㭪
int main( int argc, char * argv[] )
{
	FILE	*fileVesaReport;
	int   iResult;

	// ஢ઠ  ப ணࠬ
	if( argc != 2 )
	{
		printf("\nଠ 맮: VESATEST < 䠩>"
			 "\n  < 䠩>:  䠩,   㤥 ᠭ ଠ");

		return -1;
	}

	// 뢠 䠩
	fileVesaReport = fopen(argv[1], "w+");

	// 뢠  䠩 fileVesaReport ଠ  VBE  
	iResult = GetBaseVESAInfo(fileVesaReport);

	// 뢠 䠩
	fclose(fileVesaReport);

	return ((iResult==0) ? 0 : -1);
}

//=================================================
// 㭪 GetBaseVESAInfo
//=================================================
int
GetBaseVESAInfo(FILE *file)
{
	union REGS regs;
	struct SREGS segregs;
	int	iResult, i;

	//   祭 ଠ樨  VBE
	VESAINFO			vesaInfo;
	VESAMODEINFO	modeInfo;

	// ⠢   VBE ᨨ 2.0
	strcpy( vesaInfo.cSignature, "VBE2" );

	// 砥   ॠ樨 VBE  
	regs.h.ah = 0x4f;
	regs.h.al = 0x00;
	segregs.es = FP_SEG((void far *)&vesaInfo);
	regs.x.di = FP_OFF((void far *)&vesaInfo);
	int86x(0x10, &regs, &regs, &segregs);

	// ஢塞 १ 맮 㭪樨 VBE
	iResult = AnalyseResult(regs);
	if(iResult != 0) return -1;

	// 뢠  䠩 ଠ   vesaInfo
	fprintf(file, ": '%4.4s' \n", vesaInfo.cSignature );
	fprintf(file, "ଠ  ந⥫: '%s'\n", vesaInfo.fpInfoOEM );

	fprintf(file, " VBE: %Xh \n", vesaInfo.usVersion);

	fprintf(file, " : '%x%x%x%x' \n",
		vesaInfo.ucCapabilities[0], vesaInfo.ucCapabilities[1],
		vesaInfo.ucCapabilities[2], vesaInfo.ucCapabilities[3]);

	fprintf(file, "ন ᫥騥 ० VESA: \n");

	 for( i=0; i<50; i++ )	 {
		if(vesaInfo.fpModeTable[i] == 0xFFFF)	break;
		fprintf(file,  "   %Xh \n", vesaInfo.fpModeTable[i] );
	 }

	// ꥬ  । VBE ᨨ   1.2
	if( vesaInfo.usVersion >= 0x102 )
		fprintf(file,  "ꥬ  %d \n", vesaInfo.usTotalMemory * 64);

	//  ଠ 㯭 ⮫쪮  VBE ᨨ 2.0  
	if( vesaInfo.usVersion >= 0x200 )
	{
		fprintf(file,  "⥫  ᨨ VBE: %04Xh\n",
			vesaInfo.usRevVersion);
		fprintf(file, "⥫  ᨨ : '%s'\n",
			vesaInfo.fpOEMRevVersion);
		fprintf(file, "  ࠧࠡ稪: '%s'\n", vesaInfo.fpOEMName);
		fprintf(file, " : '%s'\n", vesaInfo.fpOEMProductName);
	}

	//  砥 ଠ   㯭 ० VESA
	for( i=0; i<50; i++ )	 {

		// 砥 ।  ० VESA
		if(vesaInfo.fpModeTable[i] == 0xFFFF)	break;
		fprintf(file,  "\n\n %Xh \n", vesaInfo.fpModeTable[i] );

		// 砥 ଠ  ० vesaInfo.fpModeTable[i]
		regs.h.ah = 0x4f;
		regs.h.al = 0x01;
		regs.x.cx = vesaInfo.fpModeTable[i];
		segregs.es = FP_SEG((void far *)&modeInfo);
		regs.x.di = FP_OFF((void far *)&modeInfo);
		int86x(0x10, &regs, &regs, &segregs);

		// ஢塞 १ 맮 㭪樨 VBE
		iResult = AnalyseResult(regs);
		if(iResult != 0) return -1;

		// 뢠  䠩 ଠ   modeInfo
		fprintf(file, "ਡ ०: %04Xh \n", modeInfo.usModeAttr);
		fprintf(file, "ਡ : A %02Xh \n", modeInfo.ucWinAAttr);
		fprintf(file, "ਡ : B %02Xh \n", modeInfo.ucWinBAttr);
		fprintf(file, " 樮஢ : %d  \n", modeInfo.usWinGranularity);
		fprintf(file, " , : %d  \n", modeInfo.usWinSize );
		fprintf(file, "砫 ᥣ  A: %04Xh \n", modeInfo.usBegSegA );
		fprintf(file, "砫 ᥣ  B: %04Xh \n", modeInfo.usBegSegB );
		fprintf(file, "㭪 ६饭 : %p \n", modeInfo.fpWinFunc );
		fprintf(file, "⢮    ᪠஢: %d \n",
			modeInfo.usBytesPerScanLine );

		// ꥬ  । VBE ᨨ   1.2
//		if(vesaInfo.usVersion >= 0x102)
		if(1)
		{
			fprintf(file,  "襭  ਧ⠫: %d \n", modeInfo.usSizeX);
			fprintf(file,  "襭  ⨪: %d \n", modeInfo.usSizeY);
			fprintf(file,  "ਭ ᨬ:  %02Xh \n", modeInfo.ucCharSizeX);
			fprintf(file,  " ᨬ: %02Xh \n", modeInfo.ucCharSizeY);
			fprintf(file,  "⢮ ᫮ : %02Xh \n", modeInfo.ucNumPlanes);
			fprintf(file,  "⢮   ᥫ: %02Xh \n", modeInfo.ucNumPixelBits);
			fprintf(file,  "⢮  : %02Xh \n", modeInfo.ucBanksNum);
			fprintf(file,  "  : %02Xh \n", modeInfo.ucTypeMemModel);
			fprintf(file,  "  : %02Xh \n", modeInfo.ucBankSize);

			fprintf(file,  "⢮ 㯭 ࠭ : %02Xh \n",
				modeInfo.ucPageNum);

			fprintf(file,  "  ᭮  梥: %02Xh \n",
				modeInfo.ucRedSize);
			fprintf(file,  " ᭮ : %02Xh \n",
				modeInfo.ucRedField);
			fprintf(file,  "    梥 ᥫ: %02Xh \n",
				modeInfo.ucGreenSize);
			fprintf(file,  "  : %02Xh \n",
				modeInfo.ucGreenField);
			fprintf(file,  "  ᨭ  梥 ᥫ: %02Xh \n",
				modeInfo.ucBlueSize);
			fprintf(file,  " ᨭ : %02Xh \n",
				modeInfo.ucBlueField);
			fprintf(file,  " १ࢭ : %02Xh \n",
				modeInfo.ucResSize);
			fprintf(file,  " १ࢭ : %02Xh \n",
				modeInfo.ucResField);
			fprintf(file,  " : %02X\n", modeInfo.ucDACInfo);
		}
	}
	return iResult;
}


//=================================================
// 㭪 AnalyseResult
//=================================================
int
AnalyseResult(union REGS regs)
{
	int	iResult;

	if((regs.h.al == 0x4f) && (regs.h.ah == 0))
		iResult = 0;
	else if(regs.h.al != 0x4f)
		iResult = -1;
	else
		iResult = 1;

	return iResult;
}
