// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include "button.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

// 䨪 
HWND hWndButton1;
HWND hWndButton2;

CHAR szAppTitle[] = "Button Demo";

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "BTNDEMO";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS hps;
  RECTL rec;

  switch (msg)
  {
    //   
    case WM_CREATE:
    {
      hWndButton1 = WinCreateWindow(hWnd, WC_BUTTON,
        " 1", WS_VISIBLE | BS_PUSHBUTTON,
        0, 0, 0, 0,
        hWnd, HWND_TOP, BTN1_ID, NULL, NULL);

      hWndButton2 = WinCreateWindow(hWnd, WC_BUTTON,
        " 2", WS_VISIBLE | BS_PUSHBUTTON,
        0, 0, 0, 0,
        hWnd, HWND_TOP, BTN2_ID, NULL, NULL);

      return FALSE;
    }

    // 塞 ࠧ  ᯮ 
    case WM_SIZE:
    {
      WinSetWindowPos(hWndButton1, HWND_TOP,
      10, 10, 200, 50, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      WinSetWindowPos(hWndButton2, HWND_TOP,
      10, 70, 200, 50, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      // ᮢ뢠  ਫ
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // 訢 , ॡ 
      WinFillRect(hps, &rec, CLR_WHITE);

      // 頥 ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //  ᮮ饭 㯠  㭪 ,
    //  짮⥫    
    // 
    case WM_COMMAND:
    {
      switch (COMMANDMSG(&msg) -> cmd)
      {
        case BTN1_ID:
        {
          WinMessageBox(HWND_DESKTOP, hWnd,
           "  1",
           "饭", 0,
           MB_INFORMATION | MB_APPLMODAL |
             MB_MOVEABLE | MB_OK);
          break;
        }

        case BTN2_ID:
        {
          WinMessageBox(HWND_DESKTOP, hWnd,
           "  2",
           "饭", 0,
           MB_INFORMATION | MB_APPLMODAL |
             MB_MOVEABLE | MB_OK);
          break;
        }
        default:
          break;
      }
      return 0;
    }
    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

