// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <stdio.h>
#include "check.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

// 䨪 
HWND hWndButton1;
HWND hWndButton2;
HWND hWndButton3;

// ﭨ ४⥫
BOOL fButton2Checked = FALSE;
BOOL fButton3Checked = FALSE;

CHAR szAppTitle[] = "CheckBox Demo";

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "BTNDEMO";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS hps;
  RECTL rec;
  CHAR szBuf[256];

  switch (msg)
  {
    //     ४⥫
    case WM_CREATE:
    {
      hWndButton1 = WinCreateWindow(hWnd, WC_BUTTON,
        "४⥫", WS_VISIBLE | BS_PUSHBUTTON,
        0, 0, 0, 0,
        hWnd, HWND_TOP, BTN1_ID, NULL, NULL);

      // ⮬᪨ ४⥫
      hWndButton2 = WinCreateWindow(hWnd, WC_BUTTON,
        "(2) AutoCheckBox", WS_VISIBLE | BS_AUTOCHECKBOX,
        0, 0, 0, 0,
        hWnd, HWND_TOP, BTN2_ID, NULL, NULL);

      //  ४⥫
      hWndButton3 = WinCreateWindow(hWnd, WC_BUTTON,
        "(3) CheckBox", WS_VISIBLE | BS_CHECKBOX,
        0, 0, 0, 0,
        hWnd, HWND_TOP, BTN3_ID, NULL, NULL);
      return FALSE;
    }

    // 塞 ࠧ  ᯮ ࣠ ࠢ
    case WM_SIZE:
    {
      WinSetWindowPos(hWndButton1, HWND_TOP,
      10, 10, 200, 50, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      WinSetWindowPos(hWndButton2, HWND_TOP,
      10, 70, 200, 50, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      WinSetWindowPos(hWndButton3, HWND_TOP,
      10, 110, 200, 50, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      // ᮢ뢠  ਫ
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // 訢 , ॡ 
      WinFillRect(hps, &rec, CLR_WHITE);

      // 頥 ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //  ᮮ饭 室  
    // ﭨ ४⥫
    case WM_CONTROL:
    {
      switch (SHORT1FROMMP(mp1))
      {
        // ᫨ ᮮ饭 諮  ⮬᪮
        // ४⥫, 砥  ࠭塞 
        // ⥪饥 ﭨ
        case BTN2_ID:
        {
          fButton2Checked = (BOOL)WinSendMsg(hWndButton2,
            BM_QUERYCHECK, MPFROMSHORT(0), NULL);
          break;
        }

        // ᫨ ᮮ饭 諮  筮 ४⥫,
        // 塞  ﭨ  ࠭塞 
        // ﭨ  ६ fButton3Checked
        case BTN3_ID:
        {
          if(fButton3Checked)
            WinSendMsg(hWndButton3, BM_SETCHECK,
              MPFROMSHORT(0), NULL);

          else
            WinSendMsg(hWndButton3, BM_SETCHECK,
              MPFROMSHORT(1), NULL);

          fButton3Checked = ~fButton3Checked;
          break;
        }

        default:
          break;
      }
      return 0;
    }

    //  짮⥫  ,
    // ।塞  ࠭塞 ﭨ
    //  ४⥫
    case WM_COMMAND:
    {
      switch (COMMANDMSG(&msg) -> cmd)
      {
        case BTN1_ID:
        {
          sprintf(szBuf, "ﭨ ४⠫:\n"
            "(3) ⨩ - %d\n(2) ன - %d",
            fButton3Checked ? 1 : 0,
            fButton2Checked ? 1 : 0);


          WinMessageBox(HWND_DESKTOP, hWnd, szBuf,
           "ﭨ ४⥫", 0,
           MB_INFORMATION | MB_APPLMODAL |
             MB_MOVEABLE | MB_OK);
          break;
        }

        default:
          break;
      }
      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

