// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <string.h>
#include <stdio.h>
#include "clock.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "Clock Application";

// न     
//   
SHORT cxPoint;
SHORT cyPoint;

// न     ᪠
//   
SHORT cxNewPoint;
SHORT cyNewPoint;

// ਧ 砫  ६饭 
BOOL  fDrag = FALSE;

// 䨪 㪠⥫ 
HPOINTER hptr, hptr1;

//  ᨬ ࠭ 
SHORT cxChar, cyChar, cyDesc;

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;
  FONTMETRICS fm;
  HPS hps;

  //   ᮧ  Frame Window.
  //    ࠣ ࠢ 
  // ࠬ   ࠧ஢
  ULONG flFrameFlags = FCF_TASKLIST | FCF_ICON;

  //    
  CHAR  szWndClass[] = "TIMERBEEP";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // 砥 ࠭⢮ ⮡ࠦ
  hps = WinGetPS(hWndFrame);

  // 롨ࠥ  ࠭⢮ ⮡ࠦ 
  //  䨪஢ ਭ ᨬ
  SetCourierFont(hps);

  // ।塞 ਪ 
  GpiQueryFontMetrics(hps, (LONG)sizeof(fm), &fm);

  cxChar = fm.lAveCharWidth;
  cyChar = fm.lMaxBaselineExt;
  cyDesc = fm.lMaxDescender;

  // ⠭ , ࠭  ࠭⢮
  // ⮡ࠦ  㬮砭
  ResetFont(hps);

  // 頥 ࠭⢮ ⮡ࠦ
  WinReleasePS(hps);

  // ⠭  ࠧ  ᯮ
  //   ਫ
  WinSetWindowPos(hWndFrame, HWND_TOP,
    0, 0, 10 * cxChar, cyChar + cyDesc,
    SWP_SIZE | SWP_MOVE | SWP_ZORDER);

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS   hps;
  RECTL rec;
  SWP   swp;
  CHAR  pszBuf[256];
  DATETIME dt;

  switch (msg)
  {
    case WM_CREATE:
    {
      // ᪠ ⠩  ࢠ 1000 
      WinStartTimer(hab, hWnd, ID_APP_TIMER, 1000);

      // 㦠 䨪 ஢ 
      hptr  = WinLoadPointer(HWND_DESKTOP,
        NULLHANDLE, ID_APP_POINTER);

      hptr1 = WinLoadPointer(HWND_DESKTOP,
        NULLHANDLE, ID_APP_POINTER1);

      return FALSE;
    }

    case WM_DESTROY:
    {
      // ⠭ ⠩
      WinStopTimer(hab, hWnd, ID_APP_TIMER);

      // 塞  
      WinDestroyPointer(hptr);
      WinDestroyPointer(hptr1);
      return 0;
    }

    //  室 ᮮ饭  ⠩,
    // ᮢ뢠   ਫ
    case WM_TIMER:
    {
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // ।塞 ࠧ  
      WinQueryWindowRect(hWnd, &rec);

      // ।塞   ६
      DosGetDateTime(&dt);

      sprintf(pszBuf, "%02d:%02d:%02d",
        dt.hours, dt.minutes, dt.seconds);

      // ⠭   ⮡ࠦ
      SetCourierFont(hps);

      // 뢮 ⥪  業 
      WinDrawText(hps, -1, pszBuf, &rec, 0L, 0L,
        DT_WORDBREAK | DT_CENTER | DT_VCENTER |
        DT_TEXTATTRS | DT_ERASERECT);

      // ⠭ 
      ResetFont(hps);

      // ᢮ ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //  짮⥫   
    // ,  न  
    // 뤢  ਫ  । 
    case WM_BUTTON1DOWN:
    {
      cxPoint = MOUSEMSG(&msg) -> x;
      cyPoint = MOUSEMSG(&msg) -> y;

      // 塞 ᯮ    Z
      WinSetWindowPos(hWndFrame, HWND_TOP,
        0, 0, 0, 0, SWP_ZORDER);

      // ⠭ ਧ ६饭
      //   ਫ
      fDrag = TRUE;

      // 墠뢠 
      WinSetCapture(HWND_DESKTOP, hWnd);
      return 0;
    }

    //  ᪠    뢠
    // ਧ ६饭 
    case WM_BUTTON1UP:
    {
      // 뢠 ਧ ६饭
      //   ਫ
      fDrag = FALSE;

      // ᢮ 
      WinSetCapture(HWND_DESKTOP, NULLHANDLE);
      return 0;
    }

    //  ᮮ饭 室  ६饭 
    // .
    case WM_MOUSEMOVE:
    {
      // ᫨ 祭 ਧ ६饭, ।塞
      //  न   । 
      if(fDrag)
      {
        // 롨ࠥ 㪠⥫   ⮩ 㪨
        WinSetPointer(HWND_DESKTOP, hptr1);

        cxNewPoint = MOUSEMSG(&msg) -> x;
        cyNewPoint = MOUSEMSG(&msg) -> y;

        // ।塞 ⥪騥 न 
        WinQueryWindowPos(hWndFrame, &swp);

        // । 
        WinSetWindowPos(hWndFrame, HWND_TOP,
          swp.x + (cxNewPoint - cxPoint),
          swp.y + (cyNewPoint - cyPoint),
          0, 0, SWP_MOVE);
      }

      else
        // 롨ࠥ 㪠⥫   ⮩ 㪨
        WinSetPointer(HWND_DESKTOP, hptr);

      return (MRESULT)TRUE;
    }

    // ᫨ 짮⥫ ᤥ  饫箪 
    //  , 蠥 ࠡ ਫ
    case WM_BUTTON1DBLCLK:
    {
      WinPostMsg(hWnd, WM_QUIT, 0L, 0L);
      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

// =================================================
// 롮   䨪஢ ਭ ᨬ
// =================================================

void SetCourierFont(HPS hps)
{
  FATTRS fat;

  // 塞  ᠭ 㦭
  //  
  fat.usRecordLength = sizeof(FATTRS);
  strcpy(fat.szFacename ,"Courier");
  fat.fsSelection = 0;
  fat.lMatch = 0L;
  fat.idRegistry = 0;
  fat.usCodePage = 850;
  fat.lMaxBaselineExt = 12L;
  fat.lAveCharWidth = 12L;
  fat.fsType = 0;
  fat.fsFontUse = FATTR_FONTUSE_NOMIX;

  //  ᪨ , 騩 䨪 1L
  GpiCreateLogFont(hps, NULL, 1L, &fat);

  // 롨ࠥ ᮧ   ࠭⢮ ⮡ࠦ
  GpiSetCharSet(hps, 1L);
}

// =================================================
// ⠭ , ࠭  ࠭⢮
// ⮡ࠦ  㬮砭
// =================================================
void ResetFont(HPS hps)
{
  GpiSetCharSet(hps, LCID_DEFAULT);
  GpiDeleteSetId(hps, 1L);
}


