// =====================================================
// ।
// =====================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS

#include <os2.h>
#include <stdio.h>
#include "menuapp.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =====================================================
//  ६
// =====================================================

// 䨪 Anchor-block
HAB  hab;

// 䨪  Frame Window
HWND hWndFrame;

// 䨪  Client Window
HWND hWndClient;

//  ਫ
CHAR szAppTitle[] = "Menu Demo Application";

// 䨪 ६ 
HWND    hwndPopupMenu;

// =====================================================
//  㭪 ਫ main
// =====================================================

int main()
{
  // 䨪 । ᮮ饭
  HMQ   hmq;

  // ,   뢠 ᮮ饭,
  // 祭  ।
  QMSG  qmsg;

  // ६  ࠭  
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON | FCF_MENU;

  //    
  CHAR  szWndClass[] = "MENUDEMO";

  // 樠 ਫ, 室  ᯮ짮
  // 㭪権 Presentation Manager
  hab = WinInitialize(0);

  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);

  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass, (PFNWP)WndProc, 0, 0);

  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP, WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);

  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  // ⮦   ਫ
  WinDestroyWindow(hWndFrame);

  // 塞 । ᮮ饭  뢠
  // 㭪 WinTerminate
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);

  // 頥 ࠢ 樮 ⥬
  return(0);
}

// =====================================================
// 㭪   ਫ
// =====================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  // ६   ⮢ ᮮ饭
  CHAR szMsg[100];

  USHORT  usItemId; // 䨪 
  HWND    hwndMenu; // 䨪  

  switch (msg)
  {
    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    // 믮塞 樠   ਫ
    case WM_INITMENU:
    {
      // 䨪 
      usItemId = SHORT1FROMMP(mp1);

      // 䨪  
      hwndMenu = HWNDFROMMP(mp2);

      //   File 㥬 ப New  Open
      if(usItemId == IDM_FILE)
      {
        WinEnableMenuItem(hwndMenu, IDM_FILE_NEW,  FALSE);
        WinEnableMenuItem(hwndMenu, IDM_FILE_OPEN, FALSE);
      }

      //   Edit 㥬 ப Undo  Redo
      else if(usItemId == IDM_EDIT)
      {
        WinEnableMenuItem(hwndMenu, IDM_EDIT_UNDO, FALSE);
        WinEnableMenuItem(hwndMenu, IDM_EDIT_REDO, FALSE);
      }
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
    }

    // 饭 WM_COMMAND 㯠  㭪 ,
    //  짮⥫ 롨ࠥ   ப 
    case WM_COMMAND:
    {
      // 㥬  ப 
      switch(LOUSHORT(mp1))
      {
        case IDM_FILE_NEW:
        case IDM_FILE_OPEN:
        case IDM_FILE_SAVE:
        case IDM_FILE_SAVEAS:

        case IDM_EDIT_UNDO:
        case IDM_EDIT_REDO:
        case IDM_EDIT_CUT:
        case IDM_EDIT_COPY:
        case IDM_EDIT_PASTE:
        case IDM_EDIT_CLEAR:
        case IDM_EDIT_DUPLICATE:
        case IDM_EDIT_SELECTALL:

        case IDM_OPTIONS_FONT_NORMAL:
        case IDM_OPTIONS_FONT_BOLD:
        case IDM_OPTIONS_FONT_ITALIC:
        case IDM_OPTIONS_FONT_UNDERLINE:
        case IDM_OPTIONS_PARA_LEFT:
        case IDM_OPTIONS_PARA_CENTER:
        case IDM_OPTIONS_PARA_RIGHT:
        case IDM_OPTIONS_PARA_JUSTIFY:

        case IDM_HELP_INDEX:
        case IDM_HELP_GENERAL:
        case IDM_HELP_USING:
        case IDM_HELP_KEYS:
        {
           WinMessageBox(HWND_DESKTOP, hWnd,
             "㭪  ॠ",
             szAppTitle, 0, MB_INFORMATION | MB_OK);
          break;
        }

        case IDM_HELP_ABOUT:
        {
           WinMessageBox(HWND_DESKTOP, hWnd,
             "ਫ MenuApp, (C) Frolov A., 1996",
             szAppTitle, 0, MB_INFORMATION | MB_OK);
          break;
        }

        // ᫨   File ࠭ ப Exit,
        // 蠥 ࠡ ਫ
        case IDM_FILE_EXIT:
        {
           WinPostMsg(hWnd, WM_QUIT, 0L, 0L);
           break;
        }
      }
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));

    }

    //   樠樨   ਫ
    // 㦠 ६   ।塞 䨪
    //  
    case WM_CREATE:
    {
      hwndPopupMenu = WinLoadMenu(hWnd,
        NULLHANDLE, POPUP_MENU);
      return FALSE;
    }

    // । 㭨⮦   ਫ
    // 㭨⮦  ६ 
    case WM_DESTROY:
    {
      WinDestroyWindow(hwndPopupMenu);
      break;
    }

    // ᫨ 짮⥫ ᤥ   ਫ 饫箪
    // ࠢ 襩 , ⮡ࠦ ६ 
    case WM_BUTTON2DOWN:
    {
      WinPopupMenu(hWnd, hWnd, hwndPopupMenu,
        SHORT1FROMMP(mp1), SHORT2FROMMP(mp1),
        IDM_FILE_NEW,
        PU_POSITIONONITEM | PU_HCONSTRAIN | PU_VCONSTRAIN |
        PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 | PU_KEYBOARD);

      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
  return(WinDefWindowProc(hWnd, msg, mp1, mp2));
}

