// ==========================================================
// ।
// ==========================================================

// ।  䠩 os2.h
#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS

//  ᮤন ।, 室
//   ਫ OS/2
#include <os2.h>

//  䠩 㦥  । 㭪樨 sprintf
#include <stdio.h>

// । ⠭  ਫ MYWINDOW
#include "mywindow.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// ==========================================================
//  ६
// ==========================================================

// 䨪 Anchor-block
HAB  hab;

// 䨪  Frame Window -   ਫ
HWND hWndFrame;

// 䨪  Client Window
HWND hWndClient;

//  ਫ
CHAR szAppTitle[] = "My First OS/2 Application";

// ==========================================================
//  㭪 ਫ main
// 砥 ࠢ  ᪥ ਫ
// ==========================================================

int main()
{
  // 䨪 । ᮮ饭
  HMQ   hmq;

  // ,   뢠 ᮮ饭,
  // 祭  ।
  QMSG  qmsg;

  // ६  ࠭  
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "MYWINDOW";

  // 樠 ਫ, 室  ᯮ짮
  // 㭪権 Presentation Manager
  hab = WinInitialize(0);

  //   樠樨 뢮 ᮮ饭  訡
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);

  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);

    // । ਩ 襭 ਫ 室
    // 맢 㭪 WinTerminate
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass, (PFNWP)WndProc, 0, 0);

  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);

    // । ਩ 襭 ਫ 㭨⮦
    // ᮧ ࠭ । ᮮ饭 
    // 뢠 㭪 WinTerminate
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP, WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);

  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  // ⮦   ਫ
  WinDestroyWindow(hWndFrame);

  // 塞 । ᮮ饭  뢠
  // 㭪 WinTerminate
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);

  // 頥 ࠢ 樮 ⥬
  return(0);
}

// ==========================================================
// 㭪   ਫ
// ࠡ뢠 ᮮ饭, 㯠騥  । ਫ
// ==========================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  // ६   ⮢ ᮮ饭
  CHAR szMsg[100];

  switch (msg)
  {
    // ࠡ稪 ᮮ饭 WM_ERASEBACKGROUND
    //  ᮮ饭 㯠 । ᮢ
    // ७  
    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    // ࠡ稪 ᮮ饭 WM_BUTTON1DOWN  WM_BUTTON2DOWN
    //  ᮮ饭 㯠,  짮⥫ 
    //   ਫ 饫箪   ࠢ 
    // , ᮮ⢥⢥
    case WM_BUTTON1DOWN:
    case WM_BUTTON2DOWN:
    {
      // ।塞 न    뢠
      //    ⥪⮢ ப  ६ 
      sprintf(szMsg, "(x, y) = (%ld, %ld)",
        SHORT1FROMMP(mp1), SHORT2FROMMP(mp1));

      // ⮡ࠦ ᮤন ६   ࠭
      WinMessageBox(HWND_DESKTOP, hWnd,  szMsg,
        "न  ", 0, MB_INFORMATION | MB_OK);
    }

    // ᫨  㭪   ࠡ뢠 ᮮ饭,
    //  ᫥ 易⥫쭮 । 㪭樨 WinDefWindowProc
    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

