// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <string.h>
#include <stdio.h>
#include "scroll.h"

// ᨬ쭮 ⢮ ப  ⨪
#define YSIZE 50

// ᨬ쭮 ⢮ ᨬ  ਧ⠫
#define XSIZE 50

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "Scroll Demo";

//   Client Window
SHORT cxClient;
SHORT cyClient;

//  ᨬ ࠭ 
SHORT cxChar, cyChar, cyDesc;

//    ਪ 
FONTMETRICS fm;

// 䨪  ᬮ
HWND hwndXScroll;
HWND hwndYScroll;

// 騥 न 
INT nXScrollPos;
INT nYScrollPos;

// 騥 न  뢮 ⥪
LONG cxCurrentPosition;
LONG cyCurrentPosition;

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;
  HPS hps;

  //   ᮧ  Frame Window
  // 塞 䫠 FCF_VERTSCROLL  FCF_HORZSCROLL,
  //  १ 祣     ᮧ
  // ⨪쭠  ਧ⠫쭠  ᬮ
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON       | FCF_VERTSCROLL    | FCF_HORZSCROLL;

  //    
  CHAR  szWndClass[] = "SCRDEMO";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // 砥 ࠭⢮ ⮡ࠦ
  hps = WinGetPS(hWndFrame);

  // 롨ࠥ  ࠭⢮ ⮡ࠦ 
  //  䨪஢ ਭ ᨬ
  SetCourierFont(hps);

  // ।塞 ਪ 
  GpiQueryFontMetrics(hps, (LONG)sizeof(fm), &fm);

  cxChar = fm.lAveCharWidth;
  cyChar = fm.lMaxBaselineExt;
  cyDesc = fm.lMaxDescender;

  // ⠭ , ࠭  ࠭⢮
  // ⮡ࠦ  㬮砭
  ResetFont(hps);

  // 頥 ࠭⢮ ⮡ࠦ
  WinReleasePS(hps);

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS hps;
  RECTL rec;

  switch (msg)
  {
    case WM_CREATE:
    {
      // 砫 न 
      nYScrollPos = 0;
      nXScrollPos = 0;

      // 砫 न  뢮 ⥪
      cyCurrentPosition = cyClient;
      cxCurrentPosition =
        nXScrollPos * cxChar + cxChar;

      // ।塞 䨪  
      // ⨪쭮  ᬮ
      hwndYScroll = WinWindowFromID(
        WinQueryWindow(hWnd, QW_PARENT), FID_VERTSCROLL),

      // ⠭   न
      //   砫쭮  
      // ⨪쭮  ᬮ
      WinSendMsg(hwndYScroll,
        SBM_SETSCROLLBAR, (MPARAM)0,
        MPFROM2SHORT(0, YSIZE));

      // 믮塞  ⢨ 
      // ਧ⠫쭮  ᬮ
      hwndXScroll = WinWindowFromID(
        WinQueryWindow(hWnd, QW_PARENT), FID_HORZSCROLL),

      WinSendMsg(hwndXScroll,
        SBM_SETSCROLLBAR, (MPARAM)0,
        MPFROM2SHORT(0, XSIZE));

      return FALSE;
    }

    case WM_SIZE:
    {
      // 砥  ࠭塞 ࠧ  
      cxClient = SHORT1FROMMP(mp2);
      cyClient = SHORT2FROMMP(mp2);

      // ᮢ뢠  ਫ
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // 訢 , ॡ 
      WinFillRect(hps, &rec, CLR_WHITE);

      // 롨ࠥ  ࠭⢮ ⮡ࠦ 
      //  䨪஢ ਭ ᨬ
      SetCourierFont(hps);

      // ⠭ 砫 न 
      // 뢮 ⥪
      cxCurrentPosition = -nXScrollPos * cxChar + cxChar;
      cyCurrentPosition = cyClient;

      // 뢮 ਪ 
      PrintString(hps, fm.szFamilyname,     "szFamilyname");
      PrintString(hps, fm.szFacename,       "szFacename");

      PrintLong(hps, fm.idRegistry,         "idRegistry");
      PrintLong(hps, fm.usCodePage,         "usCodePage");
      PrintLong(hps, fm.lEmHeight,          "lEmHeight");
      PrintLong(hps, fm.lXHeight,           "lXHeight");
      PrintLong(hps, fm.lMaxAscender,       "lMaxAscender");
      PrintLong(hps, fm.lMaxDescender,      "lMaxDescender");
      PrintLong(hps, fm.lLowerCaseAscent,   "lLowerCaseAscent");
      PrintLong(hps, fm.lLowerCaseDescent,  "lLowerCaseDescent");
      PrintLong(hps, fm.lInternalLeading,   "lInternalLeading");
      PrintLong(hps, fm.lExternalLeading,   "lExternalLeading");
      PrintLong(hps, fm.lAveCharWidth,      "lAveCharWidth");
      PrintLong(hps, fm.lMaxCharInc,        "lMaxCharInc");
      PrintLong(hps, fm.lEmInc,             "lEmInc");
      PrintLong(hps, fm.lMaxBaselineExt,    "lMaxBaselineExt");
      PrintLong(hps, fm.sCharSlope,         "sCharSlope");
      PrintLong(hps, fm.sInlineDir,         "sInlineDir");
      PrintLong(hps, fm.sCharRot,           "sCharRot");
      PrintLong(hps, fm.usWeightClass,      "usWeightClass");
      PrintLong(hps, fm.usWidthClass,       "usWidthClass");
      PrintLong(hps, fm.sXDeviceRes,        "sXDeviceRes");
      PrintLong(hps, fm.sYDeviceRes,        "sYDeviceRes");
      PrintLong(hps, fm.sFirstChar,         "sFirstChar");
      PrintLong(hps, fm.sLastChar,          "sLastChar");
      PrintLong(hps, fm.sDefaultChar,       "sDefaultChar");
      PrintLong(hps, fm.sBreakChar,         "sBreakChar");
      PrintLong(hps, fm.sNominalPointSize,  "sNominalPointSize");
      PrintLong(hps, fm.sMinimumPointSize,  "sMinimumPointSize");
      PrintLong(hps, fm.sMaximumPointSize,  "sMaximumPointSize");
      PrintLong(hps, fm.fsType,             "fsType");
      PrintLong(hps, fm.fsDefn,             "fsDefn");
      PrintLong(hps, fm.fsSelection,        "fsSelection");
      PrintLong(hps, fm.fsCapabilities,     "fsCapabilities");
      PrintLong(hps, fm.lSubscriptXSize,    "lSubscriptXSize");
      PrintLong(hps, fm.lSubscriptYSize,    "lSubscriptYSize");
      PrintLong(hps, fm.lSubscriptXOffset,  "lSubscriptXOffset");
      PrintLong(hps, fm.lSubscriptYOffset,  "lSubscriptYOffset");
      PrintLong(hps, fm.lSuperscriptXSize,  "lSuperscriptXSize");
      PrintLong(hps, fm.lSuperscriptYSize,  "lSuperscriptYSize");
      PrintLong(hps, fm.lSuperscriptXOffset,"lSuperscriptXOffset");
      PrintLong(hps, fm.lSuperscriptYOffset,"lSuperscriptYOffset");
      PrintLong(hps, fm.lUnderscoreSize,    "lUnderscoreSize");
      PrintLong(hps, fm.lUnderscorePosition,"lUnderscorePosition");
      PrintLong(hps, fm.lStrikeoutSize,     "lStrikeoutSize");
      PrintLong(hps, fm.lStrikeoutPosition, "lStrikeoutPosition");
      PrintLong(hps, fm.sKerningPairs,      "sKerningPairs");
      PrintLong(hps, fm.sFamilyClass,       "sFamilyClass");
      PrintLong(hps, fm.lMatch,             "lMatch");
      PrintLong(hps, fm.FamilyNameAtom,     "FamilyNameAtom");
      PrintLong(hps, fm.FaceNameAtom,       "FaceNameAtom");

      // ⠭ , ࠭  ࠭⢮
      // ⮡ࠦ  㬮砭
      ResetFont(hps);

      // 頥 ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //  ᮮ饭 室  ⨪쭮
    //  ᬮ
    case WM_VSCROLL:
    {
      //  ᨬ   饭
      // 塞 ᮤন ६,  ன
      // ࠭ न 
      switch (SHORT2FROMMP(mp2))
      {
        case SB_LINEDOWN:
        {
          nYScrollPos += 1;
          break;
        }
        case SB_LINEUP:
        {
          nYScrollPos -= 1;
          break;
        }
        case SB_PAGEDOWN:
        {
          nYScrollPos += cyClient / cyChar;
          break;
        }
        case SB_PAGEUP:
        {
          nYScrollPos -= cyClient / cyChar;
          break;
        }
        case SB_SLIDERTRACK:
        {
          nYScrollPos = SHORT1FROMMP(mp2);
          break;
        }

        default:
          break;
      }

      // ࠭稢  
      // न 
      if(nYScrollPos > YSIZE) nYScrollPos = YSIZE;
      if(nYScrollPos < 0)  nYScrollPos = 0;

      // ⠭   
      WinSendMsg(hwndYScroll, SBM_SETPOS,
        (MPARAM)nYScrollPos, NULL);

      // ᮢ뢠  ਫ
      WinInvalidateRect(hWnd, NULL, TRUE);

      return 0;
    }

    //  ᮮ饭 室  ਧ⠫쭮
    //  ᬮ
    case WM_HSCROLL:
    {
      //  ᨬ   饭
      // 塞 ᮤন ६,  ன
      // ࠭ न 
      switch (SHORT2FROMMP(mp2))
      {
        case SB_LINELEFT:
        {
          nXScrollPos -= 1;
          break;
        }
        case SB_LINERIGHT:
        {
          nXScrollPos += 1;
          break;
        }
        case SB_PAGERIGHT:
        {
          nXScrollPos += 10;
          break;
        }
        case SB_PAGELEFT:
        {
          nXScrollPos -= 10;
          break;
        }
        case SB_SLIDERTRACK:
        {
          nXScrollPos = SHORT1FROMMP(mp2);
          break;
        }

        default:
          break;
      }

      // ࠭稢  
      // न 
      if(nXScrollPos < 0)  nXScrollPos = 0;

      // ⠭   
      WinSendMsg(hwndXScroll, SBM_SETPOS,
        (MPARAM)nXScrollPos, NULL);

      // ᮢ뢠  ਫ
      WinInvalidateRect(hWnd, NULL, TRUE);

      return 0;
    }

    //  ᮮ饭 ,  짮⥫
    //   ⦨ 
    case WM_CHAR:
    {
      // ய᪠ ⮫쪮 㠫 
      if(!(CHARMSG(&msg) ->fs & KC_VIRTUALKEY))
        return 0;

      // 㥬 ᮮ饭, 㯠騥 
      // ⦠⨨ 
      if(!(CHARMSG(&msg) ->fs & KC_KEYUP))
        return 0;

      //  ᨬ  㠫쭮  
      // 뫠  襣 ਫ
      // ᮮ饭 WM_HSCROLL  WM_HSCROLL 
      // ࠡ  ᠬ ᬮ  
      // 
      switch(CHARMSG(&msg) ->vkey)
      {
        case VK_LEFT:
        {
           WinSendMsg(hWnd, WM_HSCROLL,
             NULL, MPFROM2SHORT(0, SB_LINELEFT));
          break;
        }
        case VK_RIGHT:
        {
           WinSendMsg(hWnd, WM_HSCROLL,
             NULL, MPFROM2SHORT(0, SB_LINERIGHT));
          break;
        }
        case VK_UP:
        {
           WinSendMsg(hWnd, WM_VSCROLL,
             NULL, MPFROM2SHORT(0, SB_LINEUP));
          break;
        }
        case VK_DOWN:
        {
           WinSendMsg(hWnd, WM_VSCROLL,
             NULL, MPFROM2SHORT(0, SB_LINEDOWN));
          break;
        }
        case VK_PAGEUP:
        {
           WinSendMsg(hWnd, WM_VSCROLL,
             NULL, MPFROM2SHORT(0, SB_PAGEUP));
          break;
        }
        case VK_PAGEDOWN:
        {
           WinSendMsg(hWnd, WM_VSCROLL,
             NULL, MPFROM2SHORT(0, SB_PAGEDOWN));
          break;
        }
        default:
          break;
      }

      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

// =================================================
// 롮   䨪஢ ਭ ᨬ
// =================================================

void SetCourierFont(HPS hps)
{
  FATTRS fat;

  // 塞  ᠭ 㦭
  //  
  fat.usRecordLength = sizeof(FATTRS);
  strcpy(fat.szFacename ,"Courier");
  fat.fsSelection = 0;
  fat.lMatch = 0L;
  fat.idRegistry = 0;
  fat.usCodePage = 850;
  fat.lMaxBaselineExt = 12L;
  fat.lAveCharWidth = 12L;
  fat.fsType = 0;
  fat.fsFontUse = FATTR_FONTUSE_NOMIX;

  //  ᪨ , 騩 䨪 1L
  GpiCreateLogFont(hps, NULL, 1L, &fat);

  // 롨ࠥ ᮧ   ࠭⢮ ⮡ࠦ
  GpiSetCharSet(hps, 1L);
}

// =================================================
// ⠭ , ࠭  ࠭⢮
// ⮡ࠦ  㬮砭
// =================================================
void ResetFont(HPS hps)
{
  GpiSetCharSet(hps, LCID_DEFAULT);
  GpiDeleteSetId(hps, 1L);
}

// =================================================
// 뢮   祭 筮 ६
// =================================================

void PrintString(HPS hps, PSZ pszValue, PSZ pszName)
{
  int i;
  CHAR szBuf[80];
  POINTL ptl;

  // 뢮   
  sprintf(szBuf, "%s", pszName);
  i = strlen(szBuf);

  ptl.x = cxCurrentPosition;
  ptl.y = cyCurrentPosition -
    cyChar * (1 - nYScrollPos);
  GpiCharStringAt(hps, &ptl, i, szBuf);

  // 뢮 祭, ᠭ  ⮬ 
  sprintf(szBuf, "= %s", pszValue);
  i = strlen(szBuf);

  ptl.x = cxCurrentPosition + 20 * cxChar;
  ptl.y = cyCurrentPosition -
    cyChar * (1 - nYScrollPos);
  GpiCharStringAt(hps, &ptl, i, szBuf);

  // 塞 ⥪   뢮
  cyCurrentPosition -= cyChar;
}

// =================================================
// 뢮   祭 ६ ⨯ LONG
// =================================================

void PrintLong(HPS hps, LONG lValue, PSZ pszName)
{
  int i;
  CHAR szBuf[80];
  POINTL ptl;

  sprintf(szBuf, "%s", pszName);
  i = strlen(szBuf);

  ptl.x = cxCurrentPosition;
  ptl.y = cyCurrentPosition - cyChar * (1 - nYScrollPos);
  GpiCharStringAt(hps, &ptl, i, szBuf);

  sprintf(szBuf, "= %ld", lValue);
  i = strlen(szBuf);

  ptl.x = cxCurrentPosition + 20 * cxChar;
  ptl.y = cyCurrentPosition - cyChar * (1 - nYScrollPos);
  GpiCharStringAt(hps, &ptl, i, szBuf);

  cyCurrentPosition -= cyChar;
}

