// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <stdio.h>
#include <string.h>
#include "textout.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "TextOut Application";

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "TEXTOUT";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  CHAR szMsg[100];
  int nMsgSize;
  HPS hps;
  POINTL ptl;
  RECTL rec;

  switch (msg)
  {
    //  ⢥   ᮮ饭 㥬 
    //  Client Window
    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // 訢 , ॡ 
      WinFillRect(hps, &rec, CLR_WHITE);

      // 㥬 ⥪⮢ ப, 稭  窨,
      // 饩 न (10, 10)
      ptl.x = 10L;
      ptl.y = 10L;
      GpiCharStringAt(hps, &ptl, 10, "Hello, PM!");

      // ᢮ ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    // 塞  Frame Window  ᮤন
    //  Client Window
    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //   ࠧ஢  ਫ
    // ᮢ뢠  ᮤন
    case WM_SIZE:
    {
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    // ᫨ 짮⥫ ᤥ 饫箪  襩
    //    ਫ,   ᯮ
    //   ⮡ࠦ न ⮣ 
    case WM_BUTTON1DOWN:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinGetPS(hWnd);

      // ।塞 न    뢠
      //    ⥪⮢ ப  ६ 
      sprintf(szMsg, "(x, y) = (%ld, %ld)",
        SHORT1FROMMP(mp1), SHORT2FROMMP(mp1));

      // ।塞 न 窨  뢮 ⥪
      ptl.x = SHORT1FROMMP(mp1);
      ptl.y = SHORT2FROMMP(mp1);

      // ।塞 ࠧ ⥪⮢ ப
      nMsgSize = strlen(szMsg);

      // 㥬 ⥪⮢ ப
      GpiCharStringAt(hps, &ptl, nMsgSize, szMsg);

      // ᢮ ࠭⢮ ⮡ࠦ
      WinReleasePS(hps);
      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

