//      
//  
#define VC_EXTRALEAN

//    MFC
#include <afxwin.h>
#include <afxext.h> 
#include <afxcmn.h>

//     
#include "resource.h"

//===================================================== 
//  CBarApp -    
//===================================================== 
class CBarApp : public CWinApp
{
public:
   //     InitInstance,
   //    
   virtual BOOL InitInstance();
};
 
//     CBarApp
CBarApp MFBarApp;
 
//===================================================== 
//  CBarWindow -    
//===================================================== 
class CBarWindow : public CFrameWnd
{

protected:  // control bar embedded members
   CToolBar    m_wndToolBar;
   
protected:
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

public:
   //    CBarWindow
   CBarWindow();

   //      
   afx_msg void BarCommand();

   //  ,    
   // CBarWindow  
   DECLARE_MESSAGE_MAP()    
}; 

//===================================================== 
//  BarCommand
//   ID_TEST_BEEP
//===================================================== 
void CBarWindow::BarCommand()
{
   MessageBox("Command not implemented");	
}

//===================================================== 
//    CBarWindow
//===================================================== 
BEGIN_MESSAGE_MAP(CBarWindow, CFrameWnd)
   ON_WM_CREATE()
   ON_COMMAND(ID_FILE_OPEN, CBarWindow::BarCommand)
   ON_COMMAND(ID_FILE_SAVE, CBarWindow::BarCommand)
   ON_COMMAND(ID_TOOL_EXIT, CBarWindow::BarCommand)
END_MESSAGE_MAP()

//===================================================== 
//  InitInstance  CBarApp
//===================================================== 
BOOL CBarApp::InitInstance()
{
   //    CBarWindow
   m_pMainWnd = new CBarWindow();

   //    
   m_pMainWnd -> ShowWindow(m_nCmdShow);

   //   
   m_pMainWnd -> UpdateWindow();
   return TRUE;
}

//===================================================== 
//   CBarWindow
//===================================================== 
CBarWindow::CBarWindow()
{ 
   //   ,  
   //    CBarWindow
   Create(NULL, "Hello MFC", WS_OVERLAPPEDWINDOW,
         rectDefault, NULL ); 
}

//===================================================== 
//  OnCreate  CBarWindow
//      
//===================================================== 
int CBarWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   //   OnCreate  
   if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
      return -1;

   //    toolbar.   
   //     CBarWindow
   if (!m_wndToolBar.Create(this))
   {
      //     
      TRACE0("Failed to create toolbar\n");
      return -1;
   }
	
   if (!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
   {
      //      
      TRACE0("Failed to load toolbar\n");
      return -1;
   }

   return 0;
}
