// ===============================================
//  CGI controls.c
//     
//   ,    HTML
//
// (C)  .., 1997
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         
//         http://www.dials.ccas.ru/frolov
// ===============================================

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//   
void DecodeStr(char *szString);
char DecodeHex(char *str);

// ------------------------------------------------
//  main
//    CGI
// ------------------------------------------------
void main(int argc, char *argv[])
{
  int lSize;
  FILE * fileReceived;
  char * szMethod;
  char * szQueryString;
  char szBuf[8196];
  char szSrcBuf[8196];
  char * szPtr;
  char * szParam;

  //   HTTP   
  printf("Content-type: text/html\n\n");

  //     HTML,
  //  
  printf("<!DOCTYPE HTML PUBLIC"
    " \"-//W3C//DTD HTML 3.2//EN\">");
  printf("<HTML><HEAD><TITLE>XYZ Incorporation"
    "</TITLE></HEAD><BODY BGCOLOR=#FFFFFF>");

  //    
  szMethod = getenv("REQUEST_METHOD");

  //   POST
  if(!strcmp(szMethod, "POST"))
  {
    //   ,   
    //      
    lSize = atoi(getenv("CONTENT_LENGTH"));

    //      szBuf 
    //    STDIN
    fread(szBuf, lSize, 1, stdin);

    //  ,    
    //  
    fileReceived = fopen("received.dat", "w");

    //    
    fwrite(szBuf, lSize, 1, fileReceived);

    //    
    fclose(fileReceived);

    //     
    printf("<H2> </H2>");
    
    //  
    printf("REQUEST_METHOD = %s", getenv("REQUEST_METHOD"));

    //     
    printf("<BR>CONTENT_LENGTH = %ld", lSize);

    //   
    printf("<BR>CONTENT_TYPE = %s", getenv("CONTENT_TYPE"));

    //     , 
    //      
    szBuf[lSize] = '\0';

    //       szSrcBuf
    strcpy(szSrcBuf, szBuf);

    //     
    printf("<H2> </H2>");
    printf("<P>%s", szSrcBuf);

    //    
    DecodeStr(szSrcBuf);

    //   
    printf("<H2>  </H2>");
    printf("<P>%s", szSrcBuf);

    //     
    printf("<H2>  </H2>");
    
    //      
    //  "&",    
    //   
    szBuf[lSize] = '&';
    szBuf[lSize + 1] = '\0';

    //    
    for(szParam = szBuf;;)
    {
      //   
      szPtr = strchr(szParam, '&');
      
      //   ,   
      if(szPtr != NULL)
      {
        *szPtr = '\0';
        DecodeStr(szParam);
      
        //     
        printf("%s<BR>", szParam);

        //    
        szParam = szPtr + 1;

        //    ,  
        if(szParam >= (szBuf + lSize))
          break;
      }
      else
        break;
    }
    
    //     HTML
    printf("</BODY></HTML>");
    return;
  }
  
  //   GET
  else if(!strcmp(szMethod, "GET"))
  {
    //  ,   .
    //    GET   
    //     QUERY_STRING
    szQueryString = getenv("QUERY_STRING");
    
    //      
    fileReceived = fopen("received.dat", "w");
    fwrite(szQueryString, strlen(szQueryString) + 1, 1, fileReceived);
    fclose(fileReceived);
    
    //      HTML
    //    
    printf("<H2> </H2>");

    //   
    printf("REQUEST_METHOD = %s", getenv("REQUEST_METHOD"));

    //  
    printf("<BR>QUERY_STRING = %s", szQueryString);

    //      szSrcBuf
    strcpy(szSrcBuf, szQueryString);

    //   
    printf("<H2> </H2>");
    printf("<P>%s", szSrcBuf);
    
    //     
    // 
    DecodeStr(szSrcBuf);

    printf("<H2>  </H2>");
    printf("<P>%s", szSrcBuf);

    //       
    strcpy(szBuf, szQueryString);
    printf("<H2>  </H2>");

    szBuf[strlen(szBuf)] = '&';
    szBuf[strlen(szBuf) + 1] = '\0';

    for(szParam = szBuf;;)
    {
      szPtr = strchr(szParam, '&');
      if(szPtr != NULL)
      {
        *szPtr = '\0';
        DecodeStr(szParam);
        printf("%s<BR>", szParam);

        szParam = szPtr + 1;
        if(szParam >= (szBuf + lSize))
          break;
      }
      else
        break;
    }

    printf("</BODY></HTML>");
  }
}

// ------------------------------------------------
//  DecodeStr
//     URL
// ------------------------------------------------
void DecodeStr(char *szString)
{
  int src;
  int dst;
  char ch;

  //   
  for(src=0, dst=0; szString[src]; src++, dst++)
  {
    //     
    ch = szString[src];

    //   "+"  
    ch = (ch == '+') ? ' ' : ch;
    
    //  
    szString[dst] = ch;
    
    //     "%xx"
    if(ch == '%')
    {
      //    "%xx"
      //   
      szString[dst] = DecodeHex(&szString[src + 1]);
      src += 2;
    }
  }
  
  //    
  szString[dst] = '\0';
}

// ------------------------------------------------
//  DecodeHex
//   "%xx"
// ------------------------------------------------
char DecodeHex(char *str)
{
  char ch;

  //   
  if(str[0] >= 'A')
    ch = ((str[0] & 0xdf) - 'A') + 10;
  else
    ch = str[0] - '0';

  //     4 
  ch <<= 4;

  //     
  //   
  if(str[1] >= 'A')
    ch += ((str[1] & 0xdf) - 'A') + 10;
  else
    ch += str[1] - '0';

  //   
  return ch;
}
