// ===========================================================
//    
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// ===========================================================

import java.applet.*;
import java.awt.*;

public class FontList extends Applet
{
  // ---------------------------------------------------------
  //  
  // ---------------------------------------------------------
  Toolkit toolkit;   //   Toolkit
  String  fntlist[]; //  
  int yStart = 20;   //  Y   
  int yStep;         //      

  // ---------------------------------------------------------
  // getAppletInfo
  // ,     
  // ---------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: FontList\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // ---------------------------------------------------------
  // init
  //     
  // ---------------------------------------------------------
	public void init()
	{
    //    Toolkit
    toolkit = Toolkit.getDefaultToolkit();
    
    //    
    fntlist = toolkit.getFontList();
	}

  // ---------------------------------------------------------
  // paint
  //  paint,     
  // ---------------------------------------------------------
	public void paint(Graphics g)
	{
    //   
    FontMetrics fm = g.getFontMetrics();

    //      
    //      
    yStep = fm.getHeight();

    //     
    //      
		resize(150, 20 + yStep * fntlist.length);

    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);
    
    //      
    for(int i = 0; i < fntlist.length; i++)
    {
      g.drawString(fntlist[i], 10, yStart + yStep * i);
    }
	}
}
