//============================================================
//   FtpViewDlg   
//============================================================

//  
#define COL_NUM      4    //   
#define MIN_LEN_BUF  30   //   
#define DIRECTORY    0    //  
#define FILE         1    //  

//////////////////////////////////////////////////////////////
//  CFtpViewDlg 

class CFtpViewDlg : public CDialog
{
// Construction
public:
   ~CFtpViewDlg();
   CFtpViewDlg(CWnd* pParent = NULL); 

// Dialog Data
   //{{AFX_DATA(CFtpViewDlg)
	enum { IDD = IDD_FTPVIEW_DIALOG };
	CProgressCtrl	m_LoadProgress;
   CEdit   m_Status;       //  Directory
   CButton   m_Ok;         //  OK
   CButton   m_OnTop;      //  On top
   CButton   m_Connect;    //  Connect
   CListCtrl   m_FtpList;  //    
   CString   m_FtpAddress; //    FTP
	//}}AFX_DATA

   //{{AFX_VIRTUAL(CFtpViewDlg)
   protected:
   //   - DDX/DDV 
   virtual void DoDataExchange(CDataExchange* pDX);   
   //}}AFX_VIRTUAL

// Implementation
protected:
   CString sCurentDirectory;            //  
   CImageList* m_ImageList;             //  
   CFtpConnection* m_FtpConnection;     // FTP 
   CInternetSession* m_InternetSession; //   

   HICON m_hIcon;                    //  

protected:
   // ,   
   BOOL DirectoryView();             

   //   
   //{{AFX_MSG(CFtpViewDlg)
   virtual BOOL OnInitDialog();
   afx_msg void OnPaint();
   afx_msg HCURSOR OnQueryDragIcon();
   afx_msg void OnOnTop();
   afx_msg void OnDblclkFtpList(NMHDR* pNMHDR, LRESULT* pResult);
   afx_msg void OnConnect();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
private:
	BOOL FtpFileDownload( CString sFileName );
};
