// =========================================================
//  
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

public class Audio extends Applet
{
  // -------------------------------------------------------
  //  .
  //      
  // -------------------------------------------------------

  //     
  private String m_ClipName = "kaas.au";

  // -------------------------------------------------------
  //  
  // -------------------------------------------------------

	//   
  private final String PARAM_ClipName = "ClipName";

  // 
  AudioClip auClip;

  //    
  Button btPlay;

  //     
  Button btLoop;

  //    
  Button btStop;

  //    
  boolean fLoopPlay = false;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
  public String getAppletInfo()
	{
		return "Name: Audio\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // getParameterInfo
  // ,   
  // -------------------------------------------------------
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_ClipName, "String", "Audioclip filename" },
		};
		return info;		
	}

  // -------------------------------------------------------
  // init
  //     
  // -------------------------------------------------------
	public void init()
	{
    //     
		String param;

		//    
    //     

    //   
		param = getParameter(PARAM_ClipName);
		if (param != null)
			m_ClipName = param;

    //     
    btPlay = new Button("Play");

    //      
    btLoop = new Button("Loop");

    //     
    btStop = new Button("Stop");

    //   ,    
    //   
    btStop.disable();

    //     
    add(btPlay);
    add(btLoop);
    add(btStop);

    //      AudioClip
    auClip = Applet.getAudioClip(getCodeBase(), 
      m_ClipName);
	}

  // -------------------------------------------------------
  // action
  //  ,   
  //   
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    //   ,    
    Button btn;

    // ,    ,  
    //  
    if(evt.target instanceof Button)
    {
      //    ,  
      btn = (Button)evt.target;

      //    
      
      //    
      if(evt.target.equals(btPlay))
      {
        //   
        auClip.play();

        //    
        btStop.enable();
      }

      //     
      else if(evt.target.equals(btLoop))
      {
        //    
        auClip.loop();

        //     
        fLoopPlay = true;

        //    
        btStop.enable();
      }

      //    
      else if(evt.target.equals(btStop))
      {
        //  
        auClip.stop();

        //     
        fLoopPlay = false;

        //    
        btStop.disable();
      }

      //      ,
      //    
      else
      {
        return false;
      }

      //   ,    
      return true;
    }

    //     , 
    //    
    return false;
  }

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);
	}

  // -------------------------------------------------------
  // start
  //       
  // -------------------------------------------------------
	public void start()
	{
    //      ,
    //   
    if(fLoopPlay)
      auClip.loop();
	}
	
  // -------------------------------------------------------
  // stop
  //  ,      
  // -------------------------------------------------------
	public void stop()
	{
    //      ,
    //  
    if(fLoopPlay)
      auClip.stop();
	}
}
