// =========================================================
// ,     
//    Audio
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;
import java.util.*;

//   Audio,       
//  
import Audio;

public class Inspector extends Applet
{
  //  
  AppletContext appContext;

  //  ,    HTML
  Enumeration eApplets;

  //    Audio
  Audio appAudio = null;

  //    
  Button btPlay;

  //     
  Button btLoop;

  //    
  Button btStop;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: Inspector\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // -------------------------------------------------------
  // init
  //     
  // -------------------------------------------------------
	public void init()
	{
      //     
    btPlay = new Button("Play");

    //      
    btLoop = new Button("Loop");

    //     
    btStop = new Button("Stop");

    //   ,    
    //   
    btStop.disable();

    //     
    add(btPlay);
    add(btLoop);
    add(btStop);
  }
  
  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
  public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //   
    appContext = getAppletContext();
    
    //       HTML
    eApplets = appContext.getApplets();

    //   
    int i = 0;
    
    //   
    while(eApplets.hasMoreElements())
    {
      //   
      String appName;
      
      //     
      Applet currentApplet = (Applet)(eApplets.nextElement());

      //     
      appName = currentApplet.getAppletInfo();

      //  ,    
      StringTokenizer st;
      st   = new StringTokenizer(appName, "\r\n");
      appName = new String((String)st.nextElement());
      
      //    
      g.drawString(appName , 10, 15 * i + 50);

      //    Audio,  
      //     appAudio
      if(appName.equals("Name: Audio"))
      {
        appAudio = (Audio)currentApplet;
      }

      //   
      i++;
    }
	}

  // -------------------------------------------------------
  // action
  //  ,   
  //   
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    //   ,    
    Button btn;

    // ,    ,  
    //  
    if(evt.target instanceof Button)
    {
      //    ,  
      btn = (Button)evt.target;

      //    
      
      //    
      if(evt.target.equals(btPlay))
      {
        //   
        appAudio.auClip.play();

        //    
        btStop.enable();
      }

      //     
      else if(evt.target.equals(btLoop))
      {
        //    
        appAudio.auClip.loop();

        //    
        btStop.enable();
      }

      //    
      else if(evt.target.equals(btStop))
      {
        //  
        appAudio.auClip.stop();

        //    
        btStop.disable();
      }

      //      ,
      //    
      else
      {
        return false;
      }

      //   ,    
      return true;
    }

    //     , 
    //    
    return false;
  }
}
