// =========================================================
//   ,   
//    Web  
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class ShowChart extends Applet
{
  //  URL      
  URL SrcURL;

  //   
  Object URLContent;

  //  
  int errno = 0;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: ShowChart\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // init
  // ,     
  // -------------------------------------------------------
	public void init()
	{
    try
    {
      //    URL    
      //   
      SrcURL = new URL("http://frolov/chart.txt");

      try
      {
        //    
        URLContent = SrcURL.openConnection().getContent();
      }
      catch (IOException ioe)
      {
        showStatus("getContent exception");

        //      
        //    ,  1
        errno = 1;
      }
    }
    catch (MalformedURLException uex)
    {
      showStatus("MalformedURLException exception");

      //      
      //   URL   ,
      //  2
      errno = 2;
    }
	}

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    // ,     
    //     
    String sChart = "<error>";
    
    //    
    Integer AngleFromChart = new Integer(0);
    
    //    
    int PrevAngle = 0;

    //    
    int rColor, gColor, bColor;

    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    // ,    
    //  
    if(URLContent instanceof String)
    {
      sChart = (String)URLContent;
    }
    
    //  ,   ,  3
    else
      errno = 3;

    //   ,   
    //   
    if(errno != 0)
      showStatus("errno: " + errno + ", sChart: " + sChart);
    
    //   ,   
    else
      showStatus(sChart);

    //     
    //       
    StringTokenizer st = new StringTokenizer(sChart, ",\r\n");

    //    
    while(st.hasMoreElements())
    {
      //     
      rColor = (int)(255 * Math.random());
      gColor = (int)(255 * Math.random());
      bColor = (int)(255 * Math.random());

      //      
      g.setColor(new Color(rColor, gColor, bColor));

      //   
      String angle = (String)st.nextElement();

      //     
      AngleFromChart = new Integer(angle) ;
      
      //   
      g.fillArc(0, 0, 200, 200, 
        PrevAngle, AngleFromChart.intValue());

      //    
      PrevAngle += AngleFromChart.intValue();
    }
	}
}
