// =========================================================
//    
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

// =========================================================
//   
// =========================================================
public class Synchro extends Applet
{
  //     
  DrawRectangles m_DrawRectThread = null;

  //   ,   
  //  
  NotifyTask m_NotifyTaskThread = null;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: Synchro\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);
	}

  // -------------------------------------------------------
  // start
  //       
  // -------------------------------------------------------
	public void start()
	{
    if (m_DrawRectThread == null)
		{
      m_DrawRectThread = new DrawRectangles(this);
      m_DrawRectThread.start();
		}

    if (m_NotifyTaskThread == null)
		{
      //  ,    
      //   , 
      //   
      m_NotifyTaskThread = new NotifyTask(m_DrawRectThread);
      m_NotifyTaskThread.start();
		}
	}
	
  // -------------------------------------------------------
  // stop
  //  ,      
  // -------------------------------------------------------
	public void stop()
	{
		if (m_DrawRectThread != null)
		{
			m_DrawRectThread.stop();
			m_DrawRectThread = null;
		}

    if (m_NotifyTaskThread != null)
		{
			m_NotifyTaskThread.stop();
			m_NotifyTaskThread = null;
		}
	}
}

// =========================================================
//     
// =========================================================
class DrawRectangles extends Thread
{
  //    
  Graphics g;

  //   
  Dimension dimAppWndDimension;

  // -------------------------------------------------------
  // DrawRectangles
  //   DrawRectangles
  // -------------------------------------------------------
  public DrawRectangles(Applet Appl)
  {
    //     
    g = Appl.getGraphics();

    //     
    dimAppWndDimension = Appl.size();
  }

	// -------------------------------------------------------
  // run
  // ,      
  //       
  // ,   
  //
  //       synchronized
  // -------------------------------------------------------
	public synchronized void run()
	{
    while (true)
		{
      int x, y, width, height;
      int rColor, gColor, bColor;
      
      //    
      //    
      x =      (int)(dimAppWndDimension.width * Math.random());
      y =      (int)(dimAppWndDimension.height * Math.random());
      width  = (int)(dimAppWndDimension.width * Math.random()) / 2;
      height = (int)(dimAppWndDimension.height * Math.random()) / 2;
      
      //      
      rColor = (int)(255 * Math.random());
      gColor = (int)(255 * Math.random());
      bColor = (int)(255 * Math.random());

      //      
      g.setColor(new Color(rColor, gColor, bColor));

      //  
      g.fillRect(x, y, width, height);

      //     ,  
      //      ,   
      //    NotifyTask
      try
			{
				Thread.wait();
			}
			catch (InterruptedException e)
			{
			}
		}
	}
}

// =========================================================
//     
//   
// =========================================================
class NotifyTask extends Thread
{
  //   ,   
  Thread STask;

  // -------------------------------------------------------
  //   NotifyTask
  // -------------------------------------------------------
  public NotifyTask(Thread SynchroTask)
  {
    //    ,  
    // 
    STask = SynchroTask;
  }

  // -------------------------------------------------------
  // run
  // ,       
  //    STask
  // -------------------------------------------------------
	public void run()
	{
    while (true)
		{
      //    30 
      try
			{
				Thread.sleep(30);
			}
			catch (InterruptedException e)
			{
  		}

      //   STask   
      //      notify, 
      //    
      synchronized(STask)
      {
        STask.notify();
      }
		}
	}
}

