// =====================================================
//       BIOS
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =====================================================
#include <dos.h>
#include <stdio.h>
#include <conio.h>

union REGS rg;
int printchar(int chr);
int error(char chr, int status);

int main(int argc, char *argv[]) 
{
  FILE *srcfile;

  //  ,   
  //   .
  //      
  //   ,   
  if( (srcfile = fopen( argv[1], "rb" )) == NULL ) 
  {
    printf("\n     ");
    return (-1);
  }

  //     ,   
  //        printchar
  for(;;) 
  {
    printchar(fgetc(srcfile));
    if(feof(srcfile)) 
      break;
  }

  //  
  fclose(srcfile);
  
  return 0;
}

// ------------------------------------
//     
//    (LPT1)
// ------------------------------------
int printchar(int chr) 
{
  int status;

  //       
  //   ,      
  // ,     
  //  
  for(;;) 
  {
    //     
    putch(chr);

    //   00h  INT 17h -
    //    .
    //   DX    LPT1 -  0
    rg.h.ah = 0;
    rg.h.al = chr;
    rg.x.dx = 0;

    int86(0x17, &rg, &rg);

    //    
    //   
    status = rg.h.ah;

    //   .   :
    //
    //    0 -   
    //    3 -  /
    //    4 -    ONLINE (1)  OFFLINE (0)
    //    5 -  
    if((status & 0x39) != 0x10) 
    {
      //     error(). 
      //   0,   
      //   ,  1 - 
      //   
      if(error(chr, status)) 
      {
        printf("\n  ");
        return -1;
      }
    }
    else 
      break;
  }
}

// ------------------------------------
//     
//     
//   - 
//     
// ------------------------------------
int error(char chr, int status) 
{
  //     
  printf("\n  %02.2X"
       "\n\n :"
       "\n-------------------", status);

  if(status & 1)
    printf("\n  ");

  if(status & 8)
    printf("\n /");

  if(!(status & 0x10))
    printf("\n    OFFLINE");

  if(status & 0x20)
    printf("\n ");

  printf("\n\n     ESC,"
    "\n  -   \n");

  if(getch() == 27) 
    return 1;
  else 
    return 0;
}
