// =========================================================
//   .
//      
//
// (C)  ., 1997, 1998
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================

import java.applet.*;
import java.awt.*;

public class TextOut extends Applet
{
  // -------------------------------------------------------
  //  .
  //      
  // -------------------------------------------------------
	private String m_Str1 = "Hello 1";
	private String m_Font1 = "Arial";
	private String m_Type1 = "Bold";

  // -------------------------------------------------------
  //  
  // -------------------------------------------------------
	private final String PARAM_Str1 = "Str1";
	private final String PARAM_Font1 = "Font1";
	private final String PARAM_Type1 = "Type1";

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: TextOut\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // getParameterInfo
  // ,   
  // -------------------------------------------------------
  public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_Str1, "String", "Text string to write" },
			{ PARAM_Font1, "String", "Text font" },
			{ PARAM_Type1, "String", "Font type" },
		};
		return info;		
	}

  // -------------------------------------------------------
  // init
  //     
  // -------------------------------------------------------
	public void init()
	{
    //     
    String param;

		//    
    //     

    // ,      
    param = getParameter(PARAM_Str1);
		if (param != null)
			m_Str1 = param;


		//    
    param = getParameter(PARAM_Font1);
		if (param != null)
			m_Font1 = param;


		//  
    param = getParameter(PARAM_Type1);
		if (param != null)
			m_Type1 = param;
	}

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
  {
    //      
    int yStart   = 20;

    //     
    int yCurrent = 20;

    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    //     
    if(m_Type1.equals("Bold"))
      g.setFont(new Font(m_Font1, Font.BOLD, 25));

    else if(m_Type1.equals("Italic"))
      g.setFont(new Font(m_Font1, Font.ITALIC, 25));

    else if(m_Type1.equals("Plain"))
      g.setFont(new Font(m_Font1, Font.PLAIN, 25));

    //    
    yCurrent += yStart;

    //   
    g.drawString(m_Str1, 10, yCurrent);


	}
}
