// ===============================================
//  ISAPI xbmcnt.c
//   
//
// (C)  .., 1997
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         
//         http://www.dials.ccas.ru/frolov
// ===============================================

#include <windows.h>
#include <httpext.h>
#include <stdio.h>
#include <string.h>

//  
#define char_width 8

//  
#define char_height 16

//     
static unsigned char char_bits[10][char_height] = 
{
	//   0
  {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x3C, 0x42, 0x42, 0x42, 0x42, 0x42, 
    0x42, 0x42, 0x42, 0x3C 
  },
	
	//   1
  { 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x10, 0x18, 0x14, 0x10,	0x10, 0x10, 
    0x10, 0x10, 0x10, 0x7C 
  },

	//   2
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x3E, 0x22, 0x20, 0x20, 0x10, 0x08, 
    0x04, 0x02, 0x22, 0x3F 
  },

	//   3
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x3E, 0x22, 0x40, 0x40, 0x3C, 0x40, 
    0x40, 0x40, 0x22, 0x3E 
  },

	//   4
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x10, 0x18, 0x14, 0x12, 0x12, 0x3E, 
    0x10, 0x10, 0x10, 0x38 
  },

	//   5
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x3E, 0x02, 0x02, 0x02, 0x3E, 0x20, 
    0x20, 0x20, 0x22, 0x2C 
  },

	//   6
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x1C, 0x06, 0x02, 0x02, 0x1E, 0x22, 
    0x22, 0x22, 0x22, 0x1C 
  },

	//   7
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x3E, 0x22, 0x20, 0x20, 0x10, 0x08, 
    0x08, 0x08, 0x08, 0x08 
  },

	//   8
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x1C, 0x22, 0x22, 0x22, 0x1C, 0x22, 
    0x22, 0x22, 0x22, 0x1C 
  },

	//   9
	{ 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x1C, 0x22, 0x22, 0x22, 0x3C, 0x20, 
    0x20, 0x20, 0x20, 0x1C 
  },
};

void PrintCounter(LPSTR szCounter, LPSTR szBuffer);

// =============================================================
//  GetExtensionVersion
//    ISAPI 
//   
// =============================================================
BOOL WINAPI GetExtensionVersion(HSE_VERSION_INFO *pVer)
{
  //    ISAPI
  pVer->dwExtensionVersion = 
    MAKELONG(HSE_VERSION_MINOR,HSE_VERSION_MAJOR );

  //    
  lstrcpyn(pVer->lpszExtensionDesc,
    "ISAPI Counter", HSE_MAX_EXT_DLL_NAME_LEN);

  return TRUE;
}

// =============================================================
//  HttpExtensionProc
// =============================================================
DWORD WINAPI HttpExtensionProc(EXTENSION_CONTROL_BLOCK *lpECB)
{
  //  
  CHAR  szBuff[4096];

  //   
  HANDLE hCounterFile;

  //   
  DWORD dwBytesRead;

  //   
  DWORD dwBytesWritten;

  //   
  BOOL bResult;

  //      
  CHAR  szBuf[20];

  //   
  INT   nCounter;

  //    -   
  lpECB->dwHttpStatusCode = 0;

  // -----------------------------------------------
  //     
  // -----------------------------------------------

  //     
  hCounterFile = CreateFile("CNTDAT.DAT", 
    GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
    FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  //      
  bResult = ReadFile(hCounterFile, szBuf, 7, 
    &dwBytesRead, NULL);

  //   
  CloseHandle(hCounterFile);
  
  //     
  //    
  sscanf(szBuf, "%d", &nCounter);
  
  //   
  nCounter++;
  
  //    szBuf   
  //  
  sprintf(szBuf, "%05.5ld", nCounter);

  //      
  hCounterFile = CreateFile("CNTDAT.DAT", 
    GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
    FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  WriteFile(hCounterFile, szBuf, strlen(szBuf),
    &dwBytesWritten, NULL);

  CloseHandle(hCounterFile);
  
  //     HTTP
  wsprintf(szBuff, "Content-type: image/x-xbitmap\r\n\r\n");

  //       XBM
  PrintCounter(szBuf, szBuff);

  //     
  if(!lpECB->ServerSupportFunction(lpECB->ConnID,
    HSE_REQ_SEND_RESPONSE_HEADER, NULL, NULL, 
    (LPDWORD)szBuff))
  {
    //     , 
    //     ISAPI 
    //   
    return HSE_STATUS_ERROR;
  }

  //    
  lpECB->dwHttpStatusCode = 200;
  
  //      
  return HSE_STATUS_SUCCESS;
}

// =============================================================
//  PrintCounter
// =============================================================
void PrintCounter(LPSTR szCounter, LPSTR szBuff)
{
  //  
  CHAR  szTempBuf[4096];

  //    
  int nFinalWidth;

  //    
  int nFinalHeight;

  //     
  int nLine;

  //  
  unsigned int nChar;

  //     
  int nDigitOffset;

  //      
  //    
  nFinalWidth  = char_width * strlen(szCounter);

  //      
  //  
  nFinalHeight = char_height;

  //  
  wsprintf(szTempBuf, "Expires: Thu, 03 Dec 1996 10:00:00 GMT\r\n");
  strcat(szBuff, szTempBuf);

  wsprintf(szTempBuf, "Pragma: no-cache\r\n");
  strcat(szBuff, szTempBuf);

  //    XBM
  wsprintf(szTempBuf, "#define counter_width %d\r\n",
    nFinalWidth);
  strcat(szBuff, szTempBuf);

  wsprintf(szTempBuf, "#define counter_height %d\r\n", 
    nFinalHeight);
  strcat(szBuff, szTempBuf);

  wsprintf(szTempBuf, "static unsigned char counter_bits[] = {\r\n");
  strcat(szBuff, szTempBuf);

  //      
  for(nLine=0; nLine < nFinalHeight; nLine++)
	{
		for(nChar=0; nChar < strlen(szCounter); nChar++)
		{
      nDigitOffset = szCounter[nChar] - '0';

      wsprintf(szTempBuf, "0x%02X, ", 
        char_bits[nDigitOffset][nLine]);

      strcat(szBuff, szTempBuf);
		}
	}
 
  //  ,     XBM
  strcat(szBuff, "};\r\n");
}