// ===============================================
//  ISAPI ishello.c
//   ISAPI,  
//  cookie
//
// (C)  .., 1997, 1998
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         
//         http://www.dials.ccas.ru/frolov
// ===============================================

#include <windows.h>
#include <httpext.h>

// =============================================================
//  GetExtensionVersion
//    ISAPI 
//   
// =============================================================
BOOL WINAPI GetExtensionVersion(HSE_VERSION_INFO *pVer)
{
  //    ISAPI
  pVer->dwExtensionVersion = 
    MAKELONG(HSE_VERSION_MINOR,HSE_VERSION_MAJOR );

  //    
  lstrcpyn(pVer->lpszExtensionDesc,
    "Cookie show ISAPI DLL", HSE_MAX_EXT_DLL_NAME_LEN);

  return TRUE;
}

// =============================================================
//  HttpExtensionProc
// =============================================================
DWORD WINAPI HttpExtensionProc(EXTENSION_CONTROL_BLOCK *lpECB)
{
  CHAR  szBuff[4096];
  CHAR  szTempBuf[4096];
  
  DWORD  dwSize;

  //    -   
  lpECB->dwHttpStatusCode = 0;

  //     HTTP  
  //     HTML
  wsprintf(szBuff,
    "Content-Type: text/html\r\n\r\n"
    "<HTML><HEAD><TITLE>Simple ISAPI Extension</TITLE></HEAD>\n"
    "<BODY BGCOLOR=#FFFFFF><H2>Hello from ISAPI Extension!</H2>\n");

  //   
  strcat(szBuff, "<HR>");
 
  //    ISAPI
  wsprintf(szTempBuf, "<P>Extension Version: %d.%d", 
    HIWORD(lpECB->dwVersion), LOWORD(lpECB->dwVersion));
  strcat(szBuff, szTempBuf);
  
  //    
  wsprintf(szTempBuf, "<BR>Method: %s", lpECB->lpszMethod);
  strcat(szBuff, szTempBuf);
  
  //     ISAPI
  wsprintf(szTempBuf, "<BR>QueryString: %s", 
    lpECB->lpszQueryString);
  strcat(szBuff, szTempBuf);
  
  //       ISAPI
  wsprintf(szTempBuf, "<BR>PathTranslated: %s", 
    lpECB->lpszPathTranslated);
  strcat(szBuff, szTempBuf);

  //   ,   
  wsprintf(szTempBuf, "<BR>TotalBytes: %d", 
    lpECB->cbTotalBytes);
  strcat(szBuff, szTempBuf);

  //  
  wsprintf(szTempBuf, "<BR>ContentType: %s", 
    lpECB->lpszContentType);
  strcat(szBuff, szTempBuf);

  //   COOKIE
  strcat(szBuff, "<HR><P><B>Cookie:</B><BR>");

  dwSize = 4096;
  lpECB->GetServerVariable(lpECB->ConnID,
    (LPSTR)"HTTP_COOKIE", (LPVOID)szTempBuf, &dwSize);
  strcat(szBuff, szTempBuf);

  //    HTML
  strcat(szBuff, "</BODY></HTML>");  

  //     
  if(!lpECB->ServerSupportFunction(lpECB->ConnID,
    HSE_REQ_SEND_RESPONSE_HEADER, NULL, NULL, 
    (LPDWORD)szBuff))
  {
    //     , 
    //     ISAPI 
    //   
    return HSE_STATUS_ERROR;
  }

  //    
  lpECB->dwHttpStatusCode = 200;
  
  //      
  return HSE_STATUS_SUCCESS;
}

