// MODEM.C
//

// (C) ஫ .., 1995
//  E-mail: frolov@glas.apc.org


#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>

#include "uart.h"
#include "common.h"
#include "modem.h"
#include "mod_link.h"
#include "get_word.h"
#include "timer.h"
#include "tools.h"
#include "conf.h"


char *device = "COM3";  //  ᯮ㥬   ଠ
								// COMn,  n  1  4

unsigned  dialTimeout = 12,   // த⥫쭮  ᮥ
			 chardelay = 0,      // প  ।  ᨬ
			 modemTimeout = 3,   // ⠩  祭 ⢥  
			 answerTimeout;      // த⥫쭮  


unsigned  speed = 2400;     // ᪮  묨


char initialize[80];    //  樠樨
char dropline[80];      //   㡪
char autoanswer[80];    // ⢥  맮  ० ⮮⢥

char dialPrefix[80];  // 䨪 
char dialSuffix[80];  // 䨪 
char dialNumber[80];  // ⥫䮭 

void Exchange( void );


// Call
// 맮 㤠 짮⥫

int Call() {

	char str[80], buf[80];
	char *exp;
	int i,j;

	// ।塞 ࠬ 裡 (뢠 䠩 䨣樨)

	GetConfig();

	// ⠭ ࠡ稪 뢠  樠㥬
	// ॣ UART  ஫ 뢠

	if (OpenLine(device, speed))
		return FALSE;

	// 頥 ਥ 

	while (SRead(buf,1,0));

	printf("樠㥬 \n\n");

	// ।  ப 樠樨
	// (ப 樠樨 । 祢 ᫮ Initialize
	//  䠩 䨣樨 setup.cfg)

	SendStr( initialize );

	//  ⢥ 

	Sleep(modemTimeout);

	// 뢠  ⮡ࠦ  ࠭ ⢥⭮ ᮮ饭 

	if( RCountPending() > 0 ) {

		SRead(str, i = RCountPending(), 0);
		str[i] = '\0';

		for( j = 0; j < i; j++ )
			putch( str[j] );
	}

	// ।    

	strcpy(buf, dialPrefix);
	strcat(buf, dialNumber);
	strcat(buf, dialSuffix);

	printf( "ࠥ \n\n");

	SendStr( buf );

	printf( " ᮥ\n\n");

	// ந  묨  㤠 ,
	//     "ESC"

	Exchange();

	return(0);
}

// ansver
// ⢥砥  

int Ansver( void ) {

	char c;

	// ।塞 ࠬ 裡

	GetConfig();

	// ⠭ ࠡ稪 뢠  樠㥬
	// ॣ UART  ஫ 뢠

	if (OpenLine(device, speed))
		exit(-2);

	// 頥 ਥ 

	while (SRead(&c ,1,0));

	printf("樠㥬 \n\n");

	// ।  ப 樠樨
	// (ப 樠樨 । 祢 ᫮ Autoanswer
	//  䠩 䨣樨 setup.cfg)

	SendStr( autoanswer );
	Sleep(modemTimeout);

	printf(" \n");

	// ந  묨  㤠 ,
	//     "ESC"

	Exchange();

	return(0);
}


// shutdown
// 㭪  ⥫䮭 㡪

void ShutDown( void ) {

	printf("\n\n 祭, ᢮ ⥫䮭\n");

	// ।   㡪

	SendStr( dropline );

	// ⠭  ࠡ稪 뢠

	CloseLine();
}


// SlowWrite
// । ᨬ   প, ।塞 祢
// ᫮ CharDelay  䠩 䨣樨

void SlowWrite( char *s, int len) {

	SWrite( s , len );
	if (chardelay > 0) Delay(chardelay);
}


// Exchange
// 㭪 믮  짮⥫  㤠 

void Exchange( void ) {

	int flag = 1;

	while(flag) {

		unsigned char str[80];
		unsigned char key;
		unsigned i,j;

		// ᫨ 짮⥫   , 砥 
		// ⮣ ᨬ  ।  

		if( kbhit() ) {
			key =  getch();

			//    "ESC" 室  ணࠬ

			if( key == 27 ) {
				SSendBrk( );
				flag = 0;
				break;
			}

			if( key == '\r' ) putch( '\n' );

			putch(key);

			SWrite( &key, 1);
		}

		// ᫨ 祭   , ⮡ࠦ   ࠭

		if( RCountPending() > 0 ) {

			Delay(100);

			SRead(str, i = RCountPending(), 0);
			str[i] = '\0';

			for( j = 0; j < i; j++ )
				putch( str[j] );
		}
	}
}



