// ======================================================
// DLL- d2w.dll
//
//     dos2win.exe
//  VxD- VXDSRV.386  1.1
// ------------------------------------------------------
// Copyright (C) 1995 Alexandr Frolov
// ======================================================
#define  STRICT
#include <windows.h>
#include <mem.h>
#include "d2w.h"
#include "vxdcall.hpp"

extern "C" void FAR PASCAL _export
WinAppStart(WORD wVxDVersion);

extern "C" void FAR PASCAL _export
RegisterWnd(HWND hwnd);

void UnregisterWnd(VXDAPI vxdEntry);

//   API VxD-
VXDAPI vxdApi = NULL;

//    dos2win.exe
HWND hwndDos2Win;

//    VXD- VXDSRV.386  
//  ,  ,   
//   ,  
//  MS-DOS    
BYTE szCallbackBuf[350];

//       VM MS-DOS
//    
BYTE szCmd[6][350];

//      szCmd
int nCmdLine = 0;

// ========================================================
//  LibMain
//      
//  DLL-  
// ========================================================
#pragma argsused
int FAR PASCAL
LibMain(HINSTANCE hModule, WORD wDataSegment,
  WORD wHeapSize, LPSTR lpszCmdLine)
{
  if(wHeapSize != 0)
    UnlockData(0);

  //    API VxD-
  vxdApi = vxdGetDeviceAPI(VXD_ID);

  return TRUE;
}

// ========================================================
//  WEP
// ========================================================
#pragma argsused
int FAR PASCAL WEP(int bSystemExit)
{
  //  DLL-   ,
  //   VxD-
  if(vxdApi != NULL)
    UnregisterWnd(vxdApi);
  return 1;
}

// ========================================================
//    WinAppStart
//   VxD- VXDSRV.386
//  ,   
//     , 
//   WM_STARTWINAPP  
// dos2win.exe,   .
// ========================================================
extern "C" void FAR PASCAL _export
WinAppStart(WORD wVxDVersion)
{
  //   VxD-, 
  //   wVxDVersion
  if(wVxDVersion != 0x0101) return;

  //   ,   
  //    
  _fmemcpy((LPVOID)szCmd[nCmdLine], (LPVOID)szCallbackBuf, 65 + 256);

  //    dos2win
  PostMessage(hwndDos2Win, WM_STARTWINAPP,
    0, (LPARAM)szCmd[nCmdLine]);

  //      
  nCmdLine++;
  if(nCmdLine > 5) nCmdLine = 0;
}

// ========================================================
//  RegisterWnd
//    dos2win.exe
// ========================================================
extern "C" void FAR PASCAL _export
RegisterWnd(HWND hwnd)
{
  if(vxdApi == NULL) return;

  //   
  hwndDos2Win = hwnd;
  if(vxdApi == NULL) return;

  //      
  unsigned sel  = SELECTOROF((LPVOID)WinAppStart);
  unsigned off  = OFFSETOF((LPVOID)WinAppStart);

  //     szCallbackBuf
  unsigned bsel  = SELECTOROF(szCallbackBuf);
  unsigned boff  = OFFSETOF(szCallbackBuf);

  //     
  //  szCallbackBuf  VxD-
  asm mov dx, sel
  asm mov cx, off
  asm mov si, bsel
  asm mov di, boff
  asm mov ax, vxdapiRegisterWnd
  (*vxdApi)();
}

// ========================================================
//  UnregisterWnd
//  VxD-
// ========================================================
void UnregisterWnd(VXDAPI vxdEntry)
{
  if(vxdApi == NULL) return;

  asm mov ax, vxdapiUnregisterWnd
  (*vxdEntry)();
}

// ========================================================
//  vxdGetDeviceAPI
//     API 
// VxD-,  
//   vxd_id
// ========================================================
VXDAPI vxdGetDeviceAPI(unsigned short vxd_id)
{
  unsigned axreg, dxreg;

  asm push  di
  asm push  es
  asm mov   ax, 0x1684
  asm mov   bx, vxd_id
  asm xor   di, di
  asm mov   es, di
  asm int   0x2f
  asm mov   ax, di
  asm mov   dx, es
  asm pop   es
  asm pop   di

  asm mov   axreg, ax
  asm mov   dxreg, dx

  return((VXDAPI)MAKELP(dxreg, axreg));
}
