  .MODEL tiny                                                                  
  .CODE
  ORG 0

drvioctl proc far

;===================================================
;  ࠩ
;===================================================
  dd   0ffffffffh      ;  ᫥饣 ࠩ
  dw   8000h           ;  ਡ⮢
  dw   dev_strategy    ;  楤 ⥣
  dw   dev_interrupt   ;  楤 뢠
  db   'IODRIVER'      ;  ன⢠

;===================================================
; ணࠬ ⥣
;===================================================
dev_strategy:
  mov  cs:req_seg, es
  mov  cs:req_off, bx
  ret

;     
req_seg         dw ?
req_off         dw ?

;===================================================
; ࠡ稪 뢠
;===================================================

dev_interrupt:
  push es
  push ds
  push ax
  push bx
  push cx
  push dx
  push si
  push di
  push bp

  mov  ax, cs:req_seg
  mov  es, ax
  mov  bx, cs:req_off

  mov  al,es:[bx]+2
  shl  al,1
  sub  ah,ah         
  lea  di,functions 
  add  di,ax 
  jmp  word ptr [di] 

functions   LABEL  WORD

   dw   initialize
   dw   check_media
   dw   make_bpb
   dw   ioctl_in
   dw   input_data
   dw   nondestruct_in
   dw   input_status
   dw   clear_input
   dw   output_data
   dw   output_verify
   dw   output_status
   dw   clear_output
   dw   ioctl_out
   dw   Device_open
   dw   Device_close
   dw   Removable_media

check_media:
make_bpb:
ioctl_in:
nondestruct_in:
input_status:
clear_input:
output_verify:
output_status:
clear_output:
ioctl_out:
Removable_media:
Device_open:
Device_close:

  or   es:word ptr [bx]+3, 8103h
  jmp  quit

;===================================================
; ࠡ稪  뢮 
;===================================================

output_data:

; 뢠  ॣ CL ⢮
; 뢮 ᨬ

  mov  cl, es:[bx]+18
  push cx

; 뢮 ᮮ饭  砫 뢮

  mov ax, cs
  mov ds, ax
  mov si, offset outmsg
  call Puts

  pop cx

; 㦠  DS:SI   

  mov  ax, es:[bx]+16
  mov  ds, ax
  mov  si, es:[bx]+14

; 뢮  ࠭ ᨬ  

out_loop:
  mov   ah, 02h
  mov   dl, ds:byte ptr [si]
  int   21h
  inc si
  loop out_loop
  jmp  quit

;===================================================
; ࠡ稪   
;===================================================

input_data:

; 뢠  ॣ CL ⢮
;  ᨬ

  mov  cl, es:[bx]+18
  push cx

; 뢮 ᮮ饭  砫 

  mov ax, cs
  mov ds, ax
  mov si, offset inpmsg
  call Puts

; 㦠  DS:SI   

  pop  cx
  mov  ax, es:[bx]+16
  mov  ds, ax
  mov  di, es:[bx]+14

;  ᨬ    뢠  

inp_loop:
  mov  ax,0
  int  16h
  mov  ds:byte ptr [di], al
  mov   ah, 02h
  mov   dl, al
  int   21h
  inc di
  loop inp_loop
  jmp  quit

quit:
  or   es:word ptr [bx]+3, 100h
  pop bp
  pop di
  pop si
  pop dx
  pop cx
  pop bx
  pop ax
  pop ds
  pop es
  ret

;===================================================
; 楤 뢮  ࠭ ப
; ᨬ  ଠ ASCIIZ
;===================================================

Puts proc near
  push si
Puts_loop:
  cmp  ds:byte ptr [si], 0
  jz   end_Puts
  mov   ah, 02h
  mov   dl, ds:byte ptr [si]
  int   21h
  inc si
  jmp Puts_loop

end_Puts:
  pop si
  ret
Puts endp

hello db 13,10,'+--------------------------------+'
      db 13,10,'| *DRVIOCTL* (C)Frolov A., 1995  |'
      db 13,10,'+--------------------------------+'
      db 13,10,0

outmsg   DB 13,10,'뢥: ',0
inpmsg   DB 13,10,' ᨬ: ',0

E_O_P:
initialize:

  lea  ax, E_O_P 
  mov  es:word ptr [bx]+14, ax
  mov  es:word ptr [bx]+16, cs

; ࠥ ࠭

  mov   dh, 18h
  mov   dl, 80h

  xor   cx, cx
  mov   bh, 7
  xor   al, al
  mov   ah, 6
  int   10h

; ⠭    孨 㣮 ࠭

  mov   bh, 0
  xor   dx, dx
  mov   ah, 2
  int   10h

; 뢮 ᮮ饭

  mov ax, cs
  mov ds, ax
  mov si, offset hello
  call Puts
  jmp  quit

drvioctl endp

  END drvioctl

