  .MODEL tiny
  .CODE

drvsimp proc far

; ⬥砥   , 
; 㤥 १⭮  .   
; ࠩ  ⠭ १⭮,
; ᯮ    砫 ࠩ

DriverEnd:

; ------------------------------------------------
;  ࠩ
; ------------------------------------------------
  dd  0ffffffffh       ; ᫥饣 ࠩ
  dw  8000h            ; ਡ⮢
  dw  dev_strategy     ; 楤 ⥣
  dw  dev_interrupt    ; 楤 뢠
  db  'SIMPLDRV'       ; ன⢠

; ------------------------------------------------
; ணࠬ ⥣
; ------------------------------------------------
dev_strategy:
  mov  cs:req_seg, es
  mov  cs:req_off, bx
  ret

;     

req_seg  dw ?
req_off  dw ?

; ------------------------------------------------
; ࠡ稪 뢠
; ------------------------------------------------
dev_interrupt:

; ࠭塞 ॣ  
  push es 
  push ds
  push ax
  push bx
  push cx
  push dx
  push si
  push di
  push bp

; ⠭ ES:BX   
  mov  ax, cs:req_seg
  mov  es, ax
  mov  bx, cs:req_off

; 砥       㬭
;   , ⮡ ᯮ짮  ⢥ 
;  ⠡ ᮢ ࠡ稪 
  mov  al, es:[bx]+2
  shl  al, 1

  sub  ah, ah        ; 뢥 0  ॣ AH
  lea  di, functions ; ᬥ饭 ⠡
  add  di, ax        ; 塞 ᬥ饭  ⠡
  jmp  word ptr [di] ; 室    ⠡

; ------------------------------------------------
;  㭪権
; ------------------------------------------------
functions   LABEL  WORD    
   dw   initialize
   dw   check_media
   dw   make_bpb
   dw   ioctl_in
   dw   input_data
   dw   nondestruct_in
   dw   input_status
   dw   clear_input
   dw   output_data
   dw   output_verify
   dw   output_status
   dw   clear_output
   dw   ioctl_out
   dw   Device_open
   dw   Device_close
   dw   Removable_media

; 室, ᫨ 㭪  ন
check_media:
make_bpb:
ioctl_in:
nondestruct_in:
input_status:
clear_input:
output_verify:
output_status:
clear_output:
ioctl_out:
Removable_media:
Device_open:
Device_close:
output_data:
input_data:

  or   es:word ptr [bx]+3, 8103h
  jmp  quit

quit:
  or   es:word ptr [bx]+3, 100h
  pop bp
  pop di
  pop si
  pop dx
  pop cx
  pop bx
  pop ax
  pop ds
  pop es
  ret


; ------------------------------------------------
; 楤 뢮  ࠭ ப
; ᨬ  ଠ ASCIIZ
; ------------------------------------------------
Puts proc near
  push si

puts_loop:
  cmp  ds:byte ptr [si],0
  jz   end_puts

  mov   ah, 02h
  mov   dl, ds:byte ptr [si]
  int   21h

  inc si
  jmp puts_loop

end_puts:
  pop si
  ret
Puts endp

hello   db 13,10,'+--------------------------------+'
	db 13,10,'|  *DRVSIMP* (C)Frolov A., 1995  |'
	db 13,10,'+--------------------------------+'
	db 13,10
	db 13,10,'Press any key...'
	db 13,10,0

; ------------------------------------------------
; 믮 樠樨 ࠩ
; ------------------------------------------------
initialize:

; 뢠   ࠩ  
  lea  ax, DriverEnd
  mov  es:word ptr [bx]+14, ax 
  mov  es:word ptr [bx]+16, cs   

; ࠥ ࠭
  mov   dh, 18h
  mov   dl, 80h

  xor   cx, cx
  mov   bh, 7
  xor   al, al
  mov   ah, 6
  int   10h

; ⠭    孨 㣮 ࠭
  mov   bh, 0
  xor   dx, dx
  mov   ah, 2
  int   10h

; 뢮 ᮮ饭
  mov ax, cs
  mov ds, ax
  mov si, offset hello
  call Puts

; ,  짮⥫   
  mov   ax, 0
  int   16h

  jmp  quit
drvsimp   ENDP

  END drvsimp

