// =========================================================
//       
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

// =========================================================
//  FrameWnd
//   
// =========================================================
public class FrameWnd extends Applet
{
  // ,     
  MainFrameWnd fMainFrame;
  
  //     fMainFrame
  Button btnShowFrame;

  //     fMainFrame
  Button btnHideFrame;

  // -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: FrameWnd\r\n" +
      "Author: Alexandr Frolov\r\n" +
	    "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // init
  // ,     
  // -------------------------------------------------------
	public void init()
	{
    //       MainFrameWnd
    fMainFrame = new MainFrameWnd("Main Frame Window");

    //      
    btnShowFrame = new Button("Show Frame Window");
    
    //     
    add(btnShowFrame);
    
    //      fMainFrame 
    btnHideFrame = new Button("Hide Frame Window");

    //     
    add(btnHideFrame);
	}

	// -------------------------------------------------------
  // destroy
  // ,    
  //  
  // -------------------------------------------------------
	public void destroy()
	{
    //   fMainFrame    
    //   
    fMainFrame.dispose();
	}

  // -------------------------------------------------------
  // action
  //  ,   
  //   
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    //   ,    
    Button btn;

    // ,    ,  
    //  
    if(evt.target instanceof Button)
    {
      //    ,  
      btn = (Button)evt.target;

      //      fMainFrame,
      //      show
      if(evt.target.equals(btnShowFrame))
      {
        fMainFrame.show();
      }

      //      fMainFrame,
      //      hide
      else if(evt.target.equals(btnHideFrame))
      {
        fMainFrame.hide();
      }
      //      ,
      //    
      else
        return false;

      return true;
    }

    //     , 
    //    
    return false;
  }
}

// =========================================================
//  MainFrameWnd
//        
// =========================================================
class MainFrameWnd extends Frame
{
  // ,      
  Button btnOK;

  //   
  MenuBar mbMainMenuBar;
  
  //  File
  Menu mnFile;

  //  Help
  Menu mnHelp;

  // -------------------------------------------------------
  // MainFrameWnd
  //  
  // -------------------------------------------------------
  public MainFrameWnd(String sTitle)
  {
    //  ,     
    super(sTitle);
    
    //   
    resize(400, 200);

    //       
    setBackground(Color.yellow);
    setForeground(Color.black);

    //     FlowLayout
    setLayout(new FlowLayout());
    
    //       OK
    btnOK = new Button("OK");
    add(btnOK);

    //   
    mbMainMenuBar = new MenuBar();
    
    //   File
    mnFile = new Menu("File");
    
    //   File
    mnFile.add("New");       //  New
    mnFile.add("-");         // 
    mnFile.add("Exit");      //  Exit
  
    //   Help
    mnHelp = new Menu("Help"); 

    //   Help
    mnHelp.add("Content");   //  Content
    mnHelp.add("-");         // 
    mnHelp.add("About");     //  About

    //   File  Help   
    //   
    mbMainMenuBar.add(mnFile);
    mbMainMenuBar.add(mnHelp);
    
    //     
    setMenuBar(mbMainMenuBar);
  }

  // -------------------------------------------------------
  // paint
  //  paint,   
  //     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //  
    g.setFont(new Font("Helvetica", Font.PLAIN, 12));

    //  
    g.drawString("  Frame", 10, 50);

    //   paint  
    super.paint(g);
	}

  // -------------------------------------------------------
  // handleEvent
  //    
  // -------------------------------------------------------
  public boolean handleEvent(Event evt)
  {
    //    ,
    //      hide
    if(evt.id == Event.WINDOW_DESTROY)
    {
      hide();
      return true;
    }
      
    else
      return super.handleEvent(evt);
  }
  
  // -------------------------------------------------------
  // action
  //  ,   
  //      
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    //   ,    
    Button btn;
  
    //    
    MenuItem mnItem;

    // ,    ,  
    //  
    if(evt.target instanceof Button)
    {
      //    ,  
      btn = (Button)evt.target;

      //     OK,  
      if(evt.target.equals(btnOK))
      {
        hide();
      }
      //      ,
      //    
      else
        return false;

      return true;
    }

    //    
    else if(evt.target instanceof MenuItem)
    {
      //     
      mnItem = (MenuItem)evt.target;

      //    File   Exit,
      //     Java.
      //      
      if(obj.equals("Exit"))
      {
        System.exit(0);
      }

      //    File   New,
      //      
      else if(obj.equals("New"))
      {
        //    
        MessageBox mbox;

        //    
        mbox = new MessageBox("Item New selected",
          this, "Dialog from Frame", true);
        
        //   
        mbox.show();
      }

      //    File   Content,
      //      
      else if(obj.equals("Content"))
      {
        MessageBox mbox;

        mbox = new MessageBox("Item Content selected",
          this, "Dialog from Frame", true);
        
        mbox.show();
      }
      
      //    File   About,
      //      
      else if(obj.equals("About"))
      {
        MessageBox mbox;
        mbox = new MessageBox("Item About selected",
          this, "Dialog from Frame", true);
        
        mbox.show();
      }

      else
        return false;

      return true;
    }
    return false;
  }
}

// =========================================================
//  MessageBox
//        
// =========================================================
class MessageBox extends Dialog
{
  //     
  Label lbMsg;

  //     
  Button btnOK;

  // -------------------------------------------------------
  // MessageBox
  //  
  // -------------------------------------------------------
  public MessageBox(String sMsg, 
    Frame  parent, String  sTitle, boolean  modal)
  {
    //   ,  
    //   Dialog
    super(parent, sTitle, modal);

    //     
    resize(200, 100);

    //     GridLayout
    setLayout(new GridLayout(2, 1));
    
    //       
    lbMsg = new Label(sMsg, Label.CENTER);
    add(lbMsg);

    //       
    //  
    btnOK = new Button("OK");
    add(btnOK);
  }

  // -------------------------------------------------------
  // handleEvent
  //     
  // -------------------------------------------------------
  public boolean handleEvent(Event evt)
  {
    //      ,
    //      hide
    if(evt.id == Event.WINDOW_DESTROY)
    {
      dispose();
      return true;
    }
      
    else
      return super.handleEvent(evt);
  }

  // -------------------------------------------------------
  // action
  //  ,   
  //      
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    //   ,    
    Button btn;
  
    // ,    ,  
    //  
    if(evt.target instanceof Button)
    {
      //    ,  
      btn = (Button)evt.target;

      //    OK,   
      //       
      if(evt.target.equals(btnOK))
      {
        dispose();
      }
      
      //      ,
      //    
      else
        return false;

      return true;
    }
    return false;
  }
}

