#include <windows.h>
#include <stdio.h>
#include <conio.h>

int main()
{
  //   
  HANDLE hHeap;

  // ,     
  //   
  char *lpszBuff;

  // =================================================
  //    
  //    
  // =================================================
    
  //   
  hHeap = HeapCreate(0, 0x1000, 0x2000);

  //   ,    
  //   
  if(hHeap == NULL)
  {
    fprintf(stdout,"HeapCreate: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //      
  __try
  {
    lpszBuff = (char*)HeapAlloc(hHeap, 
      HEAP_GENERATE_EXCEPTIONS, 0x1500);
  }
  
  //   ,  ,
  //   
  __except (EXCEPTION_EXECUTE_HANDLER) 
  {
    fprintf(stdout,"1. HeapAlloc: Exception %lX\n", 
      GetExceptionCode());
  }

  //      
  __try
  {
    strcpy(lpszBuff, "  ");
  }
  
  //    lpszBuff  NULL,
  //  
  __except (EXCEPTION_EXECUTE_HANDLER) 
  {
    fprintf(stdout,"1. strcpy: Exception %lX \n", 
      GetExceptionCode());
  }

  //   ,  
  //   
  __try
  {
    lpszBuff = (char*)HeapAlloc(hHeap, 
      HEAP_GENERATE_EXCEPTIONS, 0x100);
  }
  __except (EXCEPTION_EXECUTE_HANDLER) 
  {
    fprintf(stdout,"2. HeapAlloc: Exception %lX\n", 
      GetExceptionCode());
  }

  __try
  {
    strcpy(lpszBuff, "Test string");
  }
  __except (EXCEPTION_EXECUTE_HANDLER) 
  {
    fprintf(stdout,"2. strcpy: Exception %lX \n", 
      GetExceptionCode());
  }

  //   
  if(lpszBuff != NULL)
    printf("String:>%s<\n", lpszBuff);

  //    
  __try
  {
    HeapReAlloc(hHeap, 
      HEAP_GENERATE_EXCEPTIONS | 
      HEAP_REALLOC_IN_PLACE_ONLY,
      lpszBuff, 150);
  }
  __except (EXCEPTION_EXECUTE_HANDLER) 
  {
    fprintf(stdout,"HeapReAlloc: Exception %lX \n", 
      GetExceptionCode());
  }

  //   
  if(lpszBuff != NULL)
    HeapFree(hHeap, HEAP_NO_SERIALIZE, lpszBuff);
  
  //   
  if(!HeapDestroy(hHeap))
    fprintf(stdout," %ld   \n", 
      GetLastError());
  
  // =================================================
  //    
  //   
  // =================================================

  //      
  lpszBuff = (char*)HeapAlloc(GetProcessHeap(), 
    HEAP_ZERO_MEMORY, 0x1000);
  
  //   ,    
  //    
  if(lpszBuff == NULL)
  {
    fprintf(stdout,"3. HeapAlloc: Error %ld\n", 
      GetLastError());

    getch();
    return 0;
  }

  //   
  strcpy(lpszBuff, "Test string");
  
  //   
  printf("String:>%s<\n", lpszBuff);

  //   
  if(lpszBuff != NULL)
    HeapFree(GetProcessHeap(), 
      HEAP_NO_SERIALIZE, lpszBuff);

  // =================================================
  //    
  //   
  // =================================================
  
  lpszBuff = malloc(1000);

  if(lpszBuff != NULL)
  {
    strcpy(lpszBuff, "Test string");
    printf("String:>%s<\n", lpszBuff);
    free(lpszBuff);
  }

  printf("Press any key...");
  getch();
  return 0;
}

