// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <stdio.h>
#include <string.h>
#include "kbdmsg.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "Keyboard Messages";

//   Client Window
SHORT cxClient;
SHORT cyClient;

//  ᨬ ࠭ 
SHORT cxChar, cyChar, cyDesc;

//  ⮫殢
CHAR  szTitle[] = "VKEY  SCAN  FS    REPT  CHAR";

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "KBDMSG";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  CHAR szMsg[100];
  int nMsgSize;
  HPS hps;
  POINTL ptl;
  RECTL rec;

  CHRMSG cm;
  FONTMETRICS fm;

  switch (msg)
  {
    //  ᮧ   ਫ
    // ।塞  ࠭塞 ਪ 
    //  䨪஢ ਭ ᨬ
    case WM_CREATE:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinGetPS(hWnd);

      // 롨ࠥ  ࠭⢮ ⮡ࠦ 
      //  䨪஢ ਭ ᨬ
      SetCourierFont(hps);

      // ।塞 ਪ 
      GpiQueryFontMetrics(hps, (LONG)sizeof(fm), &fm);

      cxChar = fm.lAveCharWidth;
      cyChar = fm.lMaxBaselineExt;
      cyDesc = fm.lMaxDescender;

      // ⠭ , ࠭  ࠭⢮
      // ⮡ࠦ  㬮砭
      ResetFont(hps);

      // 頥 ࠭⢮ ⮡ࠦ
      WinReleasePS(hps);
      return FALSE;
    }

    //  ६ ᮢ ࠥ ᮤন
    //   뢮 ப  ⠡
    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // 訢 , ॡ 
      WinFillRect(hps, &rec, CLR_WHITE);

      // 롨ࠥ  ࠭⢮ ⮡ࠦ 
      //  䨪஢ ਭ ᨬ
      SetCourierFont(hps);

      // 㥬  ⠡    
      ptl.x = cxChar;
      ptl.y = cyDesc + cyChar;
      GpiCharStringAt(hps, &ptl, strlen(szTitle), szTitle);

      // ⠭ , ࠭  ࠭⢮
      // ⮡ࠦ  㬮砭
      ResetFont(hps);

      // 頥 ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //   ࠧ஢  ࠭塞 
    // ࠧ  ᮢ뢠 
    case WM_SIZE:
    {
      cxClient = SHORT1FROMMP(mp2);
      cyClient = SHORT2FROMMP(mp2);

      //   ॡ ᮢ
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    //  ᮮ饭 ,  짮⥫
    //   ⦨ 
    case WM_CHAR:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinGetPS(hWnd);

      // 롨ࠥ  ࠭⢮ ⮡ࠦ 
      //  䨪஢ ਭ ᨬ
      SetCourierFont(hps);

      // 뤥塞 ࠬ ୮ ᮮ饭
      //  ࠭塞    cm
      cm.chr      = CHARMSG(&msg) ->chr;
      cm.vkey     = CHARMSG(&msg) ->vkey;
      cm.scancode = CHARMSG(&msg) ->scancode;
      cm.cRepeat  = CHARMSG(&msg) ->cRepeat;
      cm.fs       = CHARMSG(&msg) ->fs;

      // ⮢ ப  ⮡ࠦ ࠬ஢
      // ୮ ᮮ饭
      sprintf(szMsg, "%04x  %04x  %04x  %d     %c",
        cm.vkey, cm.scancode, cm.fs, cm.cRepeat,
        cm.fs & KC_CHAR ? cm.chr : ' ');

      // ⮡ࠦ ப   ⠡
      //    
      ptl.x = cxChar;
      ptl.y = 2 * cyChar + cyDesc;

      nMsgSize = strlen(szMsg);
      GpiCharStringAt(hps, &ptl, nMsgSize, szMsg);

      // ⠭ , ࠭  ࠭⢮
      // ⮡ࠦ  㬮砭
      ResetFont(hps);

      // 頥 ࠭⢮ ⮡ࠦ
      WinReleasePS(hps);

      // ⠭ ࠭ ᤢ  
      WinSetRect(hab, &rec,
        0, 2 * cyChar, cxClient, cyClient);

      // 믮塞 ᤢ 孥  
      WinScrollWindow(hWnd, 0, cyChar + cyDesc,
        &rec, NULL, NULLHANDLE, NULL, SW_INVALIDATERGN);

      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

// =================================================
// 롮   䨪஢ ਭ ᨬ
// =================================================

void SetCourierFont(HPS hps)
{
  FATTRS fat;

  // 塞  ᠭ 㦭
  //  

  //  
  fat.usRecordLength = sizeof(FATTRS);

  //  
  strcpy(fat.szFacename ,"Courier");

  // ᯮ㥬 ଠ   뤥
  // , ન  . .
  fat.fsSelection = 0;

  // 뢠,  ⥬ Presentation Manager 
  //  , 室騩  襬 ᠭ
  fat.lMatch = 0L;

  // 樮 ,   ࠢ 0
  fat.idRegistry = 0;

  //  ࠭
  fat.usCodePage = 850;

  //  
  fat.lMaxBaselineExt = 12L;

  // ਭ 
  fat.lAveCharWidth = 12L;

  //   -   ᯮ짮 ୨,
  // 塠⮢ ᨬ  . .
  fat.fsType = 0;

  // ᯮ짮  - ,  ⮡ࠦ
  //  ᬥ訢  䨪
  fat.fsFontUse = FATTR_FONTUSE_NOMIX;

  //  ᪨ , 騩 䨪 1L
  GpiCreateLogFont(hps, NULL, 1L, &fat);

  // 롨ࠥ ᮧ   ࠭⢮ ⮡ࠦ
  GpiSetCharSet(hps, 1L);
}

// =================================================
// ⠭ , ࠭  ࠭⢮
// ⮡ࠦ  㬮砭
// =================================================
void ResetFont(HPS hps)
{
  // 롨ࠥ   㬮砭
  GpiSetCharSet(hps, LCID_DEFAULT);

  // 塞 ᮧ ࠭ 
  //  䨪஬ 1L
  GpiDeleteSetId(hps, 1L);
}

