/**
*.Name      get_ddcb
*
*.Title       DDCB  ᪠
*
*.Descr     㭪 頥   ࠢ
*           ன⢮ DOS DDCB
*
*.Proto     DDCB far *get_ddcb(int device_number)
*
*.Params    device_number -  ᪠,  ண
*                           ॡ  DDCB
*                             ⠪:
*                           0 - ⥪騩 , 1 -   ..
*
*.Return    ⥫  DDCB  ᪠
*
*.Sample    showddcb.c
**/

#include <dos.h>
#include <stdio.h>
#include "sysp.h"

DDCB far *get_ddcb(unsigned char device_number) {

	union  REGS  inregs, outregs;
	struct SREGS segregs;

	inregs.h.ah = 0x32;
	inregs.h.al = 0;
	inregs.h.dl = device_number;
	intdosx( &inregs, &outregs, &segregs );
	if(outregs.h.al == 0xff) return(DDCB far *)0;

	return((DDCB far*)FP_MAKE(segregs.ds,outregs.x.bx));

}
