// =========================================================
//   List Box
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

public class ListBox extends Applet
{
  //      List
  List chBackgroundColor;
  List chForegroundColor;

  //      
  String sSelBackground = new String("Yellow");
  String sSelForeground = new String("Black");
  
  // -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: ListBox\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // init
  // ,     
  // -------------------------------------------------------
	public void init()
	{
    //       
    //  
    chBackgroundColor = new List(6, false);
    chForegroundColor = new List(4, false);

    //     
    add(chBackgroundColor);
    add(chForegroundColor);

    //    
    chBackgroundColor.addItem("Yellow");
    chBackgroundColor.addItem("Green");
    chBackgroundColor.addItem("White");
    chBackgroundColor.addItem("Black");
    chBackgroundColor.addItem("Red");
    chBackgroundColor.addItem("Blue");

    //    
    chForegroundColor.addItem("Black");
    chForegroundColor.addItem("Red");
    chForegroundColor.addItem("Blue");
    chForegroundColor.addItem("Yellow");
    chForegroundColor.addItem("Green");
    chForegroundColor.addItem("White");

    //   
    setBackground(Color.yellow);

    //   
    setForeground(Color.black);
	}

  // -------------------------------------------------------
  // action
  //  ,   
  //   
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    //      ,
    //  
    List ch;

    //    
    ch = (List)evt.target;

    // ,    ,  
    //  
    if(evt.target instanceof List)
    {
      //    
      
      //   
      if(evt.target.equals(chBackgroundColor))
      {
        //     
        //   
        //  
        if(ch.getSelectedIndex() == 0)
          setBackground(Color.yellow);
        
        else if(ch.getSelectedIndex() == 1)
          setBackground(Color.green);

        else if(ch.getSelectedIndex() == 2)
          setBackground(Color.white);

        else if(ch.getSelectedIndex() == 3)
          setBackground(Color.black);
        
        else if(ch.getSelectedIndex() == 4)
          setBackground(Color.red);
        
        else if(ch.getSelectedIndex() == 5)
          setBackground(Color.blue);
      }

      //   
      else if(evt.target.equals(chForegroundColor))
      {
        //     
        //   
        //  
        if(ch.getSelectedIndex() == 0)
          setForeground(Color.black);
        
        else if(ch.getSelectedIndex() == 1)
          setForeground(Color.red);

        else if(ch.getSelectedIndex() == 2)
          setForeground(Color.blue);
      
        else if(ch.getSelectedIndex() == 3)
          setForeground(Color.yellow);

        else if(ch.getSelectedIndex() == 4)
          setForeground(Color.green);
      
        else if(ch.getSelectedIndex() == 5)
          setForeground(Color.white);
      }

      //      ,
      //    
      else
      {
        return false;
      }

      //   
      repaint();

      //   ,    
      return true;
    }

    //     , 
    //    
    return false;
  }

  // -------------------------------------------------------
  // handleEvent
  //  
  // -------------------------------------------------------
  public boolean handleEvent(Event evt)
  {
    //      
    List ls;
  
    //   , 
    //      
    if(evt.id == Event.LIST_SELECT)
    {
      //    
      ls = (List)evt.target;
      
      //     
      if(evt.target.equals(chBackgroundColor))
        sSelBackground = ls.getSelectedItem();

      //     
      else if(evt.target.equals(chForegroundColor))
        sSelForeground = ls.getSelectedItem();

      //       
      //  
      showStatus("(" + sSelBackground 
        + ", " + sSelForeground + ")");
      
      //  
      repaint();

      //   ,   
      //  
      return true;
    }
    
    //   ,    ,
    //   handleEvent   
    else
      return super.handleEvent(evt);
  }
  
  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //  
    g.drawString("     !", 10, 120);

    //     
    //  
    g.drawString("Background:  " + sSelBackground, 10, 160);
    g.drawString("Foreground:  " + sSelForeground, 10, 190);
	}
}
