#include <dos.h>
#include <stdio.h>
#include <conio.h>

typedef struct
{
  unsigned char type;
  unsigned owner;
  unsigned size;
  char reserve[11];
} MCB;
typedef MCB far* LPMCB;

typedef struct
{
  unsigned mcb_seg;
  void far *dev_cb;
  void far *file_tab;
  void far *clock_dr;
  void far *con_dr;
  unsigned max_btbl;
  void far *disk_buf;
  void far *drv_info;
  void far *fcb_tabl;
  unsigned fcb_size;
  unsigned char num_bdev;
  unsigned char lastdriv;
} CVT;
typedef CVT far* LPCVT;

LPMCB get_nmcb(LPMCB);

void main(void)
{
  union REGS regs;
  struct SREGS sregs;
  LPCVT lpCVT;
  LPMCB lpMCB;

  // 砥  ୮ ⠡ 裡
  regs.h.ah = 0x52;
  intdosx(&regs, &regs, &sregs);

  // । 㪠⥫   msb_seg
  lpCVT = (LPCVT)MK_FP(sregs.es, regs.x.bx - 2);

  // 砥 㪠⥫    MCB
  lpMCB = (LPMCB)MK_FP(lpCVT->mcb_seg, 0);

  printf("\n ࠢ  MCB"
    "\n(C) ஫ .., 1995\n"
    "\n MCB   "
    "\n--------- --- -------- ------"
    "\n");

  for(;;)
  {
    // ᫨ ᫥  MCB, 室
    //  横
    if(lpMCB == NULL) break;

    // 뢮 ଠ   MCB
    printf("%Fp %c   %04X     %04X\n",
      lpMCB, lpMCB->type,
      lpMCB->owner, lpMCB->size);

    // 砥  ᫥饣  MCB
    lpMCB=get_nmcb(lpMCB);
  }

  printf("\n  ...");
  getch();
}

// ------------------------------------------
// get_nmcb
// 㭪 頥  ᫥饣 
// MCB  NULL, ᫨  ᫥ 
// ------------------------------------------
LPMCB get_nmcb(LPMCB mcb)
{
  unsigned seg, off;

  // ஢塞 ⨯ 
  if(mcb->type == 'M')
  {
    // 塞  ᫥饣 MCB
    seg = FP_SEG(mcb) + mcb->size + 1;
    off = FP_OFF(mcb);
    return((MCB far *) MK_FP(seg,off));
  }
  else return((LPMCB)NULL);
}


