#include <windows.h>
#include <vfw.h>

static char szAppName[]="MCIWnd";
static HWND hwnd;

// =====================================
//  WinMain
// =====================================
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpszCmdLine, int nCmdShow)
{
   MSG msg;
   WORD wVersion;

   //   Video for Windows
   wVersion = HIWORD(VideoForWindowsVersion());
   if(wVersion < 0x010a)
   {
     MessageBox(NULL, " Video for Windows"
        "  1.1    ",
        "MCIWnd Error", MB_OK | MB_ICONHAND);
     return FALSE;
   }

   //    MCIWND
   hwnd = MCIWndCreate(NULL, hInstance,
            MCIWNDF_SHOWNAME | MCIWNDF_SHOWMODE |
            WS_OVERLAPPEDWINDOW | WS_VISIBLE, NULL);

   if(hwnd == NULL)
     return -1;

   //   
   SetWindowText(hwnd, szAppName);

   //    
   while (GetMessage(&msg,NULL,0,0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);

      if (!IsWindow(hwnd))
          PostQuitMessage(0);
   }
   return msg.wParam;
}
