// DISP.C

// ᥣ  
static unsigned  video_adr = 0xB800;

// ⥪饥 
static   int cur = 0;

//  ⥪饩 ப * 160
static   int line = 0;



// 㭪 disp() ᯮ  뢮 ᨬ  ࠭
// ।⢥ १ ;
// ࠧ㬥,   室  梥⭮
// ⥪⮢ ०  ࠧ襭 25*80 ᨬ;
// 뢮 ந  㫥 ࠭ 

void disp( char outchar,   // ASCII- ᨬ
			  char attr       // ਡ ᨬ
			) {

	static char save_ch = 0, save_attr = 7;

	asm {

		push  es

		mov   bx,cur
		add   bx,line

		mov   ax,video_adr
		mov   es,ax

		mov   al,save_ch
		mov   es:[bx], al
		inc   bx

		mov   al,save_attr
		mov   es:[bx], al
	}

display:

	asm {

		// ஢塞 ࠢ騥 ᨬ CR  LF
		cmp   outchar, 20h
		jb    handl

		// ।塞 ᬥ饭 ⥪饣  
		//mov   bx,cur
		//add   bx,line
		dec   bx

		// ᫨  ࠭ , 頥   ६頥 
		// 孨  㣮 ࠭
		cmp   bx,3840
		jb    send_it

		// 頥 ࠭

		mov   cx,4000
		xor   bx,bx
	}

clr_scr:

	asm {

		mov   es:[bx], 0
		inc   bx
		loop  clr_scr

		mov   line,0
		xor   bx,bx

		// 뢠 ᨬ   ਡ  ⥪饩 樨 ࠭
	}

send_it:

	asm {
		mov   al,BYTE PTR outchar
		mov   es:[bx], al
		inc   cur
		inc   bx
		mov   al,BYTE PTR attr
		mov   es:[bx], al
		inc   cur

		jmp   end_disp

		// ࠡ뢠 ࠢ騥 ᨬ CR, LF, Backspace
	}

handl:

	asm {

		cmp   outchar, 0xd
		jne   next_1
		add   line,160
		jmp   end_disp
	}

next_1:

	asm {

		cmp   outchar, 0xa
		jne   next_2
		mov   cur,0
		jmp   end_disp
	}

next_2:

	asm {
		cmp   outchar, 0x8
		jne   next_3
		dec   cur
		dec   cur
		jmp   end_disp
	}

next_3:

end_disp:

	asm {

		mov   bx,cur
		add   bx,line

		mov   al,es:[bx]
		mov   save_ch,al

		mov   al,5fh
		mov   es:[bx], al
		inc   bx

		mov   al,es:[bx]
		mov   save_attr,al

		mov   al,7
		mov   es:[bx], al

		pop   es
	}
}


void disp_string( char *str, char attr ) {
	int i;

	for( i = 0; str[i]; i++ )
		disp( str[i], attr );
}
