#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <malloc.h>
#include <errno.h>
#include <dos.h>

int main(void);

union REGS inregs, outregs;
struct SREGS segregs;

int main(void) {

	 int io_handle;
	 unsigned count;

	 struct {
		unsigned days;
		unsigned char min;
		unsigned char hours;
		unsigned char sec_per_100;
		unsigned char sec;
	 } clock_buf;

	 // 뢠 ன⢮   CLOCK$

	 if( (io_handle = open("CLOCK$", O_RDWR)) == - 1 ) {

		// ᫨   㤠, 뢮
		//  訡

		printf("訡  ⨨ ன⢠ %d",errno);
		return errno;
	 }

	// 砥 ଠ  ன⢥

	inregs.h.ah = 0x44;
	inregs.h.al = 0;
	inregs.x.bx = io_handle;
	intdos( &inregs, &outregs );
	if(outregs.x.cflag == 1) {

		//  訡 뢮  訡

		printf("IOCTL error %x\n",&outregs.x.ax);
		exit(-1);
	}

	// ⠭  1  5 (४砥 ࠩ
	//   ०  묨

	inregs.x.dx = (outregs.x.dx | 0x0020) & 0x00ff;

	// ⠭ ᫮ ଠ樨  ன⢥

	inregs.h.ah = 0x44;
	inregs.h.al = 1;
	inregs.x.bx = io_handle;
	intdos( &inregs, &outregs );
	if(outregs.x.cflag == 1) {

		//  訡 뢮  訡

		printf("IOCTL error %x\n",&outregs.x.ax);
		exit(-1);
	}

	// 뢮 ᫮ ଠ樨  ன⢥  ࠭

	printf("\nDevice Information:  %04X\n", outregs.x.dx);


	 // ⠥ 6   ன⢠   buf
	 //  ந  筮 ०

	 if((count = read(io_handle, &clock_buf, 6)) == -1) {

		 // ᫨  ⥭ ந諠 訡,
		 // 뢮  

		 printf("訡 ⥭ %d",errno);
	    return errno;
	}

	printf("\n祭  ࠩ ᮢ CLOCK$:"
			 "\n"
			 "\n諮  ᫥ 01.01.80:  %d"
			 "\n:                      %d"
			 "\n:                        %d"
			 "\n㭤:                     %d"
			 "\n  ᥪ㭤:          %d"
			 "\n",
			 clock_buf.days,
			 clock_buf.min,
			 clock_buf.hours,
			 clock_buf.sec,
			 clock_buf.sec_per_100);

	// 뢠 ன⢮

	close(io_handle);

	exit(0);
}

