// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include "slider.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

// 䨪 ॣ஢
HWND hWndCirc1;
HWND hWndCirc2;
HWND hWndCirc3;

//  梥
SHORT sColorR = 255, sColorG = 255, sColorB = 255;

CHAR szAppTitle[] = "Slider Demo";

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "SLIDERDEMO";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS hps;
  RECTL rec;

  switch (msg)
  {
    case WM_CREATE:
    {
      //  ॣ ᭮ 梥
      hWndCirc1 = WinCreateWindow(hWnd,
        WC_CIRCULARSLIDER,
        "", WS_VISIBLE, 0, 0, 0, 0,
        hWnd, HWND_TOP, CIRCSLD1_ID, NULL, NULL);

      // ⠭   祭
      WinSendMsg(hWndCirc1, CSM_SETRANGE,
        MPFROMLONG(0L), MPFROMLONG(255L));

      // ⠭ 蠣   樨
      //  蠣 ࠧ饭 ⮪
      WinSendMsg(hWndCirc1, CSM_SETINCREMENT,
        MPFROMLONG(10L), MPFROMLONG(2L));

      // ⠭ 砫쭮 祭
      WinSendMsg(hWndCirc1, CSM_SETVALUE,
        MPFROMLONG(255L), NULL);

      //  ॣ  梥
      //  ࠨ  ࠬ
      hWndCirc2 = WinCreateWindow(hWnd,
      WC_CIRCULARSLIDER,
        "", WS_VISIBLE, 0, 0, 0, 0,
        hWnd, HWND_TOP, CIRCSLD2_ID, NULL, NULL);

      WinSendMsg(hWndCirc2, CSM_SETRANGE,
        MPFROMLONG(0L), MPFROMLONG(255L));

      WinSendMsg(hWndCirc2, CSM_SETINCREMENT,
        MPFROMLONG(10L), MPFROMLONG(2L));

      WinSendMsg(hWndCirc2, CSM_SETVALUE,
        MPFROMLONG(255L), NULL);

      //  ॣ ᨭ 梥
      //  ࠨ  ࠬ
      hWndCirc3 = WinCreateWindow(hWnd, WC_CIRCULARSLIDER,
        "", WS_VISIBLE, 0, 0, 0, 0,
        hWnd, HWND_TOP, CIRCSLD3_ID, NULL, NULL);

      WinSendMsg(hWndCirc3, CSM_SETRANGE,
        MPFROMLONG(0L), MPFROMLONG(255L));

      WinSendMsg(hWndCirc3, CSM_SETINCREMENT,
        MPFROMLONG(10L), MPFROMLONG(2L));

      WinSendMsg(hWndCirc3, CSM_SETVALUE,
        MPFROMLONG(255L), NULL);

      return FALSE;
    }

    // 塞 ࠧ  ᯮ ॣ஢
    case WM_SIZE:
    {
      WinSetWindowPos(hWndCirc1, HWND_TOP,
      0, 0, 150, 150, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      WinSetWindowPos(hWndCirc2, HWND_TOP,
      150, 0, 150, 150, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      WinSetWindowPos(hWndCirc3, HWND_TOP,
      300, 0, 150, 150, SWP_SIZE | SWP_MOVE | SWP_ZORDER);

      // ᮢ뢠  ਫ
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // ४砥 ⠡ 梥⮢  ० RGB
      GpiCreateLogColorTable(hps,
        LCOL_RESET, LCOLF_RGB, 0L, 0L, NULL);

      // 訢 , ॡ 
      WinFillRect(hps, &rec,
        (ULONG)sColorR << 16 |
        (ULONG)sColorG << 8  | (ULONG)sColorB);

      // 頥 ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    case WM_CONTROL:
    {
      // 饭 諮  ᭮ ॣ
      if(SHORT1FROMMP(mp1) == CIRCSLD1_ID)
      {
        // 뤥塞  饭
        if(SHORT2FROMMP(mp1) == CSN_CHANGED)
        {
           // ⠭  祭 梥
           sColorR = (SHORT)mp2;

           // ᮢ뢠 
           WinInvalidateRect(hWnd, NULL, TRUE);
        }
      }

      // 饭   ॣ
      else if(SHORT1FROMMP(mp1) == CIRCSLD2_ID)
      {
        if(SHORT2FROMMP(mp1) == CSN_CHANGED)
        {
           sColorG = (SHORT)mp2;
           WinInvalidateRect(hWnd, NULL, TRUE);
        }
      }

      // 饭  ᨭ ॣ
      else if(SHORT1FROMMP(mp1) == CIRCSLD3_ID)
      {
        if(SHORT2FROMMP(mp1) == CSN_CHANGED)
        {
           sColorB = (SHORT)mp2;
           WinInvalidateRect(hWnd, NULL, TRUE);
        }
      }
      return 0;
    }
    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

