TITLE	SPLIT.ASM
NAME	SPLIT
PAGE	55,132

P286

; Borland TASM directive for assembly-language syntax
IDEAL

; Borland TASM directive to disable "needs brackets" warning
NOWARN BRK

SEGMENT SPLIT_TEXT WORD PUBLIC 'CODE'
ASSUME	cs:SPLIT_TEXT


; void Split(unsigned split_line)
; 㭪 ࠧ ࠭   . 㭪 ࠡ⠥
; ⮫쪮  EGA  VGA.
; split_line -  ਧ⠫쭮 ࠧ⪨,  ன
; ந室 ࠧ ࠭ ᯫ.

split_line	EQU	[bp+6]

PUBLIC	SPLIT
PROC	SPLIT FAR

	enter	0, 0

	; ⠭ ॣ es  砫 ⨢ 

	xor   ax,ax
	mov   es,ax

	; 砥   ᭮ ॣ ஫ 
	; (3B4h/3D4h),
	;  ஬ ०  樨  ᭮ ॣ
	; ᯮ   ᮬ 3B4h,   梥 -  3D4h

	mov   dx,es:[463h]

	; 塞   ॣ ﭨ 1,
	;  ஬ ०  樨  ॣ ﭨ 1
	; ᯮ   ᮬ 3BAh,   梥 -  3DAh

	add   dx,6


	;  砫 ⭮ ⨪쭮 室 

	in    al,dx
	nop

	; ᫨  D3 ࠢ ,  ந室 
	; ⨪ 室 

	test  al,8
	jz    wait_on

wait_off:

	in    al,dx

	; প

	nop
	test  al,8
	jnz    wait_off

wait_on:

	in    al,dx
	nop
	test  al,8
	jz    wait_on


	; 塞   ᭮ ॣ ஫ 
	; (3B4h/3D4h)

	sub   dx,6

	; 롨ࠥ   ॣ ࠢ 

	mov   al,18h
	out   dx,al

	; 塞   ॣ  ஫ ,
	;  ஬ ०  樨  ॣ 
	; ᯮ   ᮬ 3B5h,   梥 -  3D5h

	inc   dx

	; ।塞  ਧ⠫쭮 ࠧ⪨,  ன ந室
	; ࠧ ࠭ ᯫ

	mov   ax,split_line

	;   EGA ॣ ࠢ  ⮨  9 ,
	;   ⮬  ந室 १ ⥫ ॣ
	; ஫ ;
	;  VGA     , ᯮ  ॣ
	;  ᨬ ⥪

	; 뢠 訥 8 ⮢  ॣ ࠢ 

	out   dx,al

	; 塞   ᭮ ॣ ஫ 

	dec   dx

	; 뢠 㭪 ⥭ 䨣樨 ⥬

	mov   ax,1A00h
	int   10h

	; ᫨ ᫥ 맮 㭪樨 ॣ al  ࠢ 1Ah,  ᯮ㥬
	;   VGA

	cmp   al,1Ah
	je    vga
	jmp   ega

vga:

	; 뢠  al ﭨ ⥫쭣 ॣ

	mov   al,7
	out   dx,al
	inc   dx
	in    al,dx

	; 㥬  D4 ⥫쭮 ࣨ

	mov   bx,split_line
	mov   cl,4
	shl   bh,cl
	and   bh,00010000b

	and   al,11101111b
	or    al,bh
	out   dx,al

	; 뢠  D6 ॣ  ᨬ ⥪

	dec   dx
	mov   al,9
	out   dx,al
	inc   dx
	in    al,dx
	and   al,10111111b
	out   dx,al
	jmp   quit_split

ega:

	mov   bx,split_line
	mov   cl,4
	shl   bh,cl
	and   bh,00010000b

	cmp   dx,3B4h       ; ஬ ०?
	je    default_1Fh

	; ।塞 稥 襭 梥⭮ ᯫ  
	; ४⥫   EGA

	mov   al,es:[488h]
	and   al,0Fh

	;  ४⥫ "off off on on" ?

	cmp   al,3
	je    default_1Fh

	;  ४⥫ "off on on off" ?

	cmp   al,9
	je    default_1Fh

	;  ⥬  ஬  梥 ᯫﬨ, ⥫
	; ॣ  㬮砭 ᮤন 11h

	or    bh,1
	jmp   set_overflow

	;  ⥬  筥 梥 ᯫ   ஬
	; ⥪⮢ ० ⥫ ॣ  㬮砭 ᮤন 1Fh

default_1Fh:

	or    bh,0Fh

	; ⠭ ⥫ ॣ

set_overflow:

	mov   al,07h
	out   dx,al
	inc   dx
	mov   al,bh
	out   dx,al

quit_split:

	leave
	ret 2

ENDP	SPLIT

ENDS	SPLIT_TEXT

END
