;// TSRLIB.ASM - ⥫ 㭪樨

  .MODEL small
  .DATA

  public  _new_int13, _get_int_13
  public  _tsrunload
  public  _set_stack, _restore_stack

;// ⥪  TSR
  extrn   _tsr_stack:near

;//  ࠡ⪨ 뢠 INT 13h.
;//  1,  ࠡ⠥ INT 13
  extrn   _unsafe_flag:near

;//   뢠 INT 13h
  extrn   _old_int13:near

;// 䨪 ணࠬ 
;// ⨯᭮ 뢠 INT 2Fh
  extrn   _tsrid:near

;//  ࠭
old_int13 dd  0
_ds_old   dw  0
_ss_old   dw  0
_sp_old   dw  0

  .CODE

;//-------------------------------------------
;// void tsrunload(void)
;// 㭪 㧪 TSR  
;//-------------------------------------------
_tsrunload proc
   push di
   push si
   push bp

;// ࠭塞 㪠⥫  ⥪
   mov word ptr _ss_old, ss
   mov word ptr _sp_old, sp

;// ࠭塞 ॣ DS
   mov cs:_ds_old, ds

;// ⠭ BX:DX   襭
   mov bx, cs
   mov dx, offset ExitTSR

;// 뢠 ⨯᭮ 뢠,
;// ।   襭
   mov ah, byte ptr _tsrid
   mov al, 01h
   int 2fh

;// ᫨ TSR 訫,    
;//  jmp,  室
;//   TerminateAddr
   jmp short NotExit

ExitTSR:

;// ⠭ DS  ⥪
   mov     ax,cs:_ds_old
   mov     ds,ax

;// ਧ ᯥ譮 ⠫樨
   mov     al,2

;// ⠭ ⥪
   mov     ss, word ptr _ss_old
   mov     sp, word ptr _sp_old

NotExit:
;// ८ࠧ㥬 饭 祭 
;//  ᫮
   cbw

   pop bp
   pop si
   pop di
   ret
_tsrunload endp

;//-------------------------------------------
;// void get_int_13_ptr(void)
;// 뫪 㪠⥫  INT 13
;//   ᥣ 
;//-------------------------------------------
_get_int_13 proc
  push    es
  push    bx

;// ⥫  INT 13h
  les     bx,  dword ptr _old_int13
  mov     word ptr cs:old_int13, bx
  mov     word ptr cs:old_int13 + 2, es

  pop     bx
  pop     es
  ret
_get_int_13 endp

;//-------------------------------------------
;// void set_stack(void)
;// ࠭  ⥪  ⠭
;// ⥪,  㤥 ᯮ짮  TSR
;//-------------------------------------------
_set_stack proc

;// 砥 ᬥ饭  ᥣ
;//  
   pop ax
   pop bx

;// ࠭塞 ⥪
   mov word ptr _ss_old, ss
   mov word ptr _sp_old, sp

;// ⠭ ⥪  TSR
   mov ss, word ptr _tsr_stack + 2
   mov sp, word ptr _tsr_stack

;// 㦠 ⥪  
   push    bx
   push    ax

   ret
_set_stack  endp

;//-------------------------------------------
;// void restore_stack(void) -
;// ⠭ ⥪
;//-------------------------------------------
_restore_stack  proc
;// 砥 ᬥ饭  ᥣ
;//  
  pop cx
  pop bx

;// ࠭塞  ⥪
  mov word ptr _tsr_stack + 2, ss
  mov word ptr _tsr_stack, sp

;// ⠭ ⥪
  mov ss,word ptr _ss_old
  mov sp,word ptr _sp_old

;// 㦠 ⥪  
  push bx
  push cx

  ret
_restore_stack  endp

;//-------------------------------------------
;// void far new_int13(void)
;//  ࠡ稪 INT 13h
;//-------------------------------------------
_new_int13 proc far
  push    ax
  push    ds

;// ⠭ DS  ᥣ  TSR
  mov ax, DGROUP
  mov ds, ax

;// 稢 䫠 _unsafe_flag
  inc word ptr _unsafe_flag

;// ⠭ DS  AX
  pop ds
  pop ax

;// 뢠 뢠
  pushf
  call    cs:old_int13

  push    ax
  push    ds
  mov ax, DGROUP
  mov ds, ax

;// 蠥 䫠 _unsafe_flag
  dec word ptr _unsafe_flag

  pop ds
  pop ax

  ret 2
_new_int13 endp

  end
