// ======================================================
//   wastdrv.dll
//  1.0
//     wast.exe
//  VxD- VXDSRV.386  1.1
// ------------------------------------------------------
// Copyright (C) 1995 Alexandr Frolov
// ======================================================
#define  STRICT
#include <windows.h>
#include <mem.h>
#include <string.h>
#include "wastdrv.hpp"
#include "wastvxd.hpp"

extern "C" LRESULT CALLBACK _export
DriverProc(DWORD  dwDiverId, HDRVR  hDriver,
  UINT msg, LPARAM lParam1, LPARAM lParam2);

extern "C" void FAR PASCAL _export
WinAppStart(WORD wVxDVersion);

BOOL RegisterTask(HTASK hTask);
void UnregisterTask(VXDAPI vxdEntry);

int CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);

void AutoStartWAST(BOOL);

DWORD dwRc = 0L;

//   API VxD-
VXDAPI vxdApi = NULL;

//    wast.exe
HTASK hTaskWAST = NULL;

//      
// 
BYTE szCallbackBuf[350];

//       VM MS-DOS
BYTE szCmd[6][350];

//      szCmd
int nCmdLine = 0;

//    wast.exe
BOOL fTaskRegistered = FALSE;

HINSTANCE hMod;
char szDriverName[] = "wastdrv";
char szTemp[80];

// ========================================================
//  LibMain
// ========================================================
#pragma argsused
int FAR PASCAL
LibMain(HINSTANCE hModule, WORD wDataSegment,
  WORD wHeapSize, LPSTR lpszCmdLine)
{
  hMod = hModule;

  //    API VxD-
  vxdApi = vxdGetDeviceAPI(VXD_ID);
  return TRUE;
}

// ========================================================
//  WEP
// ========================================================
#pragma argsused
int FAR PASCAL WEP(int bSystemExit)
{
  //     DLL-,
  //   ,
  //   VxD-
  if(vxdApi != NULL)
  {
    if(fTaskRegistered)
      UnregisterTask(vxdApi);
  }
  return 1;
}

// ========================================================
//    WinAppStart
// ========================================================
extern "C" void FAR PASCAL _export
WinAppStart(WORD wVxDVersion)
{
  if(wVxDVersion != 0x0101) return;

  _fmemcpy((LPVOID)szCmd[nCmdLine],
           (LPVOID)szCallbackBuf, 65 + 256);

  PostAppMessage(hTaskWAST, WM_STARTWINAPP,
    0, (LPARAM)szCmd[nCmdLine]);

  nCmdLine++;
  if(nCmdLine > 5) nCmdLine = 0;
}

// ========================================================
//  RegisterTask
//   wast.exe
// ========================================================
BOOL RegisterTask(HTASK hTask)
{
  if(vxdApi == NULL)
    return FALSE;

  //   
  fTaskRegistered = TRUE;

  //   
  hTaskWAST = hTask;

  //      
  unsigned sel  = SELECTOROF((LPVOID)WinAppStart);
  unsigned off  = OFFSETOF((LPVOID)WinAppStart);

  //     szCallbackBuf
  unsigned bsel  = SELECTOROF(szCallbackBuf);
  unsigned boff  = OFFSETOF(szCallbackBuf);

  //     
  //  szCallbackBuf  VxD-

  asm mov dx, sel
  asm mov cx, off
  asm mov si, bsel
  asm mov di, boff
  asm mov ax, vxdapiRegisterTask
  (*vxdApi)();

  return TRUE;
}

// ========================================================
//  UnregisterTask
//  VxD-
// ========================================================
void UnregisterTask(VXDAPI vxdEntry)
{
  if(vxdApi == NULL) return;

  //   
  fTaskRegistered = FALSE;

  asm mov ax, vxdapiUnregisterTask
  (*vxdEntry)();
}

// ========================================================
//  vxdGetDeviceAPI
//     API 
// VxD-,  
//   vxd_id
// ========================================================
VXDAPI vxdGetDeviceAPI(unsigned short vxd_id)
{
  unsigned axreg, dxreg;

  asm push  ax
  asm push  bx
  asm push  di
  asm push  es

  asm mov   ax, 0x1684
  asm mov   bx, vxd_id
  asm xor   di, di
  asm mov   es, di
  asm int   0x2f
  asm mov   ax, di
  asm mov   dx, es

  asm pop   es

  asm mov   axreg, ax
  asm mov   dxreg, dx

  asm pop   di
  asm pop   bx
  asm pop   ax

  return((VXDAPI)MAKELP(dxreg, axreg));
}

// ========================================================
// DriverProc
//   
// ========================================================
extern "C" LRESULT CALLBACK _export
DriverProc(
  DWORD  dwDiverId, //   
  HDRVR  hDriver,   // , 
                    //      
  UINT   msg,       //  
  LPARAM lParam1,   //   
  LPARAM lParam2)   //   
{
  switch(msg)
  {
    //    wast.exe
    case UDRV_REGISTERTASK:
    {
      //     ,
      //    FALSE
      if(vxdApi == NULL)
      {
        dwRc = (DWORD)FALSE;
        break;
      }

      //     , 
      //    Windows 
      //   MS-DOS
      if(GetPrivateProfileInt(szDriverName,
        "Enable", 0, "system.ini"))
      {
        dwRc = (DWORD)RegisterTask((HTASK)lParam1);
      }
      break;
    }

    //    wast.exe
    case UDRV_UNREGISTERTASK:
    {
      if(fTaskRegistered)
         UnregisterTask(vxdApi);
      break;
    }

    //  .   , 
    //  
    case DRV_LOAD:
    {
      dwRc = 1l;
      break;
    }

    //      ,
    //      
    case DRV_FREE:
    {
      dwRc = 1l;
      break;
    }

    //  
    case DRV_OPEN:
    {
      dwRc = 1l;
      break;
    }

    //  
    case DRV_CLOSE:
    {
      dwRc = 1l;
      break;
    }

    //  
    case DRV_ENABLE:
    {
      dwRc = 1l;
      break;
    }

    //  
    case DRV_DISABLE:
    {
      dwRc = 1l;
      break;
    }

    //      
    case DRV_INSTALL:
    {
      //   [wastdrv]   system.ini
      //     : "Enable=1"
      WritePrivateProfileString(szDriverName,
        "Enable", "1", "system.ini");

      //    wast.exe  
      // "load="  [windows]  win.ini 
      AutoStartWAST(TRUE);

      //   Windows
      dwRc = DRVCNF_RESTART;
      break;
    }

    //  
    case DRV_REMOVE:
    {
      //    wast.exe 
      // ,  
      if(fTaskRegistered)
         UnregisterTask(vxdApi);

      //   wast.exe 
      // WM_UNLOADWAST,     
      //   
      if(hTaskWAST != NULL)
        PostAppMessage(hTaskWAST, WM_UNLOADWAST, 0, 0l);

      //   wast.exe 
      // 
      hTaskWAST = NULL;

      //   [wastdrv]  system.ini
      //   "Enable=1"  "Enable=0"
      WritePrivateProfileString(szDriverName,
        "Enable", "0", "system.ini");

      //    wast.exe
      AutoStartWAST(FALSE);

      dwRc = 0l;
      break;
    }

    //      
    //   .
    //      ,
    //   1l
    case DRV_QUERYCONFIGURE:
    {
      dwRc = 1l;
      break;
    }

    //  
    case DRV_CONFIGURE:
    {
      //    
      dwRc = DialogBox(hMod, "CONFIG", NULL, DlgProc);
      break;
    }

    //    
    //   DefDriverProc
    default:
    {
      return DefDriverProc(dwDiverId, hDriver,
         msg, lParam1, lParam2);
    }
  }
  return dwRc;
}

// ======================================================
//  DldProc
//     
// ======================================================
#pragma argsused

int CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  static BOOL fWasActive, fChanged;

  switch(msg)
  {
    case WM_INITDIALOG:
    {
      //     "Enable="
      fWasActive = GetPrivateProfileInt(szDriverName,
        "Enable", 0, "system.ini");

      //      
      // ,   
      //  Windows    MS-DOS
      CheckDlgButton(hdlg, ID_ENABLE, fWasActive);

      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        case IDOK:
        {
          //     
          //   
          fChanged = TRUE;

          //     
          // ,   
          if(IsDlgButtonChecked(hdlg, ID_ENABLE))
          {
            if(fWasActive)
              fChanged = FALSE;

            //     system.ini
            WritePrivateProfileString(szDriverName,
              "Enable", "1", "system.ini");

            //    wast.exe
            AutoStartWAST(TRUE);
          }

          //     
          // ,   
          else
          {
            if(!fWasActive)
              fChanged = FALSE;
            WritePrivateProfileString(szDriverName,
              "Enable", "0", "system.ini");
            AutoStartWAST(FALSE);
          }

          //      ,
          //   Windows
          EndDialog(hdlg,
            fChanged ? DRVCNF_RESTART : DRVCNF_CANCEL);
          return TRUE;
        }

        //   
        case IDCANCEL:
        {
          EndDialog(hdlg, DRVCNF_CANCEL);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}

// ======================================================
//  AutoStartWAST
//       
//    wast.exe  
// "load="  [windows]  win.ini
//  ,   wast.exe    
// ======================================================
void AutoStartWAST(BOOL fStart)
{
  static LPSTR lpszSubst;

  //   "load=..."   
  GetProfileString("windows", "load",
    "", szTemp, 80);

  //       wast.exe
  lpszSubst = _fstrstr(szTemp, (LPSTR)"wast");

  //     TRUE, 
  //   
  if(fStart)
  {
    //     ,  
    //   
    if(lpszSubst == NULL)
    {
      lstrcat(szTemp, " ");
      lstrcat(szTemp, "wast");
    }
  }

  //     FALSE, 
  //   wast.exe  
  else
  {
    //     ,   
    //   
    if(lpszSubst != NULL)
    {
      _fstrcpy(lpszSubst, lpszSubst + _fstrlen(lpszSubst));
    }
  }

  //     "load=..."
  WriteProfileString("windows", "load", szTemp);
}
