// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

// ===================================================================
//   COM-
// ===================================================================

#define	STRICT
#include	<windows.h>

BYTE FAR FindCOMPorts( void );

// ===================================================================
//  WinMain
// ===================================================================
#pragma argsused

int PASCAL
WinMain( HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPSTR lpCmdLine,
			int nCmdShow )
{
	char  szMsg[ 60 ] = "";
	BYTE  bFindPort;

	//     COM-
	bFindPort = FindCOMPorts();

	//       
	for (int nBitNum = 0; nBitNum < 8; nBitNum++)
	{
		if (bFindPort & (BYTE) (1 << (BYTE)nBitNum))
		wsprintf( szMsg, "%sCOM%d ", (LPSTR) szMsg, nBitNum + 1 ) ;
	}

	//       
	// COM-
	MessageBox(NULL, szMsg, " COM-:",
				  MB_OK | MB_ICONINFORMATION);

	return 0;
}


// ===================================================================
//  FindCOMPorts
//        
// COM-       
// ===================================================================

BYTE FAR FindCOMPorts( void )
{
	//     
	char	szCommPattern[8];	
	//  COM-
	int	idComDev;
   //    
	BYTE	bFindPort = 0;
	//   nBitNum 
	int	nBitNum = 1;

	//   COM- COM1 - COM8
	for(int i = 0; i < 8; i++) {
		
		wsprintf( szCommPattern, "COM%d", i + 1 ) ;

		//  COM-
		idComDev = OpenComm(szCommPattern, 1024, 1024);

		if (idComDev >= 0)
		{
			//  COM- n  ,  
			//   bFindPort n- 
			bFindPort = bFindPort | nBitNum;

			//  COM-
			CloseComm(idComDev);
		}
		nBitNum <<= 1;
	}

   //  
	return bFindPort;
}


