// -----------------------------------------------------
//  MCISTRVW
//     MCI
// -----------------------------------------------------
#define STRICT
#include <windows.h>
#include <mmsystem.h>

void mciwioError(DWORD dwrc);

#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)
{
  DWORD dwrc;
  BYTE szBuf[256], szBuf1[256];

  //   kaas.wav
  dwrc = mciSendString(
    (LPSTR)"open kaas.wav type waveaudio alias patr wait",
    (LPSTR)szBuf, 256, NULL);
  if(dwrc) mciwioError(dwrc);

  //   ,    
  //   system.ini
  dwrc = mciSendString((LPSTR)"sysinfo patr installname wait",
    (LPSTR)szBuf, 256, NULL);
  if(dwrc) mciwioError(dwrc);

  lstrcat(szBuf, (LPSTR)"\n");

  //      
  dwrc = mciSendString((LPSTR)"info patr product wait",
    (LPSTR)szBuf1, 256, NULL);
  if(dwrc) mciwioError(dwrc);
  lstrcat(szBuf, szBuf1);

  //       
  MessageBox(NULL, szBuf, "MCISTRWV", MB_ICONINFORMATION);

  //     
  dwrc = mciSendString((LPSTR)"play patr wait",
    (LPSTR)szBuf, 256, NULL);
  if(dwrc) mciwioError(dwrc);

  //      
  dwrc = mciSendString((LPSTR)"close patr",
    (LPSTR)szBuf, 256, NULL);
  if(dwrc) mciwioError(dwrc);

  return 0;
}

// -----------------------------------------------------
//  mciwioError
//    
// -----------------------------------------------------
void mciwioError(DWORD dwrc)
{
  BYTE szBuf[MAXERRORLENGTH];

  //   ,    dwrc
  //   ,     
  if(mciGetErrorString(dwrc, (LPSTR)szBuf, MAXERRORLENGTH))
    MessageBox(NULL, szBuf, "MCISTRVW Error",
      MB_ICONEXCLAMATION);

  //       ,  
  //  
  else
    MessageBox(NULL, " ", "MCISTRVW Error",
      MB_ICONEXCLAMATION);
}
