	TITLE	EVGAM.ASM
	NAME	EVGAM
	PAGE	55,132

P286

IDEAL

NOWARN BRK

INCLUDE "evga.inc"

SEGMENT EVGA_TEXT WORD PUBLIC 'CODE'
ASSUME	cs:EVGA_TEXT


; void Set320x400Mode( void )
; ⠭ ० 320400 ᥫ, 256 梥⮢.

PUBLIC	SET320X400MODE
PROC	SET320X400MODE FAR

	enter	0, 0

	; ࠭塞 ॣ di
	push	di

	; ⠭ ⠭ ० 13h (320x200 ᥫ, 256 梥⮢)
	mov	ax,0013h
	int	10h

	; 롨ࠥ ॣ ।  
	mov	dx,SC_INDEX
	mov	al,MMR
	out	dx,al

	; 뢠 祭 ॣ ।  
	inc	dx
	in		al,dx

	; 뢠  D4
	and     al,11110111b

	; ⠭  D3,  ⮬ 몫砥 ० 樨
	;     ᠬ  ࠧ ᫮ 
	or      al,00000100b

	; 뢠  ॣ  祭
	out     dx,al


	; ᫥ 㧪   ॣ  祭 
	;  ᮮ⢥ ० 10h  12h  ᪫祭
	; ⮣,   ᥫ ᮮ⢥   

	; 롨ࠥ ॣ ० ࠡ ᪮ ஫

	mov     dx,GC_INDEX
	mov     al,MDR
	out     dx,al

	; 뢠  祭
	inc     dx
	in      al,dx

	; 몫砥    ᠬ   ᫮,  
	;  ᠬ   ᫮
	and     al,11101111b
	out     dx,al

	; 롨ࠥ ॣ ᬥ蠭 祭 ᪮ ஫
	dec     dx
	mov     al,MIR
	out     dx,al

	; 뢠  祭
	inc     dx
	in      al,dx

	; 뢠  ࠢ騩 楯    ᫮
	and     al,11111101b
	out     dx,al

	; ࠧ蠥      梥⮢ ᫮,
	; 뢠 ᫮ 0fh  ॣ ࠧ襭  梥⮢ ᫮

	mov     dx,SC_INDEX
	mov     al,CPWER
	out     dx,al

	inc     dx
	mov     al,00001111b
	out     dx,al

	; 頥  ࠭ , ⠪  ⠭
	; ন 13h 頥 ⮫쪮  64K

	mov     ax,VGA_SEGMENT
	mov     es,ax

	xor     di,di
	mov     ax,di

	mov     cx,8000h
	cld
	rep     stosb

	; 롨ࠥ ॣ  ᨬ ⥪ ஫ 
	mov     dx,CRTC_INDEX
	mov     al,MSLR
	out     dx,al

	inc     dx
	in      al,dx

	; ⠭  ᨬ ࠢ 
	; !!! and     al,not 1fh

	; 頥  ᪠஢
	and     al,01100000b
	out     dx,al

	; 롨ࠥ ॣ  ન ᨬ
	dec     dx
	mov     al,ULR
	out     dx,al

	; 몫砥 ० 樨    ᫮
	inc     dx
	in      al,dx
	and     al,10111111b
	out     dx,al

	; 롨ࠥ ॣ ࠢ ०
	dec     dx
	mov     al,MCR
	out     dx,al

	; 砥 ⮢ ० 樨
	inc     dx
	in      al,dx
	or      al,01000000b
	out     dx,al

	pop     di

	leave
	ret

ENDP	SET320X400MODE


; void WritePixel(unsigned x, unsigned y, unsigned char color)
; 㭪 ⮡ࠦ  ࠭ ᥫ   न,
; । 梥.
; x - x-न ᥫ (0-319),
; y - y-न ᥫ (0-399),
; color - 梥 ᥫ (0-255).

color	EQU	[bp+6]
y		EQU	[bp+8]
x		EQU	[bp+10]

PUBLIC	WRITEPIXEL
PROC	WRITEPIXEL FAR

	enter	0, 0

	push    di

	mov     cx,x
	mov     dx,y
	mov     bl,color

	mov     ax,VGA_SEGMENT
	mov     es,ax

	mov     ax,( SCREEN_WIDTH / 4 )
	mul     dx

	push    cx

	shr     cx,1
	shr     cx,1

	add     ax,cx
	mov     di,ax

	pop     cx

	and     cl,3
	mov     ah,1
	shl     ah,cl

	mov     dx,SC_INDEX
	mov     al,CPWER
	out     dx,ax

	mov     es:[di],bl

	pop     di

	leave
	ret 6


ENDP	WRITEPIXEL

; unsigned char ReadPixel(unsigned x, unsigned y, unsigned char color)
; 㭪 頥 祭  , ।饣 ᥫ
;  묨 न⠬.
; x - x-न ᥫ (0-319),
; y - y-न ᥫ (0-399).
; Return  梥 ᥫ (0-255).

color	EQU	[bp+6]
y		EQU	[bp+8]
x		EQU	[bp+10]

PUBLIC	READPIXEL
PROC	READPIXEL FAR

	enter	0, 0

	push    si

	mov     cx,x
	mov     dx,y

	mov     ax,VGA_SEGMENT
	mov     es,ax

	mov     ax,( SCREEN_WIDTH / 4 )
	mul     dx

	push    cx

	shr     cx,1
	shr     cx,1

	add     ax,cx
	mov     si,ax

	pop     ax

	and     al,3
	mov     ah,al

	mov     dx,GC_INDEX
	mov     al,RPSR
	out     dx,ax

	mov     al,es:[si]
	xor	  ah,ah

	pop     si

	leave
	ret 6

ENDP	READPIXEL


; void FullScr( unsigned char color )
; 訢 ࠭  梥⮬.
; color - 梥 ࠭ (0-255).

color	EQU	[bp+6]

PUBLIC	FULLSCR
PROC	FULLSCR FAR

	enter	0, 0

	;ࠧ蠥      梥⮢ ᫮

	push    di

	mov     dx,SC_INDEX
	mov     al,CPWER
	out     dx,al

	inc     dx
	mov     al,0fh
	out     dx,al

	mov     ax,VGA_SEGMENT
	mov     es,ax

	xor     di,di
	mov     al,color

	mov     cx,32000
	cld
	rep     stosb

	pop     di

	leave
	ret 2

ENDP FULLSCR

ENDS	EVGA_TEXT

END
