// ===================================================
// ।
// ===================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS

#include <os2.h>
#include <stdio.h>
#include "menumod.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// ===================================================
//  ६
// ===================================================

// 䨪 Anchor-block
HAB  hab;

// 䨪  Frame Window
HWND hWndFrame;

// 䨪  Client Window
HWND hWndClient;

//  ਫ
CHAR szAppTitle[] = "Menu Modification Demo";

// 䨪  Edit
HWND hwndEditMenu;

// 䨪  孥 ஢
HWND hwndMenu;

// ===================================================
//  㭪 ਫ main
// ===================================================

int main()
{
  // 䨪 । ᮮ饭
  HMQ   hmq;

  // ,   뢠 ᮮ饭,
  // 祭  ।
  QMSG  qmsg;

  // ६  ࠭  
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON | FCF_MENU;

  //    
  CHAR  szWndClass[] = "MENUMODDEMO";

  // 樠 ਫ, 室  ᯮ짮
  // 㭪権 Presentation Manager
  hab = WinInitialize(0);

  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);

  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);

  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP, WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);

  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  // ⮦   ਫ
  WinDestroyWindow(hWndFrame);

  // 塞 । ᮮ饭  뢠
  // 㭪 WinTerminate
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);

  // 頥 ࠢ 樮 ⥬
  return(0);
}

// ===================================================
// 㭪   ਫ
// ===================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  // ६   ⮢ ᮮ饭
  CHAR szMsg[100];

  MENUITEM mi;

  switch (msg)
  {
    case WM_CREATE:
    {
      HWND hwndSystemMenu;
      HWND hwndSystemSubMenu;
      SHORT sSysMeniID;

      // ---------------------------------------------
      // 塞 ப  ⥬ 
      // ---------------------------------------------

      // ।塞 䨪  ⥬ 
      hwndSystemMenu = WinWindowFromID(
        WinQueryWindow(hWnd, QW_PARENT), FID_SYSMENU);

      // ।塞 䨪 ⥬ 
      sSysMeniID = (SHORT)WinSendMsg(hwndSystemMenu,
        MM_ITEMIDFROMPOSITION, MPFROMSHORT(0), NULL);

      // ।塞 ࠪ⨪ ⥬ 
      WinSendMsg(hwndSystemMenu, MM_QUERYITEM,
        MPFROMSHORT(sSysMeniID), MPFROMP(&mi));

      // 䨪  ६ ⥬ 
      hwndSystemSubMenu = mi.hwndSubMenu;

      // 塞   ࠧ⥫쭮 
      mi.afStyle = MIS_SEPARATOR;
      mi.afAttribute = 0;
      mi.hwndSubMenu = 0;
      mi.hItem = 0;
      mi.id = -1;
      mi.iPosition = MIT_END;

      // 塞 ࠧ⥫ 
      WinSendMsg(hwndSystemSubMenu, MM_INSERTITEM,
        MPFROMP(&mi), NULL);

      // 塞   塞 ப
      mi.afStyle = MIS_TEXT;
      mi.id = IDM_HELP_ABOUT;

      // 塞 ப Product Information
      WinSendMsg(hwndSystemSubMenu, MM_INSERTITEM,
        MPFROMP(&mi), "Product Information...");

      // ---------------------------------------------
      // 塞 ६  Edit
      // ---------------------------------------------

      // 砥 䨪  
      // 孥 ஢
      hwndMenu = WinWindowFromID(
        WinQueryWindow(hWnd, QW_PARENT), FID_MENU);

      //  ⮥  Edit
      hwndEditMenu = WinCreateMenu(HWND_OBJECT, NULL);

      // ᢠ  Edit 䨪 IDM_EDIT
      WinSetWindowUShort(hwndEditMenu, QWS_ID, IDM_EDIT);

      // 塞 ப  
      mi.iPosition = MIT_END;
      mi.afStyle = MIS_TEXT;
      mi.afAttribute = 0;
      mi.hwndSubMenu = 0;
      mi.hItem = 0;
      mi.id = IDM_EDIT_UNDO;

      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Undo");

      mi.id = IDM_EDIT_REDO;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Redo");

      mi.id = IDM_EDIT_CUT;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "Cu~t");

      mi.id = IDM_EDIT_COPY;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Copy");

      mi.id = IDM_EDIT_PASTE;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Paste");

      mi.id = IDM_EDIT_CLEAR;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "C~lear");

      // 塞 ࠧ⥫ 
      mi.afStyle = MIS_SEPARATOR;
      mi.id = -1;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Duplicate");

      // 塞   ப
      mi.afStyle = MIS_TEXT;
      mi.id = IDM_EDIT_DUPLICATE;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Duplicate");

      mi.id = IDM_EDIT_SELECTALL;
      WinSendMsg(hwndEditMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Select all");

      // 塞  Edit   孥 ஢
      mi.iPosition = 1;
      mi.afStyle = MIS_TEXT | MIS_SUBMENU;
      mi.afAttribute = 0;
      mi.id = IDM_EDIT;
      mi.hwndSubMenu = hwndEditMenu;

      WinSendMsg(hwndMenu, MM_INSERTITEM,
        MPFROMP(&mi), "~Edit");

      return FALSE;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    // 饭 WM_COMMAND 㯠  㭪 ,
    //  짮⥫ 롨ࠥ   ப 
    case WM_COMMAND:
    {
      // 㥬  ப 
      switch(LOUSHORT(mp1))
      {
        case IDM_FILE_NEW:
        case IDM_FILE_OPEN:
        case IDM_FILE_SAVE:
        case IDM_FILE_SAVEAS:

        case IDM_EDIT_UNDO:
        case IDM_EDIT_REDO:
        case IDM_EDIT_CUT:
        case IDM_EDIT_COPY:
        case IDM_EDIT_PASTE:
        case IDM_EDIT_CLEAR:
        case IDM_EDIT_DUPLICATE:
        case IDM_EDIT_SELECTALL:

        case IDM_OPTIONS_FONT_NORMAL:
        case IDM_OPTIONS_FONT_BOLD:
        case IDM_OPTIONS_FONT_ITALIC:
        case IDM_OPTIONS_FONT_UNDERLINE:
        case IDM_OPTIONS_PARA_LEFT:
        case IDM_OPTIONS_PARA_CENTER:
        case IDM_OPTIONS_PARA_RIGHT:
        case IDM_OPTIONS_PARA_JUSTIFY:

        case IDM_HELP_INDEX:
        case IDM_HELP_GENERAL:
        case IDM_HELP_USING:
        case IDM_HELP_KEYS:
        {
           WinMessageBox(HWND_DESKTOP, hWnd,
             "㭪  ॠ",
             szAppTitle, 0, MB_INFORMATION | MB_OK);
          break;
        }

        case IDM_HELP_ABOUT:
        {
           WinMessageBox(HWND_DESKTOP, hWnd,
             "ਫ MenuMod, (C) Frolov A., 1996",
             szAppTitle, 0, MB_INFORMATION | MB_OK);
          break;
        }

        // ᫨   File ࠭ ப Exit,
        // 蠥 ࠡ ਫ
        case IDM_FILE_EXIT:
        {
           WinPostMsg(hWnd, WM_QUIT, 0L, 0L);
           break;
        }
      }
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

