// ==========================================================
// ।
// ==========================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <stdio.h>
#include "wintree.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc1(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY WndProc2(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY WndProcChild(HWND, ULONG, MPARAM, MPARAM);

// ==========================================================
//  ६
// ==========================================================

// 䨪 Anchor-block
HAB  hab;

// 䨪 ࢮ  ண  Frame Window
HWND hWndFrame1;
HWND hWndFrame2;

// 䨪 ୥ 
HWND hWndChildFrame;

// 䨪 ࢮ  ண  Client Window
HWND hWndClient1;
HWND hWndClient2;

// 䨪  Client Window ୥ 
HWND hWndChildClient;

//  
CHAR szAppTitle1[]  = "Windows Tree Demo 1";
CHAR szAppTitle2[]  = "Windows Tree Demo 2";
CHAR szChildTitle[] = "Child Window";

// ==========================================================
//  㭪 ਫ main
// 砥 ࠢ  ᪥ ਫ
// ==========================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //   ᮧ ୥ 
  ULONG flFrameChildFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER;

  //  ᮢ  ᮧ 
  CHAR  szWndClass1[] = "WINTREE1";
  CHAR  szWndClass2[] = "WINTREE2";
  CHAR  szWndClassChild[] = "WINTREECHILD";

  // 樠 ਫ
  hab = WinInitialize(0);

  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);

  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //     ਫ
  fRc = WinRegisterClass(hab, szWndClass1, (PFNWP)WndProc1, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //   ண 
  fRc = WinRegisterClass(hab, szWndClass2,
    (PFNWP)WndProc2, 0, 0);

  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //   ୥ 
  fRc = WinRegisterClass(hab, szWndClassChild,
    (PFNWP)WndProcChild, 0, 0);

  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame1 = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
    &flFrameFlags, szWndClass1, szAppTitle1,
    0, 0, ID_APP_FRAMEWND, &hWndClient1);

  if(hWndFrame1 == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //  ஥ 
  hWndFrame2 = WinCreateStdWindow (HWND_DESKTOP, WS_VISIBLE,
    &flFrameFlags, szWndClass2, szAppTitle2,
    0, 0, ID_APP_FRAMEWND, &hWndClient1);

  if(hWndFrame2 == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ ண ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyWindow(hWndFrame1);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //  ୥ 
  hWndChildFrame = WinCreateStdWindow(hWndFrame2, WS_VISIBLE,
    &flFrameChildFlags, szWndClassChild, szChildTitle,
    0, 0, ID_CHILDWND, &hWndChildClient);

  if(hWndChildFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ ୥ ",
      "訡", 0, MB_ICONHAND | MB_OK);

    WinDestroyWindow(hWndFrame2);
    WinDestroyWindow(hWndFrame1);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ⠭ 砫 ࠧ 
  // ᯮ ୥ 
  WinSetWindowPos(hWndChildFrame, HWND_TOP, 10, 10, 200, 200,
    SWP_ACTIVATE | SWP_SIZE | SWP_SHOW | SWP_MOVE);

  // ⠭ ⮣ࠬ  ୥ 
  WinSendMsg(hWndChildFrame, WM_SETICON,
    (MPARAM)WinQuerySysPointer(HWND_DESKTOP,
    SPTR_APPICON, FALSE), NULL);

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  // ⮦   ਫ
  WinDestroyWindow(hWndFrame1);

  // 塞 । ᮮ饭  뢠
  // 㭪 WinTerminate
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);

  // 頥 ࠢ 樮 ⥬
  return(0);
}

// ==========================================================
// 㭪   ਫ
// ==========================================================

MRESULT EXPENTRY
WndProc1(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  CHAR szMsg[100];

  switch (msg)
  {
    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    case WM_BUTTON1DOWN:
    {
      sprintf(szMsg, "(x, y) = (%ld, %ld)",
        SHORT1FROMMP(mp1), SHORT2FROMMP(mp1));

      WinMessageBox(HWND_DESKTOP, hWnd,  szMsg,
        "न   ( 1)",
        0, MB_INFORMATION | MB_OK);
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

// ==========================================================
// 㭪 ண  ਫ
// ==========================================================

MRESULT EXPENTRY
WndProc2(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  CHAR szMsg[100];

  switch (msg)
  {
    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    case WM_BUTTON1DOWN:
    {
      sprintf(szMsg, "(x, y) = (%ld, %ld)",
        SHORT1FROMMP(mp1), SHORT2FROMMP(mp1));

      WinMessageBox(HWND_DESKTOP, hWnd,  szMsg,
        "न   ( 2)",
        0, MB_INFORMATION | MB_OK);
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

// ==========================================================
// 㭪 ୥ 
// ==========================================================

MRESULT EXPENTRY
WndProcChild(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  CHAR szMsg[100];

  switch (msg)
  {
    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    case WM_BUTTON1DOWN:
    {
      sprintf(szMsg, "(x, y) = (%ld, %ld)",
        SHORT1FROMMP(mp1), SHORT2FROMMP(mp1));

      WinMessageBox(HWND_DESKTOP, hWnd,  szMsg,
        "न   (୥ )",
        0, MB_INFORMATION | MB_OK);
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}



