//============================================================
//  FileDlg
// (c) Frolov G.V., 1996
// E-mail: frolov@glas.apc.org
//============================================================
//     MFC
#include <afxwin.h>

//      
#include <afxdlgs.h>

//============================================================
//  CFileDlgApp
//     CWinApp 
//   CFileDlgApp
//============================================================
class CFileDlgApp : public CWinApp
{
public:
   //     InitInstance,
   //    
   virtual BOOL InitInstance();
};
 
//     CFileDlgApp
CFileDlgApp FileDlgApp;
 
//============================================================
//  InitInstance  CFileDlgApp
//    InitInstance
//  CWinApp.       
// 
//============================================================
BOOL CFileDlgApp::InitInstance()
{
   //    CFileDialog,  
   //    Open
   CFileDialog mFileOpen(TRUE);

   //  pos     
	//   ,    Open
   POSITION pos;
	
   //   msg    
   CString msg;

   //   OFN_ALLOWMULTISELECT, 
   //     
   mFileOpen.m_ofn.Flags |= OFN_ALLOWMULTISELECT;
	
   //    Open   
   //        
   //  
   int result = mFileOpen.DoModal();

   //       Open - 
   //    OK  Cancel
   if(result == IDCANCEL) 
   {
      //        
      //   Cancel   
      // 
      AfxMessageBox("File not selected");
   }

   else if(result == IDOK)
   {
      //     OK,  
      //     GetNextPathName
      pos = mFileOpen.GetStartPosition();

      //     ,   
      //   Open.   
      // ,  
      while(pos != NULL ) {

         //    
         msg = mFileOpen.GetNextPathName( pos );

         //   
         AfxMessageBox("Selected File - " + msg);
      }
   }

   return TRUE;
}
