// =========================================================
//       File 
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.io.*;
import java.util.*;

// =========================================================
//  DirList
//   
// =========================================================
public class DirList
{
  // -------------------------------------------------------
  // main
  // ,     
  // -------------------------------------------------------
  public static void main(String args[])
  {
    //      
    byte bKbdInput[] = new byte[256];

    //   ,  
    //   
    String sDirPath;

    //   
    String sMask;

    //    
    String[] dirlist;

    try
    {
      //      
      //  ,    
      System.out.println("Enter directory path...");
      System.in.read(bKbdInput);
      sDirPath = new String(bKbdInput, 0);
      StringTokenizer st;
      st = new StringTokenizer(sDirPath, "\r\n");
      sDirPath = new String((String)st.nextElement());

      //   
      System.out.println("Enter mask...");
      System.in.read(bKbdInput);
      sMask = new String(bKbdInput, 0);
      st = new StringTokenizer(sMask, "\r\n");
      sMask = new String((String)st.nextElement());
      
      //    File, 
      //  
      File fdir = new File(sDirPath);

      //     ,
      //     
      if(!fdir.exists())
      {      
        System.out.println("Directory not found: " + sDirPath);
      }
      
      //   ,  
      //    
      else
      {
        // ,     
        if(!fdir.isDirectory())
          System.out.println("File " + sDirPath + 
            " is not directory");

        //   ,   
        else
        {
          //    ,   list
          //  
          if(sMask == null)
            dirlist = fdir.list();
          
          //   list,  
          else
            dirlist = fdir.list(new MaskFilter(sMask));

          //   
          for (int i = 0; i < dirlist.length; i++)
          {
            //   ,   ,
            //    File
            File f = new File(sDirPath + "\\" + dirlist[i]);
            
            //     
            if(f.isFile())
              System.out.println(dirlist[i].toLowerCase());
            
            //     
            else
              System.out.println(dirlist[i]);
          }
        }
      }

      System.out.println("Press <Enter> to terminate...");
      System.in.read(bKbdInput);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}

// =========================================================
//  MaskFilter
//    
// =========================================================
class MaskFilter implements FilenameFilter
{
  //     
  String sNameMask;

  // -------------------------------------------------------
  //   MaskFilter
  //   
  // -------------------------------------------------------
  MaskFilter(String sMask)
  {
    //    
    sNameMask = sMask.toUpperCase();
  }

  // -------------------------------------------------------
  //  accept
  //    
  // -------------------------------------------------------
  public boolean accept(File dir, String name)
  {
    //      *,   
    if(sNameMask.equals("*"))
      return true;

    //    ,   true
    return (name.indexOf(sNameMask) != -1);
  }
}
