// =========================================================
//       
//     ImageObserver
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

public class DrawImageObserver extends Applet
{
  //  
  Image BkgImg;
  
  boolean fAllLoaded = false;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: DrawImageObserver\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // -------------------------------------------------------
  // init
  //  init,     
  // -------------------------------------------------------
	public void init()
	{
    //   
    BkgImg = getImage(getCodeBase(), "bkg.gif");
	}

  // -------------------------------------------------------
  // imageUpdate
  // ,     
  // -------------------------------------------------------
  public boolean imageUpdate(Image img, int flags,
    int x, int y, int w, int h)
  {
    // ,     
    fAllLoaded = ((flags & ALLBITS) != 0);

    //  ,  
    if(fAllLoaded)
      repaint();

    //    ,  
    //  imageUpdate  
    return !fAllLoaded;
  }
    
  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.white);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    if(fAllLoaded == false)
    {
      //     
      g.drawString(",  ...",
        20, dimAppWndDimension.height / 2);
    }

    //   
    g.drawImage(BkgImg, 1, 1, 
      dimAppWndDimension.width  - 2, 
      dimAppWndDimension.height - 2, this);
	}
}
