// =========================================================
//    IP    InetAddress
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.net.*;
import java.io.*;
import java.util.*;

// =========================================================
//  InetAddressDemo
//   
// =========================================================
public class InetAddressDemo
{
  // -------------------------------------------------------
  // main
  // ,     
  // -------------------------------------------------------
  public static void main(String args[])
  {
    //      
    byte bKbdInput[] = new byte[256];

    //  
    String sIn;

    //  
    String str;

    //   
    InetAddress iaLocal;

    //     
    byte[] iaLocalIP;

    //     
    InetAddress[] iaRemoteAll;

    try
    {
      //    
      iaLocal = InetAddress.getLocalHost();

      //      
      System.out.println("Local host name: " +
        iaLocal.getHostName());

      //   IP  
      iaLocalIP = iaLocal.getAddress();

      //     IP  
      System.out.println("Local host IP address: " +
        (0xff & (int)iaLocalIP[0]) + "." + 
        (0xff & (int)iaLocalIP[1]) + "." + 
        (0xff & (int)iaLocalIP[2]) + "." + 
        (0xff & (int)iaLocalIP[3]));

      //   IP  , 
      //    
      System.out.println("Local host IP address: " + 
        iaLocal.toString());

      //    ,  
      //   
      System.out.println("Enter remote host name...");
      System.in.read(bKbdInput);
      sIn = new String(bKbdInput, 0);

      //  ,    
      StringTokenizer st;
      st  = new StringTokenizer(sIn, "\r\n");
      str = new String((String)st.nextElement());

      //    IP,   
      // ,      
      iaRemoteAll = InetAddress.getAllByName(str);

      //     
      for(int i = 0; i < iaRemoteAll.length; i++)
      {
        System.out.println("Remote host IP address: " + 
          iaRemoteAll[i].toString());
      }

      System.out.println("Press <Enter> to terminate...");
      System.in.read(bKbdInput);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}

