// =========================================================
//    
//   
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

// =========================================================
//   
// =========================================================
public class MultiTask2 extends Applet
{
  //     
  DrawRectangles m_DrawRectThread = null;

  //     
  DrawEllipse m_DrawEllipseThread = null;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
  public String getAppletInfo()
	{
		return "Name: MultiTask2\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);
	}

  // -------------------------------------------------------
  // start
  //       
  // -------------------------------------------------------
	public void start()
	{
    if (m_DrawRectThread == null)
		{
      m_DrawRectThread = new DrawRectangles(this);
      m_DrawRectThread.start();
		}

    if (m_DrawEllipseThread == null)
		{
      m_DrawEllipseThread = new DrawEllipse(this);
      m_DrawEllipseThread.start();
		}
	}
	
  // -------------------------------------------------------
  // stop
  //  ,      
  // -------------------------------------------------------
	public void stop()
	{
		if (m_DrawRectThread != null)
		{
			m_DrawRectThread.stop();
			m_DrawRectThread = null;
		}

    if (m_DrawEllipseThread == null)
		{
      m_DrawEllipseThread.stop();
			m_DrawEllipseThread = null;
		}
	}

}

// =========================================================
//     
// =========================================================
class DrawRectangles extends Thread
{
  //    
  Graphics g;

  //   
  Dimension dimAppWndDimension;

  // -------------------------------------------------------
  // DrawRectangles
  //   DrawRectangles
  // -------------------------------------------------------
  public DrawRectangles(Applet Appl)
  {
    //     
    g = Appl.getGraphics();

    //     
    dimAppWndDimension = Appl.size();
  }

	// -------------------------------------------------------
  // run
  // ,      
  //       
  // ,   
  // -------------------------------------------------------
	public void run()
	{
    while (true)
		{
      int x, y, width, height;
      int rColor, gColor, bColor;
      
      //    
      //    
      x =      (int)(dimAppWndDimension.width * Math.random());
      y =      (int)(dimAppWndDimension.height * Math.random());
      width  = (int)(dimAppWndDimension.width * Math.random()) / 2;
      height = (int)(dimAppWndDimension.height * Math.random()) / 2;
      
      //      
      rColor = (int)(255 * Math.random());
      gColor = (int)(255 * Math.random());
      bColor = (int)(255 * Math.random());

      //      
      g.setColor(new Color(rColor, gColor, bColor));

      //  
      g.fillRect(x, y, width, height);

      //    50 
      try
			{
				Thread.sleep(50);
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}
}

// =========================================================
//     
// =========================================================
class DrawEllipse extends Thread
{
  //    
  Graphics g;

  //   
  Dimension dimAppWndDimension;

  // -------------------------------------------------------
  // DrawEllipse
  //   DrawEllipse
  // -------------------------------------------------------
  public DrawEllipse(Applet Appl)
  {
    g = Appl.getGraphics();

    //     
    dimAppWndDimension = Appl.size();

  }

	// -------------------------------------------------------
  // run
  // ,      
  //       
  // ,   
  // -------------------------------------------------------
	public void run()
	{
    while (true)
		{
      int x, y, width, height;
      int rColor, gColor, bColor;
      
      //    
      //    
      x =      (int)(dimAppWndDimension.width * Math.random());
      y =      (int)(dimAppWndDimension.height * Math.random());
      width  = (int)(dimAppWndDimension.width * Math.random()) / 2;
      height = (int)(dimAppWndDimension.height * Math.random()) / 2;
      
      //      
      rColor = (int)(255 * Math.random());
      gColor = (int)(255 * Math.random());
      bColor = (int)(255 * Math.random());

      //      
      g.setColor(new Color(rColor, gColor, bColor));

      //  
      g.fillOval(x, y, width, height);

      //    50 
      try
			{
				Thread.sleep(50);
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}
}