// =========================================================
//       
// StreamTokenizer 
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.io.*;

// =========================================================
//  StreamToken
//   
// =========================================================
public class StreamToken
{
  // -------------------------------------------------------
  // main
  // ,     
  // -------------------------------------------------------
  public static void main(String args[])
  {
    //  
    DataOutputStream OutStream;

    //  
    DataInputStream  InStream;

    //      
    byte bKbdInput[] = new byte[256];

    //  ,     
    String sOut;

    try
    {
      //   
      System.out.println("Enter string to parse...");
      
      //        
      System.in.read(bKbdInput);

      //       String
      sOut = new String(bKbdInput, 0);
    
      //     
      OutStream = new DataOutputStream(
        new BufferedOutputStream(
          new FileOutputStream("output.txt")));

      //   sOut   
      OutStream.writeBytes(sOut);

      //   
      OutStream.close();

      //     
      InStream = new DataInputStream(
        new BufferedInputStream(
          new FileInputStream("output.txt")));

      //     
      TokenizerOfStream tos = new TokenizerOfStream();

      //  
      tos.TokenizeIt(InStream);

      //   
      InStream.close();

      System.out.println("Press <Enter> to terminate...");
      System.in.read(bKbdInput);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}

// =========================================================
//  TokenizerOfStream
//     
// =========================================================
class TokenizerOfStream
{
  public void TokenizeIt(InputStream is)
  {
    //   
    StreamTokenizer stok;

    //  
    String str;

    try
    {
      //   
      stok = new StreamTokenizer(is);

      //    ,
      //    ++ (  '/')
      stok.slashSlashComments(true);

      //  ,   '.'   
      stok.ordinaryChar('.');

      //    ,
      //     
      //  
      while(stok.nextToken() != StreamTokenizer.TT_EOF)
      {
        //    
        switch(stok.ttype)
        {
          //   ,   
          //  
          case StreamTokenizer.TT_WORD:
          {
            str = new String("\nTT_WORD >" + stok.sval);
            break;
          }

          //   ,  
          //  
          case StreamTokenizer.TT_NUMBER:
          {
            str = "\nTT_NUMBER >" + Double.toString(stok.nval);
            break;
          }

          //    , 
          //   End of line
          case StreamTokenizer.TT_EOL:
          {
            str = new String("> End of line");
            break;
          }

          //   
          default:
            {
              if((char)stok.ttype == '"')
              {
                str = new String("\nTT_WORD >" + stok.sval);
              }

              else
                str = "> " + String.valueOf((char)stok.ttype);
            }
        }

        //      
        System.out.println(str);
      }
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}