// ===============================================
//  CGI,  
//   cookie
//
// (C)  .., 1998
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         
//         http://www.dials.ccas.ru/frolov
// ===============================================
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//  ,    
char *findCookie(char * szName);
void insertHTML(char * pszFileName, char * pszBuf);

void main(int argc, char *argv[])
{
  char * pszQueryString;
  char * pszCookie;
  char * pszMyCookie;
  int nCount;
  char szBuf[4096];
  char szBuf1[20];
  
  //    cookie
  char szCookieHeader[] = 
    "Set-Cookie: AgainCount=0;\r\nContent-type: text/html\r\n\r\n";
  
  //    cookie
  char szCookieRemoveHeader[] = 
    "Set-Cookie: AgainCount=0;expires=Mon 03-May-1993 12:00:00 GMT;"
    "\r\nContent-type: text/html;\r\n\r\n";

  //    CGI
  pszQueryString = getenv("QUERY_STRING");

  //   Cookie   HTTP
  pszCookie = getenv("HTTP_COOKIE");


  //  
  if(!strcmp(pszQueryString, "go"))
  {
    //  cookie  ,  
    if(pszCookie == NULL)
    {
      //     cookie
      printf("Content-type: text/html\r\n");
      printf(szCookieHeader);
      
      //     
      printf("<HTML><HEAD><TITLE>Cookie demo</TITLE></HEAD><BODY>");
      printf("<H2>Welcome to our page!</H2>");
    }

    else
    {
      //    cookie   AgainCount
      pszMyCookie = findCookie("AgainCount");

      if(pszMyCookie != NULL)
      {
        //        
        //     
        nCount = atoi(pszMyCookie);
        nCount++;
        sprintf(szBuf1, "%d", nCount);

        //     cookie
        printf("Content-type: text/html\r\n");

        strcpy(szBuf, "Set-Cookie: AgainCount=");
        strcat(szBuf, szBuf1);
        strcat(szBuf, ";\r\nContent-type: text/html\r\n\r\n");
        printf(szBuf);

        //     
        printf("<H2>Welcome to our page AGAIN!</H2>");
        
        //   
        printf("<P>Access count: %s",szBuf1);

        //   HTML    JavaScript,
        //     cookie
        insertHTML("script.ht", szBuf);
        printf(szBuf);
      }
    }
  }

  //  cookie
  else if(!strcmp(pszQueryString, "clear"))
  {
    //     cookie
    printf("Content-type: text/html\r\n");
    printf(szCookieRemoveHeader);

    //      cookie
    printf("<HTML><HEAD><TITLE>Cookie demo</TITLE></HEAD><BODY>");
    printf("<P>Cookie Removed");
  }

  printf("</BODY></HTML>");
}

// -----------------------------------------------
// findCookie
//    cookie  
// 
// -----------------------------------------------
char *findCookie(char * szName)
{
  char * pszCookie;
  char * pszBegin;
  char * pszEnd;
  char szBuf[4096];

  //    cookie
  pszCookie = getenv("HTTP_COOKIE");

  if(pszCookie != NULL)
  {
    //     
    strcpy(szBuf, pszCookie);

    //     
    pszBegin = strstr(szBuf, szName);

    if(pszBegin == NULL)
      return NULL;
    
    else
    {
      //   
      pszBegin += strlen(szName) + 1;

      //   ;    
      //  
      pszEnd = strstr(pszBegin, ";");

      if(pszEnd != NULL)
        *pszEnd = 0;

      //   
      return pszBegin;
    }
  }
}

// -----------------------------------------------
// insertHTML
//      
// -----------------------------------------------
void insertHTML(char * pszFileName, char * pszBuf)
{
  HFILE hSrcFile;
  DWORD dwFileSize;

  //  
  hSrcFile = _lopen(pszFileName, OF_READ);

  //   
  dwFileSize = _llseek(hSrcFile, 0, 2);
  
  //     
  _llseek(hSrcFile, 0, 0);

  //    
  _hread(hSrcFile, pszBuf, dwFileSize);

  //    
  pszBuf[dwFileSize] = '\0';

  //  
  _lclose(hSrcFile);
}