#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>

char diskbuf[1024];

int main(void)
{
  unsigned status = 0, i, j;
  struct diskinfo_t di;
  time_t start, end;
  float t1, t2;

  // ⠥  ᥪ ஦
  //  ᨭ஭樨 ⠩
  di.drive    = 0;
  di.head     = 0;
  di.track    = 20;
  di.sector   = 1;
  di.nsectors = 1;
  di.buffer   = diskbuf;

  for(i = 0; i < 3; i++)
  {
    status = _bios_disk(_DISK_READ, &di) >> 8;
     if(!status) break;
  }

  //  ६ 稭 ࠧ ᫥ ⥭
  // ᥪ,  ஢ ६,
  // 室  ࠧ  
  start = clock();

  // 塞 50 ࠧ ⥭ ᥪ஢  ࠬ 1  2
  for(j=0; j<50; j++)
  {
    di.drive    = 0;
    di.head     = 0;
    di.track    = 20;
    di.sector   = 1;
    di.nsectors = 2;
    di.buffer   = diskbuf;

    for(i = 0; i < 3; i++)
    {
      status = _bios_disk(_DISK_READ, &di) >> 8;
      if(!status) break;
    }
  }

  end = clock();
  t1 = ((float)end - start) / CLK_TCK;

  printf("६   0: %5.1f\n",t1);

  // 믮塞  楤  ஦,
  //  뫠 ଠ஢  ᯮᮡ
  di.drive    = 0;
  di.head     = 1;
  di.track    = 20;
  di.sector   = 1;
  di.nsectors = 1;
  di.buffer   = diskbuf;

  for(i = 0; i < 3; i++)
  {
    status = _bios_disk(_DISK_READ, &di) >> 8;
    if(!status) break;
  }

  start = clock();

  for(j=0; j<50; j++)
  {
    di.drive    = 0;
    di.head     = 1;
    di.track    = 20;
    di.sector   = 1;
    di.nsectors = 2;
    di.buffer   = diskbuf;

    for(i = 0; i < 3; i++)
    {
      status = _bios_disk(_DISK_READ, &di) >> 8;
      if(!status) break;
    }
  }
  end = clock();

  t2 = ((float)end - start) / CLK_TCK;

  printf("६   1: %5.1f\n",t2);
  return 0;
}

