#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <dos.h>

//     ,  Windows
//    
//    NotifyProc   
//  C (  C++),   
//  extern "C"   
extern "C" BOOL CALLBACK _export NotifyProc(HGLOBAL hglbl);

#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance,
   HINSTANCE hPrevInstance,
   LPSTR     lpszCmdLine, int nCmdShow)
{
  BYTE szBuf[100];
  HGLOBAL hmemGlDiscard;
  LPVOID  lpvoidGlobal;
  LPVOID  lpvoidGlDiscard;
  DWORD   dwMaxFreeMem;

  //    
  dwMaxFreeMem = GlobalCompact(-1l);

  wsprintf(szBuf, " :\t%lu\n",
        dwMaxFreeMem);
  MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

  //   , 
  //     
  //   
  GlobalNotify((GNOTIFYPROC)NotifyProc);

  //      200000 
  //     
  //   GMEM_NOTIFY
  hmemGlDiscard =
      GlobalAlloc(GMEM_MOVEABLE | GMEM_DISCARDABLE | GMEM_NOTIFY,
      200000l);

  if(hmemGlDiscard != NULL)
  {
    //    ,   
    GlobalDiscard(hmemGlDiscard);

    //   
    lpvoidGlDiscard = GlobalLock(hmemGlDiscard);

    if(lpvoidGlDiscard != (LPVOID) NULL)
    {
      //      
      //  ,   
      //   .   
      //       
      //  
      wsprintf(szBuf, "hmemGlDiscard=\t%04.4X\n"
        "lpvoidGlDiscard=\t%04.4X:%04.4X",
        hmemGlDiscard,
        FP_SEG(lpvoidGlDiscard), FP_OFF(lpvoidGlDiscard));
      MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

      //   
      GlobalUnlock(hmemGlDiscard);
    }
    else
    {
      //      ,
      // ,     
      if(GlobalFlags(hmemGlDiscard) & GMEM_DISCARDED)
      {
         //      , 
         //      
         MessageBox(NULL, "     ",
           "Global Block", MB_OK);

         //    
         hmemGlDiscard = GlobalReAlloc(hmemGlDiscard, 200000l,
           GMEM_MOVEABLE | GMEM_DISCARDABLE);

         //   
         lpvoidGlDiscard = GlobalLock(hmemGlDiscard);

         if(lpvoidGlDiscard != (LPVOID) NULL)
         {
           //     
           //   
           wsprintf(szBuf, "hmemGlDiscard=\t%04.4X\n"
             "lpvoidGlDiscard=\t%04.4X:%04.4X",
             hmemGlDiscard,
             FP_SEG(lpvoidGlDiscard), FP_OFF(lpvoidGlDiscard));
           MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

           //   
           GlobalUnlock(hmemGlDiscard);
         }
         else
         {
           MessageBox(NULL, "   ",
           "Global Block", MB_OK);
         }
      }
    }

    //      
    GlobalFree(hmemGlDiscard);
  }
  else
  {
    MessageBox(NULL, "    ",
      "Global Block", MB_OK);
  }
  return 0;
}