/**
*.Name         timer
*.Title          ᠬ ॠ쭮 ६
*
*.Descr         㭪 ।祭  㦨
*              ⥬ ᮢ ॠ쭮 ६ १
*              뢠 INT 1Ah.
*
*.Proto        int timer(char fn, SYSTIMER *tm)
*
*.Params       char     fn - 믮塞 㭪:
*
*              RTC_GET_TIME      -   ᮢ;
*              RTC_SET_TIME      - ⠭ ;
*              RTC_GET_DATE      -  ;
*              RTC_SET_DATE      - ⠭ ;
*              RTC_SET_ALARM     - ⠭ 㤨쭨;
*              RTC_CLEAR_ALARM   -  㤨쭨.
*
*                   ⠭ ᠭ  䠩 sysp.h
*
*              SYSTIMER tm - , ᮤঠ 
*                             ⠭ ᮢ 
*                             ᮢ:
*
*              typedef struct _SYSTIMER_ {
*
*                 char hour;     // 
*                 char min;      // 
*                 char sec;      // ᥪ㭤
*                 unsigned year; // 
*                 char month;    // 
*                 char day;      // ᫮
*                 char daylight_savings; // 䫠 ࠧ襭
*                                        //  ࠭
*                                        // ( 祭 ०
*                                        //   ࠢ 1)
*
*              } SYSTIMER;
*
*.Return       0   - ᯥ譮 믮 㭪樨;
*              -1  -  ॠ쭮 ६ 
*                     .
*
*.Sample       setalarm.c
**/

#include <stdio.h>
#include <dos.h>
#include "sysp.h"

union REGS reg;

int timer(char fn, SYSTIMER *tm) {

	reg.h.ah = fn;

	switch (fn) {

		case RTC_SET_TIME:

			reg.h.ch = tm->hour;
			reg.h.cl = tm->min;
			reg.h.dh = tm->sec;
			reg.h.dl = tm->daylight_savings;

			break;

		case RTC_SET_DATE:

			reg.x.cx = tm->year;
			reg.h.dh = tm->month;
			reg.h.dl = tm->day;

			break;

		case RTC_SET_ALARM:

			reg.h.ch = tm->hour;
			reg.h.cl = tm->min;
			reg.h.dh = tm->sec;

			break;

	}

	int86(0x1a,&reg,&reg);

	if(reg.x.cflag == 1) return(-1);

	switch (fn) {

		case RTC_GET_TIME:

			tm->hour = reg.h.ch;
			tm->min = reg.h.cl;
			tm->sec = reg.h.dh;

			break;

		case RTC_GET_DATE:

			tm->year = reg.x.cx;
			tm->month = reg.h.dh;
			tm->day = reg.h.dl;

			break;
	}

	return(0);
}

