#include <stdio.h>
#include <malloc.h>
#include <dos.h>
#include "sysp.h"

void main(void);
void main(void) {

  BOOT _far *boot_rec;
  int i,j, k, status, fat_sectors;
  unsigned total_sectors;
  int ffat, root_begin, root_sectors;
  char drive;
  unsigned _far *fat_buffer;
  FITEM _far *root_buffer, _far *rptr;
  char cbuf[128];
  char _far *clust_buffer;
  int cur_clust;

  union REGS reg;
  struct SREGS segreg;


  printf("\n"
			"\n⥭ ⠫ ᪮ ᪠"
			"\n  (C)஫ ., 1991"
			"\n");


// 뢠   ⥭ BOOT-.
//   ᢠ FAR-㪠⥫.

  boot_rec = _fmalloc(sizeof(*boot_rec));

// 訢 ,  ண 室
// 믮 ⥭ 㧮筮 .

  printf("\n"
			"\n 祭 ᪠ (A, B, ...):");

  drive = getche();

// 塞  ᪮

  drive = toupper(drive) - 'A';

// ⠥ 㧮   

  status = getboot((BOOT _far*)boot_rec, drive);

// ᫨ ந諠 訡 (ਬ, ࠢ쭮 㪠
// 祭 ᪠), 蠠 ࠡ ணࠬ

  if(status) {
		printf("\n訡  ⥭ BOOT-ᥪ");
		exit(-1);
  }

// ।塞 ଠ ⠡ FAT

  total_sectors = boot_rec->bpb.totsecs;

// ᫨  ࠡ⠥  ७ ࠧ ᪠,
// 饥 ⢮ ᥪ஢  ᪠ ६ 
// ७ PBP

  if(total_sectors == 0) total_sectors = boot_rec->bpb.drvsecs;

// ଠ FAT ।塞 室  饣
// ⢠ ᥪ஢  ᪮ ᪥

  if(total_sectors > 20740) {
		printf("\nFAT  16-⮢ ଠ");
		ffat=16;
  }
  else {
		printf("\nFAT  12-⮢ ଠ");
		ffat=12;
  }

// ।塞 ⢮ ᥪ஢,  FAT

  fat_sectors = boot_rec->bpb.fatsize;

// 뢠   FAT

  fat_buffer = _fmalloc(fat_sectors * boot_rec->bpb.sectsize);

// 塞  ࢮ ᥪ FAT

  j = boot_rec->bpb.ressecs;

// ⠥ FAT   fat_buffer

// 塞 ॣ஢   맮
// 뢠 DOS INT 25h

	 reg.x.ax = drive;
	 reg.x.bx = FP_OFF(fat_buffer);
	 segreg.ds = FP_SEG(fat_buffer);
	 reg.x.cx = fat_sectors;
	 reg.x.dx = j;
	 int86x(0x25, &reg, &reg, &segreg);

//   ⥪ ⠢襥 ⠬ ᫥
// 맮 뢠 ᫮

	 _asm pop ax

// 塞  ࢮ ᥪ ୥ ⠫

	root_begin = j + fat_sectors * boot_rec->bpb.fatcnt;

// 塞  ୥ ⠫

	root_sectors = (boot_rec->bpb.rootsize * 32) /
						boot_rec->bpb.sectsize;

// 뢠   ୥ ⠫

	root_buffer = _fmalloc(root_sectors * boot_rec->bpb.sectsize);

// ⠥ ୥ ⠫   root_buffer

	 reg.x.ax = drive;
	 reg.x.bx = FP_OFF(root_buffer);
	 segreg.ds = FP_SEG(root_buffer);
	 reg.x.cx = root_sectors;
	 reg.x.dx = root_begin;
	 int86x(0x25, &reg, &reg, &segreg);
	 _asm pop ax

// 뢠 ᮤন ୥ ⠫

	printf("\n"
			 "\n 䠩    .         ६      "
			 "\n------------ ----- ----------  --------  ------- ------");

	for(rptr = root_buffer;;rptr++) {
		printf("\n");

// ਧ  ⠫ - 㫥   砫
//  䠩

		if(rptr->name[0] == 0) break;

// 뢮 ᮤন ਯ 䠩

		for(i=0; i<8; i++) printf("%c",rptr->name[i]);
		printf(".");
		for(i=0; i<3; i++) printf("%c",rptr->ext[i]);
		printf(" %02X    %02d-%02d-%02d  %02d:%02d:%02d ",
			rptr->attr,
			rptr->date.day,
			rptr->date.month,
			rptr->date.year + 1980,
			rptr->time.hour,
			rptr->time.min,
			rptr->time.sec * 2);
		printf(" %-5d   %lu",
			rptr->cluster_nu,
			rptr->size);

	}

// 砥   ⥭ ஢ ⠫

	clust_buffer = _fmalloc(boot_rec->bpb.clustsize
						* boot_rec->bpb.sectsize);

	printf("\n ࢮ  ⠫:");
	gets(cbuf);
	cur_clust = atoi(cbuf);

// ६ k ᯮ  ⢥ 䫠.
//  ࢮ ᬮ ⠫  祭 ࠢ 0,
// ⥬  ६ ⠭  1.

	k=0;

	for(;;) {

// ࠭塞   ⠫

		j=cur_clust;

// 塞  ᫥饣 , ।
// ⠫

		cur_clust = fat(fat_buffer, ffat, cur_clust);
		printf("%d ",cur_clust);

// ⠥    clust_buffer

		 reg.x.ax = drive;
		 reg.x.bx = FP_OFF(clust_buffer);
		 segreg.ds = FP_SEG(clust_buffer);
		 reg.x.cx = boot_rec->bpb.clustsize;
		 reg.x.dx = root_begin + root_sectors
						+ ((j-2)*boot_rec->bpb.clustsize);
		 int86x(0x25, &reg, &reg, &segreg);
		 _asm pop ax

// 뢠 ᮤন ⠫

		 rptr = (FITEM _far *)clust_buffer;

//  ਯ  ⠫ 㪠뢠 
//   ⠫.    ࢮ ਯ
// 室 ப ".       ".  䠪  ᯮ짮
//  ஢ન ⠫. ᫨   訡 㪠
//  ,  ਭ饣 ⠫,
// ணࠬ  ࠡ  ᮮ饭  訡.

		 if(k == 0) {
			k=1;
			if(strncmp(rptr->name,".       ",8) != 0) {
				printf("\n  ⠫ !");
				exit(-1);
			}
		 }

		 printf("\n"
			 "\n 䠩    .         ६      "
			 "\n------------ ----- ----------  --------  ------- ------");

		 for(;;rptr++) {
			printf("\n");

// ਧ  ⠫ - 㫥   砫
//  䠩

			if(rptr->name[0] == 0) break;

// 뢮 ᮤন ਯ 䠩

			for(i=0; i<8; i++) printf("%c",rptr->name[i]);
			printf(".");
			for(i=0; i<3; i++) printf("%c",rptr->ext[i]);
			printf(" %02X    %02d-%02d-%02d  %02d:%02d:%02d ",
				rptr->attr,
				rptr->date.day,
				rptr->date.month,
				rptr->date.year + 1980,
				rptr->time.hour,
				rptr->time.min,
				rptr->time.sec * 2);
			printf(" %-5d   %lu",
				rptr->cluster_nu,
				rptr->size);

		}

// ᫨   - ᫥  । ⠫,
// 蠥 ࠡ ணࠬ

		if((cur_clust == 0xfff) || (cur_clust == 0xffff)) break;

	}

// ᢮ 

  _ffree(root_buffer);
  _ffree(boot_rec);
  _ffree(fat_buffer);
  _ffree(clust_buffer);
}
