// ==================================================
// DLL- DLLDemo.DLL
//     
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#include <windows.h>
#include <windowsx.h>
#include "dlldemo.h"

//  ,   
//      NULL, 
//       
HWND hwndFinded;

// -------------------------------------------------
//  DLLEntryPoint
//   DLL-
// -------------------------------------------------
BOOL WINAPI DLLEntryPoint(
  HMODULE hModule,      //  
  DWORD   fdwReason,    //    DLLEntryPoint
  LPVOID  lpvReserved)  // 
{
  switch(fdwReason)
  {
    //   
    case DLL_PROCESS_ATTACH:
    {
      MessageBox(NULL, "Process attached", "DLL Demo", MB_OK);
      break;
    }

    //   
    case DLL_THREAD_ATTACH:
    {
      MessageBox(NULL, "Thread attached", "DLL Demo", MB_OK);
      break;
    }

    //  
    case DLL_PROCESS_DETACH:
    {
      MessageBox(NULL, "Process detached", "DLL Demo", MB_OK);
      break;
    }

    //  
    case DLL_THREAD_DETACH:
    {
      MessageBox(NULL, "Thread detached", "DLL Demo", MB_OK);
      break;
    }
  }
  return TRUE;
}

// -------------------------------------------------
//  FindApplicationWindow
//       
// -------------------------------------------------
HWND FindApplicationWindow(LPSTR lpszWindowTitle)
{
  //      ,
  //     
  //  lpszWindowTitle
  EnumWindows(EnumWindowsProc, (LPARAM)lpszWindowTitle);
      
  //     hwndFinded,
  //     
  // EnumWindowsProc     
  return hwndFinded;
}


// -------------------------------------------------
//  EnumWindowsProc
// -------------------------------------------------
BOOL CALLBACK EnumWindowsProc(
  HWND   hwnd,   //   
  LPARAM lParam) //    
{
  //     
  char szBuf[512];

  //   
  GetWindowText(hwnd, szBuf, 512);
  
  //    ,   
  //    EnumWindowsProc   lParam
  if(!strcmp((LPSTR)lParam, szBuf))
  {
    //   ,  
    //      hwndFinded
    hwndFinded = hwnd; 
    
    //    
    return FALSE;
  }
  
  //    ,  
  else
  {
    //     hwndFinded
    //  NULL.   ,  
    //      
    hwndFinded = NULL;    

    //      TRUE
    return TRUE;
  }
}


