#include <windows.h>
#include <stdio.h>
#include <conio.h>

//  -,  
//   ,   
HANDLE hEvent;
HANDLE hEventTermination;

//  -     
CHAR lpEventName[] = 
  "$MyVerySpecialEventName$";

//  -   
CHAR lpEventTerminationName[] = 
  "$MyVerySpecialEventTerminationName$";

//     
CHAR lpFileShareName[] = 
  "$MyVerySpecialFileShareName$";

//     
HANDLE hFileMapping;

//     
LPVOID lpFileMap;

int main()
{
  CHAR chr;

  printf("Mapped and shared file, client process\n"
    "(C) A. Frolov, 1996, Email: frolov@glas.apc.org\n"
    "\n\nPress <ESC> to terminate...\n");
  
  //  -   
  //   
  hEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, lpEventName);
  
  if(hEvent == NULL)
  {
    fprintf(stdout,"OpenEvent: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //  -   
  //   
  hEventTermination = OpenEvent(EVENT_ALL_ACCESS, 
    FALSE, lpEventTerminationName);
  
  if(hEventTermination == NULL)
  {
    fprintf(stdout,"OpenEvent (Termination): Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //  -
  hFileMapping = OpenFileMapping(
    FILE_MAP_READ | FILE_MAP_WRITE, FALSE, lpFileShareName);

  //    ,   
  if(hFileMapping == NULL)
  {
    fprintf(stdout,"OpenFileMapping: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //     .
  //   lpFileMap    
  //   
  lpFileMap = MapViewOfFile(hFileMapping, 
    FILE_MAP_READ | FILE_MAP_WRITE, 0, 0, 0);

  //     ,
  //   
  if(lpFileMap == 0)
  {
    fprintf(stdout,"MapViewOfFile: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //  .     ,
  //     <ESC>, 
  //   27
  while(TRUE)
  {
    //    
    chr = getche();
    
    //    <ESC>,  
    if(chr == 27)
      break;

    //     ,
    //   
    *((LPSTR)lpFileMap) = chr;

    //  -  
    // 
    SetEvent(hEvent);
  }
 
  //      
  //       
  //       
  SetEvent(hEvent);
  SetEvent(hEventTermination);
  
  //   -
  CloseHandle(hEvent);
  CloseHandle(hEventTermination);

  //   
  UnmapViewOfFile(lpFileMap);

  //   
  // -
  CloseHandle(hFileMapping);

  return 0;
}

