#include <windows.h>
#include <stdio.h>
#include <conio.h>

//  -,  
//   ,   
HANDLE hEventChar;
HANDLE hEventTermination;
HANDLE hEvents[2];

//  -     
CHAR lpEventName[] = 
  "$MyVerySpecialEventName$";

//  -   
CHAR lpEventTerminationName[] = 
  "$MyVerySpecialEventTerminationName$";

//     
CHAR lpFileShareName[] = 
  "$MyVerySpecialFileShareName$";

//     
HANDLE hFileMapping;

//     
LPVOID lpFileMap;

int main()
{
  DWORD dwRetCode;

  printf("Mapped and shared file, server process\n"
    "(C) A. Frolov, 1996, Email: frolov@glas.apc.org\n");
  
  //  -   
  //   ,    
  hEventChar = CreateEvent(NULL, FALSE, FALSE, lpEventName);
  
  //   ,     ,
  //     
  if(hEventChar == NULL)
  {
    fprintf(stdout,"CreateEvent: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //  -    ,
  // ,   EVENT   
  if(GetLastError() == ERROR_ALREADY_EXISTS)
  {
    printf("\nApplication EVENT already started\n"
      "Press any key to exit...");
    getch();
    return 0;
  }

  //  -   
  //    
  hEventTermination = CreateEvent(NULL, 
    FALSE, FALSE, lpEventTerminationName);

  if(hEventTermination == NULL)
  {
    fprintf(stdout,"CreateEvent (Termination): Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }
  
  //  -
  hFileMapping = CreateFileMapping((HANDLE)0xFFFFFFFF,
    NULL, PAGE_READWRITE, 0, 100, lpFileShareName);

  //    ,   
  if(hFileMapping == NULL)
  {
    fprintf(stdout,"CreateFileMapping: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }

  //     .
  //   lpFileMap    
  //   
  lpFileMap = MapViewOfFile(hFileMapping, 
    FILE_MAP_READ | FILE_MAP_WRITE, 0, 0, 0);

  //     ,
  //   
  if(lpFileMap == 0)
  {
    fprintf(stdout,"MapViewOfFile: Error %ld\n", 
      GetLastError());
    getch();
    return 0;
  }
  
  //    
  //   WaitForMultipleObjects
  hEvents[0] = hEventTermination;
  hEvents[1] = hEventChar;
  
  //  .     
  //    
  while(TRUE)
  {
    //      :
    //   -   ;
    //   -   
    dwRetCode = WaitForMultipleObjects(2, 
      hEvents, FALSE, INFINITE);

    //        ,
    //     ( 
    // )    ,  
    if(dwRetCode == WAIT_ABANDONED_0     ||
       dwRetCode == WAIT_ABANDONED_0 + 1 ||
       dwRetCode == WAIT_OBJECT_0        ||
       dwRetCode == WAIT_FAILED)
      break;

    //      
    //  ,    
    // ,      
    putch(*((LPSTR)lpFileMap));
  }
 
  //   -  
  CloseHandle(hEventChar);
  CloseHandle(hEventTermination);

  //   
  UnmapViewOfFile(lpFileMap);

  //   
  // -
  CloseHandle(hFileMapping);

  return 0;
}

