PRJ    = kbdmsg
CC     = icc /Ti /c /Ge /Gd- /Se /Re /ss /Gm+
LFLAGS = /NOFREE /NOE /NOD /ALIGN:16 /EXEPACK /M /BASE:0x10000 
LINK   = ILINK  $(LFLAGS)
LIBS   = CPPOM30 + OS2386
HEADERS  = $(PRJ).h
ALL_OBJ  = $(PRJ).obj

.SUFFIXES: .rc .res .obj .lst .c

.c.lst:
    $(CC) -Fc$*.lst -Fo$*.obj $*.c

.c.obj:
    $(CC) -Fo$*.obj $*.c

.rc.res:
        rc -r $*.rc

all: $(PRJ).exe

$(PRJ).l: $(PRJ).mak
    echo $(ALL_OBJ)  >  $(PRJ).l
    echo $(PRJ).exe  >> $(PRJ).l
    echo $(PRJ).map  >> $(PRJ).l
    echo $(LIBS)     >> $(PRJ).l
    echo $(PRJ).def  >> $(PRJ).l

$(PRJ).res: $(PRJ).rc $(PRJ).ico $(PRJ).h

$(PRJ).obj: $(PRJ).c $(HEADERS)

$(PRJ).exe: $(ALL_OBJ)  $(PRJ).def $(PRJ).l $(PRJ).res
    $(LINK) @$(PRJ).l
    rc -p -x $(PRJ).res $(PRJ).exe