// =========================================================
//   
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

//    Vector
import java.util.*;

public class LineDraw extends Applet
{
  //      
  Dimension dmDown;

  //      
  Dimension dmUp;

  //    
  Dimension dmPrev;
  
  //    
  boolean bDrawing;

  //   
  Vector lines;

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: LineDraw\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Author: Alexandr Frolov\r\n" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // init
  // ,     
  // -------------------------------------------------------
	public void init()
  {
    //   
    bDrawing = false;

    //      
    lines = new Vector();
  }

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
  public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);
    
    //    ,   
    //    lines
    for (int i=0; i < lines.size(); i++) 
    {
	    //    
      Rectangle p = (Rectangle)lines.elementAt(i);

      //  
      g.drawLine( p.width, p.height, p.x, p.y);
    }
   
    //   
    bDrawing = false;
	}

  // -------------------------------------------------------
  // mouseDown
  //    
  // -------------------------------------------------------
	public boolean mouseDown(Event evt, int x, int y)
	{
    //     1,  
    //   
    if(evt.clickCount > 1)
    {
      //      lines
      lines.removeAllElements();

      //   
      repaint();

      return true;
    }

    //     
    dmDown = new Dimension(x, y);

    //      
    //     
    //   
    dmPrev = new Dimension(x, y);

    //   
    bDrawing = false;
		return true;
	}

  // -------------------------------------------------------
  // mouseUp
  //   
  // -------------------------------------------------------
  public boolean mouseUp(Event evt, int x, int y)
	{
    // ,    
    if(bDrawing)
    {
      //    , 
      //     lines
      
      //    
      dmUp = new Dimension(x, y);
      
      //    
      lines.addElement(
        new Rectangle(dmDown.width, dmDown.height, x, y));
      
      //   
      repaint();

      //   
      bDrawing = false;
    }
    return true;
	}

  // -------------------------------------------------------
  // mouseDrag
  //      
  // -------------------------------------------------------
	public boolean mouseDrag(Event evt, int x, int y)
	{
    //      
    Graphics g = getGraphics();

    //   
    bDrawing = true;

    //     
    // (   )
    g.setColor(Color.yellow);

    g.drawLine(dmDown.width, dmDown.height, 
      dmPrev.width, dmPrev.height);

    //     
    g.setColor(Color.black);
    g.drawLine(dmDown.width, dmDown.height, x, y);

    //    ,
    //      
    dmPrev = new Dimension(x, y);
		return true;
	}

  // -------------------------------------------------------
  // mouseMove
  //      
  // -------------------------------------------------------
	public boolean mouseMove(Event evt, int x, int y)
	{
    //   
    bDrawing = false;
		return true;
	}
}
