// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <stdio.h>
#include "mousemov.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "Mouse Mover";

// न     
//   
SHORT cxPoint;
SHORT cyPoint;

// न     ᪠
//   
SHORT cxNewPoint;
SHORT cyNewPoint;

// ਧ 砫  ६饭 
BOOL  fDrag = FALSE;

// ,  㤥 ⮡ࠦ  
CHAR pszText[] =
  "६頩      ";

// 䨪 㪠⥫ 
HPOINTER hptr, hptr1;

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  //   ᮧ  , ⥬ ,
  //  ⠪   樨  ᨬ樨
  ULONG flFrameFlags = FCF_SIZEBORDER |
    FCF_SHELLPOSITION | FCF_TASKLIST | FCF_ICON;

  //    
  CHAR  szWndClass[] = "MOUSEMOV";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS hps;
  POINTL ptl;
  RECTL rec;
  SWP swp;

  switch (msg)
  {
    //  ᮧ  㦠 㪠⥫ 
    case WM_CREATE:
    {
      hptr  = WinLoadPointer(HWND_DESKTOP,
        NULLHANDLE, ID_APP_POINTER);
      hptr1 = WinLoadPointer(HWND_DESKTOP,
        NULLHANDLE, ID_APP_POINTER1);
      return FALSE;
    }

    //  㭨⮦  㤠塞 㪠⥫ 
    case WM_DESTROY:
    {
      WinDestroyPointer(hptr);
      WinDestroyPointer(hptr1);
      return 0;
    }

    //  짮⥫   
    // ,  न  
    // 뤢  ਫ  । 
    case WM_BUTTON1DOWN:
    {
      cxPoint = MOUSEMSG(&msg) -> x;
      cyPoint = MOUSEMSG(&msg) -> y;

      // 塞 ᯮ    Z
      WinSetWindowPos(hWndFrame, HWND_TOP,
        0, 0, 0, 0, SWP_ZORDER);

      // ⠭ ਧ ६饭
      //   ਫ
      fDrag = TRUE;
      return 0;
    }

    //  ᪠    뢠
    // ਧ ६饭 
    case WM_BUTTON1UP:
    {
      // 뢠 ਧ ६饭
      //   ਫ
      fDrag = FALSE;
      return 0;
    }

    //  ᮮ饭 室  ६饭 
    // .
    case WM_MOUSEMOVE:
    {
      // ᫨ 祭 ਧ ६饭, ।塞
      //  न   । 
      if(fDrag)
      {
        // 롨ࠥ 㪠⥫   ⮩ 㪨
        WinSetPointer(HWND_DESKTOP, hptr1);

        cxNewPoint = MOUSEMSG(&msg) -> x;
        cyNewPoint = MOUSEMSG(&msg) -> y;

        // ।塞 ⥪騥 न 
        WinQueryWindowPos(hWndFrame, &swp);

        // । 
        WinSetWindowPos(hWndFrame, HWND_TOP,
          swp.x + (cxNewPoint - cxPoint),
          swp.y + (cyNewPoint - cyPoint),
          0, 0, SWP_MOVE);
      }

      else
        // 롨ࠥ 㪠⥫   ⮩ 㪨
        WinSetPointer(HWND_DESKTOP, hptr);

      return (MRESULT)TRUE;
    }

    //  ⢥  ᮮ饭 WM_PAINT 뢮
    //  業  ப ⥪
    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // ।塞 ࠧ  
      WinQueryWindowRect(hWnd, &rec);

      // 뢮 ⥪  業 
      WinDrawText(hps, -1, pszText, &rec, 0L, 0L,
        DT_WORDBREAK | DT_CENTER | DT_VCENTER |
        DT_TEXTATTRS | DT_ERASERECT);

      // ᢮ ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //   ࠧ஢  ࠭塞 
    // ࠧ  ᮢ뢠 
    case WM_SIZE:
    {
      //   ࠧ஢  믮塞 
      // ᮢ
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    // ᫨ 짮⥫ ᤥ  饫箪 
    //  , 蠥 ࠡ ਫ
    case WM_BUTTON1DBLCLK:
    {
      WinPostMsg(hWnd, WM_QUIT, 0L, 0L);
      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}


