// =================================================
// ।
// =================================================

#define INCL_WIN
#define INCL_GPI
#define INCL_WINDIALOGS
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include "pointer.h"

// ⨯ 㭪樨  ਫ
MRESULT EXPENTRY WndProc(HWND, ULONG, MPARAM, MPARAM);

// =================================================
//  ६
// =================================================

HAB  hab;
HWND hWndFrame;
HWND hWndClient;

CHAR szAppTitle[] = "Mouse Poiter";

//  ⮣ࠬ  
LONG cxPointer, cyPointer;

//   Client Window
LONG cxClient, cyClient;

// =================================================
//  㭪 ਫ main
// =================================================

int main()
{
  HMQ   hmq;
  QMSG  qmsg;
  BOOL  fRc;

  //   ᮧ  Frame Window
  ULONG flFrameFlags =
    FCF_SYSMENU    | FCF_TITLEBAR      | FCF_MINMAX   |
    FCF_SIZEBORDER | FCF_SHELLPOSITION | FCF_TASKLIST |
    FCF_ICON;

  //    
  CHAR  szWndClass[] = "MOUSEPOINTER";

  hab = WinInitialize(0);
  if(hab == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡 樠樨",
      "訡", 0, MB_ICONHAND | MB_OK);
    return(-1);
  }

  //  । ᮮ饭
  hmq = WinCreateMsgQueue(hab, 0);
  if(hmq == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ । ᮮ饭",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinTerminate(hab);
    return(-1);
  }

  //    ਫ
  fRc = WinRegisterClass(hab, szWndClass,
    (PFNWP)WndProc, 0, 0);
  if(fRc == FALSE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ॣ樨   ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  //    ਫ
  hWndFrame = WinCreateStdWindow (HWND_DESKTOP,
    WS_VISIBLE,
    &flFrameFlags, szWndClass, szAppTitle,
    0, 0, ID_APP_FRAMEWND, &hWndClient);
  if(hWndFrame == NULLHANDLE)
  {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
      "訡  ᮧ  ",
      "訡", 0, MB_ICONHAND | MB_OK);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

    return(-1);
  }

  // ⠭  ⮣ࠬ
  //   
  WinSendMsg(hWndFrame, WM_SETICON,
    (MPARAM)WinQuerySysPointer(HWND_DESKTOP,
          SPTR_ICONINFORMATION, FALSE), NULL);

  // ᪠ 横 ࠡ⪨ ᮮ饭
  while(WinGetMsg(hab, &qmsg, 0, 0, 0))
    WinDispatchMsg(hab, &qmsg);

  WinDestroyWindow(hWndFrame);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return(0);
}

// =================================================
// 㭪   ਫ
// =================================================

MRESULT EXPENTRY
WndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  HPS hps;
  RECTL rec;
  POINTL ptl;
  LONG x, y;
  HPOINTER hptr;
  LONG xMouse, yMouse;

  switch (msg)
  {
    case WM_CREATE:
    {
      // ।塞  ࠭塞 ࠧ ⮣ࠬ
      cxPointer = WinQuerySysValue(HWND_DESKTOP,
        SV_CXPOINTER);

      cyPointer = WinQuerySysValue(HWND_DESKTOP,
        SV_CYPOINTER);

      // ﭨ  ⮣ࠬ
      cxPointer += 5;
      return FALSE;
    }

    case WM_PAINT:
    {
      // 砥 ࠭⢮ ⮡ࠦ
      hps = WinBeginPaint(hWnd, NULLHANDLE, &rec);

      // 訢 , ॡ 
      WinFillRect(hps, &rec, CLR_WHITE);

      // 㥬 ⠭ ࠦ  
      x = 0;
      y = cyClient - cyPointer;
      DrawMousePtr(hps, x, y, SPTR_ARROW);

      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_TEXT);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_WAIT);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_MOVE);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_SIZENWSE);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_SIZENESW);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_SIZEWE);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_SIZENS);

      // 㥬 ⠭ ⮣ࠬ
      x = 0;
      y = cyClient - 3*cyPointer;
      DrawMousePtr(hps, x, y, SPTR_APPICON);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_ICONINFORMATION);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_ICONQUESTION);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_ICONERROR);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_ICONWARNING);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_ILLEGAL);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_FILE);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_MULTFILE);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_FOLDER);
      x += cxPointer;
      DrawMousePtr(hps, x, y, SPTR_PROGRAM);

      // ᢮ ࠭⢮ ⮡ࠦ
      WinEndPaint(hps);
      return 0;
    }

    case WM_MOUSEMOVE:
    {
       // 砥 䨪 ⠭⭮
       // ⮣ࠬ SPTR_ICONINFORMATION
       hptr = WinQuerySysPointer(HWND_DESKTOP,
          SPTR_ICONINFORMATION, FALSE);

       // ⠭   ⠪: ⮡ 
       //   ⮣ࠬ SPTR_ICONINFORMATION
       WinSetPointer(HWND_DESKTOP, hptr);
       return (MRESULT)TRUE;
    }

    case WM_ERASEBACKGROUND:
      return(MRFROMLONG(1L));

    //   ࠧ஢  ਫ
    // ᮢ뢠  ᮤন
    case WM_SIZE:
    {
      // ࠭塞 ࠧ  Client Window
      cxClient = SHORT1FROMMP(mp2);
      cyClient = SHORT2FROMMP(mp2);

      // 塞  Client Window
      WinInvalidateRect(hWnd, NULL, TRUE);
      return 0;
    }

    // 믮塞     
    case WM_CHAR:
    {
      // 㥬 ᮮ饭, ᮮ⢥騥 ⦠
      // ,  ⠪ ᮮ饭   
      if((CHARMSG(&msg) ->fs & KC_KEYUP) |
         (!(CHARMSG(&msg) ->fs & KC_VIRTUALKEY)))
         return 0;

      // ।塞 ⥪   
      //  ࠭ न
      WinQueryPointerPos(HWND_DESKTOP, &ptl);

      // ८ࠧ㥬 ࠭ न  
      WinMapWindowPoints(HWND_DESKTOP, hWnd, &ptl, 1);

      // ࠭塞 ⥪騥  न 
      xMouse = ptl.x;
      yMouse = ptl.y;

      // 塞 न  ᮮ⢥⢨ 
      // 㠫  ⮩ 
      switch(CHARMSG(&msg) ->vkey)
      {
        case VK_LEFT:
        {
          xMouse -= cxPointer;
          break;
        }
        case VK_RIGHT:
        {
          xMouse += cxPointer;
          break;
        }
        case VK_DOWN:
        {
          yMouse -= cyPointer;
          break;
        }
        case VK_UP:
        {
          yMouse += cyPointer;
          break;
        }
        case VK_HOME:
        {
          xMouse = cxPointer;
          yMouse = cyClient - cyPointer;
          break;
        }
        case VK_END:
        {
          xMouse = cxClient - cxPointer;
          yMouse = cyPointer;
          break;
        }
        default:
          break;
      }

      //  ᪠ 室    ।
      //  ਫ
      ptl.x = max(min(xMouse, cxClient - 1), 0);
      ptl.y = max(min(yMouse, cyClient - 1), 0);

      // ८ࠧ㥬  न  ࠭
      WinMapWindowPoints(hWnd, HWND_DESKTOP, &ptl, 1);

      // ⠭    
      WinSetPointerPos(HWND_DESKTOP,
        (SHORT) ptl.x, (SHORT) ptl.y);

      return 0;
    }

    default:
      return(WinDefWindowProc(hWnd, msg, mp1, mp2));
  }
}

// =================================================
// 㭪 ᮢ  
// =================================================

void DrawMousePtr(HPS hps, LONG x, LONG y, LONG lPtrId)
{
  HPOINTER hptr;

  // 砥 䨪 ⠭⭮  
  hptr = WinQuerySysPointer(HWND_DESKTOP,
    lPtrId, FALSE);

  // 㥬 ࠦ  
  WinDrawPointer(hps, x, y, hptr, DP_NORMAL);
}
