#include <stdio.h>
#include <stdlib.h>
#include "sysp.h"

void main(int, char *[]);

void main(int argc, char *argv[]) {

	printf("ᯥ⪠  EXE-䠩\n"
			 "Copyright (C)Frolov A., 1990\n\n");

	if( argc != 2 ) {
		printf( "    EXE-䠩  ⢥ ࠬ\n" );
		exit(0);
	}

	if( gethdr( argv[1]) != 0) {
			printf( "訡  ଠ 䠩   ⠪ 䠩\n" );
			exit(0);
	}
	exit(0);
}

int gethdr( char *path) {

	EXE_HDR     header;
	RELOC_TAB   *reloc;
	FILE        *inpfile;
	int         i;

	if((inpfile = fopen(path,"rb")) == 0) return(-1);

	if(get_exeh(&header,&reloc,inpfile) != 0) {
		fclose(inpfile);
		return(-1);
	}
	printf("᪮ ᫮:                    %04X\n"
			 " ᫥ ࠭ 䠩:      %d\n"
			 "⢮ ࠭  䠩:          %d\n"
			 ". ⮢ ⠡. ६饭:    %d\n"
			 "   ࠣ:       %d\n"
			 "쭠   ணࠬ:    %04X\n"
			 "ᨬ쭠   ணࠬ:   %04X\n"
			 "祭  ⥪ SS:SP:         %04X:%04X\n"
			 "஫쭠 㬬:                   %04X\n"
			 "祭  ॣ஢ CS:IP:        %04X:%04X\n"
			 "饭 ⠡. ६饭:          %02X\n"
			 " ૥:                       %d\n",
			 header.signature,
			 header.part_pag,
			 header.file_size,
			 header.rel_item,
			 header.hdr_size,
			 header.min_mem,
			 header.max_mem,
			 header.ss_reg,
			 header.sp_reg,
			 header.chk_summ,
			 header.cs_reg,
			 header.ip_reg,
			 header.relt_off,
			 header.overlay);


	if(reloc != 0) {
		printf("\nন ⠡ ६饭:\n\n");

		for(i=0;i < header.rel_item; i++) {
			printf("%04X:%04X\n",
			(reloc+i)->segment,
			(reloc+i)->offset);

		}
		free(reloc);
	}
	fclose(inpfile);
	return(0);
}
