;
; 樮 ࠩ ᨬ쭮 ன⢠
;
; Copyright (C)Frolov A., 1990
;

	  .MODEL tiny
	  .CODE        ; ࠩ ⮨  
						; ᥣ 

	  org 0        ;  ப  ⢮

	  include sysp.inc

devdrv    PROC far

;  ࠩ

	  dd   0ffffffffh       ; ᫥饣 ࠩ
	  dw   0C800h           ; ਡ⮢
	  dw   dev_strategy     ; 楤 ⥣
	  dw   dev_interrupt    ; 楤 뢠
	  db   'DEVDRIVR'       ; ன⢠ ( ஡)

;======================================================================

; ணࠬ ⥣

dev_strategy:
		mov  cs:req_seg,es
		mov  cs:req_off,bx
		ret

;     

req_seg         dw ?
req_off         dw ?

;======================================================================

;ࠡ稪 뢠

dev_interrupt:
	push es     ;࠭塞 ॣ
	push ds
	push ax
	push bx
	push cx
	push dx
	push si
	push di
	push bp

; ⠭ ES:BX   

	mov  ax,cs:req_seg
	mov  es,ax
	mov  bx,cs:req_off

; 砥       㬭
;   , ⮡ ᯮ짮  ⢥ 
; ⠡ ᮢ ࠡ稪 

	mov  al,es:[bx]+2
	shl  al,1

	sub  ah,ah            ; 塞 AH
	lea  di,functions     ; DI 㪠뢠  ᬥ饭 ⠡
	add  di,ax            ; 塞 ᬥ饭  ⠡
	jmp  word ptr [di]    ; 室    ⠡

functions   LABEL  WORD  ;  㭪権

   dw   initialize
   dw   check_media
   dw   make_bpb
   dw   ioctl_in
   dw   input_data
   dw   nondestruct_in
   dw   input_status
   dw   clear_input
   dw   output_data
   dw   output_verify
   dw   output_status
   dw   clear_output
   dw   ioctl_out
	dw   Device_open
	dw   Device_close
   dw   Removable_media
	dw   reserved
	dw   reserved
	dw   reserved
	dw   generic_ioctl

; 室  ࠩ, ᫨ 㭪  ন

check_media:
make_bpb:
clear_input:
output_verify:
clear_output:
Removable_media:
reserved:
generic_ioctl:

; 뢮 ᮮ饭  맮
; ন ࠩ஬ 

	mov ax,cs
	mov ds,ax
	mov si,offset errmsg
	call dpc

;     

	mov ax,0
	int 16h

; ⠭ ਧ 訡

	or   es:word ptr [bx]+3,8103h
   jmp  quit

;======================================================================

nondestruct_in:

; 뢮 ᮮ饭  砫 ࠧ饣 

	mov ax,cs
	mov ds,ax
	mov si,offset inpmsg_nd
	call dpc

;  ᨬ    頥
;    

	mov  ax,0
	int  16h
	mov  BYTE PTR es:[bx]+0dh,al

	jmp  quit

;======================================================================

input_status:

; 뢮 ᮮ饭  맮 
; ஢ન ﭨ 

	mov ax,cs
	mov ds,ax
	mov si,offset statmsg_i
	call dpc

; ⠭ ਧ "", ..
; ᫥  ⥭ ਢ  
;    (ਧ  ᯮ)

	or   es:word ptr [bx]+3,0200h
	jmp  quit

;======================================================================

output_status:

; 뢮 ᮮ饭  맮 
; ஢ન ﭨ 뢮

	mov ax,cs
	mov ds,ax
	mov si,offset statmsg_o
	call dpc

;    ⠭, ..
; ⠥,  ᮫ 㯭  뢮

	or   es:word ptr [bx]+3,0000h
	jmp  quit

;======================================================================

; ࠡ稪  뢮 

output_data:

; 뢠  ॣ CL ⢮
; 뢮 ᨬ

	mov  cl,es:[bx]+18
	push cx

; 뢮 ᮮ饭  砫 뢮

	mov ax,cs
	mov ds,ax
	mov si,offset outmsg
	call dpc

	pop cx

; 㦠  DS:SI   

	mov  ax,es:[bx]+16
	mov  ds,ax
	mov  si,es:[bx]+14

; 뢮  ࠭ ᨬ  

out_loop:
	mov  al,ds:byte ptr [si]
	@@out_ch al
	inc si
	loop out_loop

	jmp  quit


;======================================================================

; ࠡ稪   

input_data:

; 뢠  ॣ CL ⢮
;  ᨬ

	mov  cl,es:[bx]+18
	push cx

; 뢮 ᮮ饭  砫 

	mov ax,cs
	mov ds,ax
	mov si,offset inpmsg
	call dpc

; 㦠  DS:SI   

	pop  cx
	mov  ax,es:[bx]+16
	mov  ds,ax
	mov  di,es:[bx]+14

;  ᨬ    뢠  

inp_loop:
	mov  ax,0
	int  16h
	mov  ds:byte ptr [di],al
	@@out_ch al
	inc di
	loop inp_loop

	jmp  quit

;======================================================================

; ࠡ稪  뢮  IOCTL

ioctl_out:

; 뢠  ॣ CL ⢮
; 뢮 ᨬ

	mov  cl,es:[bx]+18

; 㦠  DS:SI   

	mov  ax,es:[bx]+16
	mov  ds,ax
	mov  si,es:[bx]+14

; 뢮  ࠭ ᨬ  

ioctl_out_loop:
	mov  al,ds:byte ptr [si]
	@@out_ch al
	inc si
	loop ioctl_out_loop

	jmp  quit


;======================================================================

; ࠡ稪    IOCTL

ioctl_in:

; 뢠  ॣ CL ⢮
;  ᨬ

	mov  cl,es:[bx]+18

; 㦠  DS:SI   

	mov  ax,es:[bx]+16
	mov  ds,ax
	mov  di,es:[bx]+14

;  ᨬ    뢠  

ioctl_inp_loop:
	mov  ax,0
	int  16h
	mov  ds:byte ptr [di],al
	@@out_ch al
	inc di
	loop ioctl_inp_loop

	jmp  quit

;======================================================================

Device_open:

; 뢮 ᮮ饭  ⨨ ன⢠

	mov ax,cs
	mov ds,ax
	mov si,offset openmsg
	call dpc

	jmp quit

;======================================================================

Device_close:

; 뢮 ᮮ饭  ⨨ ன⢠

	mov ax,cs
	mov ds,ax
	mov si,offset closemsg
	call dpc

	jmp quit

;======================================================================

quit:
	or   es:word ptr [bx]+3,100h
	pop bp
	pop di
	pop si
	pop dx
	pop cx
	pop bx
	pop ax
	pop ds
	pop es
   ret

;======================================================================

parm_off dw ? ; 饭 ப ࠬ஢
parm_seg dw ? ;  ப ࠬ஢

pc_type  dw ? ;    ࠭
int_num  dw ? ; 祭 ࠬ஢
out_port dw ?
inp_port dw ?
ctrl_inp_port dw ?
ctrl_out_port dw ?

;======================================================================
;**
;
;.Name         INTERRUPT
;.Title        ࠡ稪 뢠
;.Synopsis
;-
;  int <NN>
;
;  室:  NN -  뢠,   䠩 CONFIG.SYS
;         AH -  믮塞 㭪樨:
;                0 -  ;
;                1 -  ⥭
;         BH -  (0...7Fh)
;         BL -    (0...FFh)
;  室: BL - ⠭ 
;-
;.Description
;-
;     뢠 뢠  INT <NN>  ࠬࠬ:
;
; 室:  NN -  뢠,   䠩 CONFIG.SYS
;        AH -  믮塞 㭪樨:
;               0 -  ;
;               1 -  ⥭
;        BH -  (0...7Fh)
;        BL -    (0...FFh)
; 室: BL - ⠭ 
;-
;.Returns
; BL - ⠭ 
;.Version 1.00 (c)Copyright Frolov, 1990
;-
;**

interrupt:
	push ax
	push cx
	push dx
	push bp
	push si
	push di
	push ds
	push es

	cmp ah,0      ;  
	jz int_write
	cmp ah,1      ;  ⥭
	jz int_read

; ࠡ⪠ ⭮ 

	@@out_ch 13,10,'?','?','?',13,10

; ⠭ ਧ 訡

	mov ax,0ffffh
	jmp int_exit

int_write:

; 뢮 ᮮ饭  室 뢠,
; ।祭  

	@@out_ch 13,10,'W','R','I','T','E',13,10

	mov ax,0
	jmp int_exit

int_read:

; 뢮 ᮮ饭  室 뢠,
; ।祭  ⥭

	@@out_ch 13,10,'R','E','A','D',13,10

;  ⥭, ᥣ 頥 祭 55h

	mov bl,55h
	mov ax,0
	jmp int_exit

int_exit:
	pop es
	pop ds
	pop di
	pop si
	pop bp
	pop dx
	pop cx
	pop ax

	iret
;======================================================================

; 楤 뢮  ࠭ ப
; ᨬ  ଠ ASCIIZ

dpc proc near
	push si
dpc_loop:
	cmp  ds:byte ptr [si],0
	jz   end_dpc
	mov  al,ds:byte ptr [si]
	@@out_ch al
	inc si
	jmp dpc_loop

end_dpc:
	pop si
	ret
dpc endp

;======================================================================

hello db 13,10,'ͻ'
		db 13,10,'  *DEVDRV* (C)Frolov A., 1990   '
      db 13,10,'ͼ'
		db 13,10,0

outmsg   DB 13,10,' 뢮  ன⢮ DEVDRIVR ',0
inpmsg   DB 13,10,'   ன⢠   DEVDRIVR ',0

openmsg  db 13,10,' 뢠 DEVDRIVR ',0
closemsg db 13,10,' 뢠 DEVDRIVR ',0

inpmsg_nd DB 13,10,' ND-  ன⢠    DEVDRIVR ',0
statmsg_i DB 13,10,' ⥭ ﭨ   DEVDRIVR ',0
statmsg_o DB 13,10,' ⥭ ﭨ 뢮 DEVDRIVR ',0

errmsg    DB 13,10,'   ন DEVDRIVR ',0

;======================================================================

E_O_P:            ;⪠  ணࠬ

initialize:

   lea  ax,E_O_P      ;ᬥ饭  ணࠬ  AX
   mov  es:word ptr [bx]+14,ax   ;頥   
   mov  es:word ptr [bx]+16,cs   ;

	mov  ax,es:word ptr [bx]+18   ;ᬥ饭 ப ࠬ஢
	mov  cs:parm_off,ax

	mov  ax,es:word ptr [bx]+20   ;ᥣ ப ࠬ஢
	mov  cs:parm_seg,ax

; ࠥ ࠭

	mov   dh,18h
	mov   dl,80h

	xor   cx,cx
	mov   bh,7
	xor   al,al
	mov   ah,6
	int   10h

; ⠭    孨 㣮 ࠭

	mov   bh,0
	xor   dx,dx
	mov   ah,2
	int   10h

; 뢮 ᮮ饭

	mov ax,cs
	mov ds,ax
	mov si,offset hello
	call dpc

; ᪮㥬 ப ࠬ஢  ஢塞
; ४⭮  ࠬ஢

	push     cs
	pop      ds

	mov      bx, cs:parm_off   ; ES:BX -  ப ࠬ஢
	mov      ax, cs:parm_seg
	mov      es, ax

;  砫  ࠬ஢

	mov      bp, OFFSET cs:pc_type

; 㥬 ࠬ

	call     parm
	jc       parm_errors

; ⠭  뢠  ஬,
;   ப ௠஢

	push cs
	pop ds
	mov dx,OFFSET cs:interrupt
	mov ax,cs:int_num
	mov ah,25h
	int 21h

	jmp  quit


parm_errors:

; ᫨ ࠬ   訡,
; ⠭ ࠩ  ந.

	mov  ax,cs:req_seg    ;ES:BX 㪠뢠   
	mov  es,ax
	mov  bx,cs:req_off

	lea  ax,devdrv       ;ᬥ饭 砫 
	mov  es:word ptr [bx]+14,ax   ;頥   
	mov  es:word ptr [bx]+16,cs   ;

	jmp quit

;======================================================================

parm proc near

				xor      si, si ;   ப ࠬ஢

next_chr:   mov      al, BYTE PTR es:[bx][si]
				cmp      al, 0ah  ; ஢ન  
				je       parm_br  ; ப ࠬ஢
				cmp      al, 0dh
				je       parm_br
				cmp      al, 0h
				jz       parm_br

; 㥬 ।  ப ࠬ஢  

				mov      BYTE PTR cs:parm_buffer[si], al
				inc      si
				jmp      next_chr

; 뢠 ᪮஢ ப ࠬ஢ 㫥

parm_br:    mov      BYTE PTR cs:parm_buffer[si], 0

; ⠢ ॣ  맮 ணࠬ
;  ࠬ஢  ஢塞 ࠢ쭮
;  ࠬ஢

				mov      dx, OFFSET sep
				mov      cl, 6
				mov      bx, OFFSET cs:parm_buffer

				call     get_parm
				jc       err_msg

				mov      ax,cs:pc_type
				cmp      ax,0
				jz       model_is_valid
				cmp      ax,1
				jz       model_is_valid

				jmp      err_msg

model_is_valid:

; ᫨ ࠬ  ࠢ쭮,
; 뢮  祭  ࠭

				mov      si, OFFSET msg1
				call     dpc
				mov      ax,cs:pc_type
				call     print_word

				mov      si, OFFSET msg2
				call     dpc
				mov      ax,cs:int_num
				call     print_word

				mov      si, OFFSET msg3
				call     dpc
				mov      ax,cs:out_port
				call     print_word

				mov      si, OFFSET msg4
				call     dpc
				mov      ax,cs:inp_port
				call     print_word

				mov      si, OFFSET msg41
				call     dpc
				mov      ax,cs:ctrl_inp_port
				call     print_word

				mov      si, OFFSET msg42
				call     dpc
				mov      ax,cs:ctrl_out_port
				call     print_word

				@@out_ch  13,10,13,10
				clc
				jmp      end_of_parm
err_msg:

; ᫨ 뫨 訡  ࠬ, 뢮
; ᮮ饭  訡,
; ᠬ 訡 ப ࠬ஢
;      .
;  室 ⠭ 䫠 CARRY

				mov      si, OFFSET msg5
				call     dpc

				mov      ds,cs:parm_seg
				mov      si,cs:parm_off
				call     dpline

				mov      ax,cs
				mov      ds,ax
				mov      si, OFFSET msg6
				call     dpc

				mov  ax,0
				int  16h
				stc
end_of_parm:  ret

parm_buffer db  100 DUP (?)

sep     db      " ",0
msg1    db      13,10,"Personal Computer Type  ........ ",0
msg2    db      13,10,"Used Interrupt Number   ........ ",0
msg3    db      13,10,"Device Input Port       ........ ",0
msg4    db      13,10,"Device Output Port      ........ ",0
msg41   db      13,10,"Device Inp Control Port ........ ",0
msg42   db      13,10,"Device Out Control Port ........ ",0

msg5    db      13,10,"Driver Parameters Error!",13,10,0

msg6    db      13,10,13,10,"  Press any key...",13,10,0

parm endp

;**
;
;.Name         get_parm
;.Title         ப ࠬ஢.
;.Synopsis
;
;              ds:bx  -  室 ப,  㫥
;              ds:dx  -  ப  ᥯஢,  㫥
;              ds:bp  -   ࠬ஢
;                 cx  -  ᫮ ࠬ஢
;
;.Description
;              室 ப ds:bx, ࠧ ᥯ࠬ
; ds:dx,   cx ࠬ஢  稭  
;  ணࠬ ࠧࠥ; ࠬ - ⭠
; .  ᫮, ᮮ⢥騥 ࠬࠬ,
; ᫥⥫쭮    ࠬ஢ ds:bp.
;
;.Returns       砥 訡 ⠭ 䫠 ७.
;
;.Version 1.00 (c)Copyright Frolov G., 1990
;**

get_parm proc near

				push  bx
				push  cx
				push  ax
				push  si

				xor   ch, ch
				xor   ax, ax
				mov   si, ax

				call  strtoc
				jc    parm_end
parm_loop:
				mov   ax, 22h
				call  strtoc
				jc    parm_end
				call  hex_to_bin
				jc    parm_end
				mov   ds:[bp][si], ax
				inc   si
				inc   si
				loop  parm_loop
parm_end:
				pop   si
				pop   ax
				pop   cx
				pop   bx

				ret

get_parm endp


;**
;
;.Name         strtoc
;.Title        뤥 । ᫮  ப.
;.Synopsis
;
;         1)  ࢮ 饭  楤:
;           室:
;              ax = 0
;              ds:bx  -  室 ப,  㫥
;              ds:dx  -  ப  ᥯஢,  㫥
;           室:
;              ds:bx  -  ப  ࢮ ࠧ⥫,  㫥
;         2)  ᫥ 饭
;           室:
;              ax != 0
;              ds:dx  -  ப  ᥯஢,  㫥
;           室:
;              ds:bx  -  ப  ᫥饣 ࠧ⥫,  㫥
;
;.Description     ࢮ 맮 뤥  ப ࢮ ᫮
;                 ࠧ⥫.  ୮ 맮 頥
;                㪠⥫  ᫥饥 ᫮  室 ப.
;                ᫨  ᫮  ப 㦥 뤥, ⠭
;                䫠 ७.
;
;.Version 1.00 (c)Copyright Frolov G., 1990
;**

strtoc proc near

				push  bp
				push  di

				mov   space, 0

				cmp   ax, 0
				jz    first

				mov   bx, cs:ds1_off
				mov   ax, cs:ds1_seg
				mov   ds, ax

first:      cmp   BYTE PTR ds:[bx], 0
				jz    error

				mov   bp, bx
str_begin:  mov   di, dx

compe:      mov   ah, BYTE PTR ds:[bp]
				cmp   ah, 0
				jz    lab
				cmp   BYTE PTR ds:[di], ah
				jne   next
				mov   BYTE PTR ds:[bp], 0
				inc   bp
				inc   BYTE PTR cs:space
				jmp   str_begin

lab:        mov   WORD PTR cs:ds1_off, bp
				mov   ax, ds
				mov   WORD PTR cs:ds1_seg, ax
				jmp   end_proc

next:       inc   di
				cmp   BYTE PTR ds:[di], 0
				jnz   compe
				cmp   BYTE PTR cs:space, 0
				jnz   lab
				inc   bp
				jmp   str_begin

error:      stc
end_proc:   pop   di
				pop   bp

				ret

ds1_off     dw    ?
ds1_seg     dw    ?
space       db    ?

strtoc endp


;**
;
;.Name         hex_to_bin
;.Title        ८ࠧ  hex ப  筮 ᫮.
;.Synopsis
;
;           室:
;              ds:bx  -  室 ப,  㫥
;           室:
;                 ax  -  ᮮ⢥饥 ப ᫮
;
;.Description  ८ࠧ ப  ascii ᨬ  hex ଥ
;                16 ⮢  .
;               砥 ९  ᫨ ப ᮤন
;              ᨬ  ࠢ 0..9 , A..F , a..f ⠭
;              䫠 ७.
;
;.Version 1.00 (c)Copyright Frolov G., 1990
;**
hex_to_bin PROC NEAR

				push  bp
				push  si
				push  dx

				xor   ax, ax
				mov   bp, bx

begin:      cmp   BYTE PTR ds:[bp], 0h
				jz    end_pro
				call  hex
				jc    h_error

				mov   si, 10h
				xor   dx, dx
				mul   si
				cmp   dx, 0
				jnz   h_error

				add   ax, bx
				inc   bp
				jmp   begin

h_error:    stc
end_pro:
				pop  dx
				pop  si
				pop  bp

				ret
hex_to_bin endp


hex proc near
				xor   bh, bh
				mov   bl, BYTE PTR ds:[bp]

				cmp   bl, '0'
				jb    hex_error
				cmp   bl, '9'
				ja    next_big
				and   bx, 0fh
				jmp   ok

next_big:   cmp   bl, 'A'
				jb    hex_error
				cmp   bl, 'F'
				ja    next_small
				sub   bl, 37h
				jmp   ok

next_small: cmp   bl, 'a'
				jb    hex_error
				cmp   bl, 'f'
				ja    hex_error
				sub   bl, 57h
				jmp   ok

hex_error:  stc
ok:         ret

hex endp


;**
;
;.Name         dec_to_bin
;.Title        ८ࠧ  dec ப  筮 ᫮.
;.Synopsis
;
;           室:
;              ds:bx  -  室 ப,  㫥
;           室:
;                 ax  -  ᮮ⢥饥 ப ᫮
;
;.Description  ८ࠧ ப  ascii ᨬ  dec ଥ
;                16 ⮢  .
;               砥 ९  ᫨ ப ᮤন
;              ᨬ  ࠢ 0..9 ⠭ 䫠 ७.
;
;.Version 1.00 (c)Copyright Frolov G., 1990
;**
dec_to_bin proc near

				push  bp
				push  si
				push  dx

				xor   ax, ax
				mov   bp, bx
d_begin:    cmp   BYTE PTR ds:[bp], 0h
				jz    d_end_pro

				cmp   BYTE PTR ds:[bp], '0'
				jb    d_error
				cmp   BYTE PTR ds:[bp], '9'
				ja    d_error
				mov   si, 10
				xor   dx, dx
				mul   si
				cmp   dx, 0
				jnz   d_error
				mov   bl, BYTE PTR ds:[bp]
				and   bx, 0fh
				add   ax, bx
				inc   bp
				jmp   d_begin
d_error:    stc
d_end_pro:
				pop  dx
				pop  si
				pop  bp

				ret

dec_to_bin endp

print_word proc near
;--------------------
	  push ax
	  push bx
	  push dx
;
	  push ax
	  mov cl,8
	  rol ax,cl
	  call byte_to_hex
	  mov bx,dx
	  @@out_ch bh
	  @@out_ch bl
;
	  pop ax
	  call byte_to_hex
	  mov bx,dx
	  @@out_ch bh
	  @@out_ch bl
;
	  pop dx
	  pop bx
	  pop ax
	  ret
print_word endp

byte_to_hex proc near
;--------------------
; al - input byte
; dx - output hex
;--------------------
	  push ds
	  push cx
	  push bx
;
	  lea bx,tabl
	  mov dx,cs
	  mov ds,dx
;
	  push ax
	  and al,0fh
	  xlat
	  mov dl,al
;
	  pop ax
	  mov cl,4
	  shr al,cl
	  xlat
	  mov dh,al
;
	  pop bx
	  pop cx
	  pop ds
	  ret
;
tabl db '0123456789ABCDEF'
byte_to_hex endp

;======================================================================
dpline proc near
	push si
dpline_loop:
	cmp  ds:byte ptr [si],0dh
	jz   end_dpline
	cmp  ds:byte ptr [si],0ah
	jz   end_dpline

	mov  al,ds:byte ptr [si]
	@@out_ch al
	inc si
	jmp dpline_loop

end_dpline:
	pop si
	ret
dpline endp

devdrv  ENDP

		  END devdrv
