#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include "sysp.h"

void main(int argc, char *argv[]);
void show(DFCB far *);

void main(int argc, char *argv[]) {

	 CVT far *cvt;
	 DFT far *dft;
	 unsigned i,j,k;
	 DFCB far *dfcb, far *file_dfcb;
	 int handle, flag, disk;

	 BOOT far *boot_rec;
	 int status;
	 char *buf;

	 char drive[_MAX_DRIVE], dir[_MAX_DIR];
	 char fname[_MAX_FNAME], ext[_MAX_EXT];
	 char name[12];

	 printf("ଠ   䠩 DOS\n"
			  "Copyright Frolov A. (C),1990\n");

	 printf("᫥㥬 ᯮ 䠩 '%s'\n", argv[1]);

// 뢠 䠩,  ண 㤥  ᯨ᮪ ஢

	 handle = open(argv[1], O_BINARY);
	 if(handle == 0) {
		printf("訡  ⨨ 䠩!\n");
		exit(-1);
	 }

//   䠩  ⠢騥 :
//   - 㪢 ᪠;
//   - ⠫;
//   -  䠩;
//   - ७ 

	 _splitpath(argv[1], drive, dir, fname, ext);

// 㥬 ப    ७

	 strcpy(name,fname);
	 for(i=0; i<8; i++) {
		if(name[i] == 0) break;
	 }
	 for(; i<8; i++) name[i] = ' ';
	 name[8] = 0;
	 strcat(name, &ext[1]);

// ८ࠧ㥬 ப    㪢

	 strupr(name);

// 塞  ᪮

	 drive[0] = toupper(drive[0]);
	 disk = drive[0] - 'A';

	 printf("%s - %s - %s - %s : %s\n",
		drive, dir, fname, ext, name);


	 cvt=get_mcvt();     //  ୮ ⠡ 裡
	 dft=get_fdft(cvt);  //  砫 ⠡ 䠩

// 뢠 䫠 ᪠ 䠩

	 flag = 0;

	 for(;;) {
		if(dft == (DDCB far *)0) break;  //  ⠡ 䠩

		i=dft->file_count;

		for(j=0;j<i;j++) {   //   䠩 ࠢ騬 

			dfcb=(&(dft->dfcb))+j; //  DFCB 䠩

// 饬 䠩  ⠡  䠩

			k = memcmp(name,dfcb->filename,11);
			if(k == 0) {

				printf(" !\n");
				printf("\nDFCB 䠩: %Fp\n\n",dfcb);

//   ⠡   䠩

				file_dfcb = dfcb;

// 뢠 ᮤন ⠡   䠩

				show(file_dfcb);
				flag = 1;
				break;
			}

		 }
		 dft=get_ndft(dft);

		 if(flag == 1) break;
	 }

	 if(flag == 0) {
		printf("  ");
		close(handle);
		exit(-1);
	 }

// 뢠   ⥭ BOOT-.
//   ᢠ FAR-㪠⥫.

	 boot_rec = malloc(sizeof(*boot_rec));

// ⠥ 㧮   

	 status = getboot((BOOT far*)boot_rec, disk);

// 塞 ࠧ   

	 i = boot_rec->bpb.clustsize * boot_rec->bpb.sectsize;
	 printf("\n , ⮢ : %d",i);

// ᫨ ந諠 訡 (ਬ, ࠢ쭮 㪠
// 祭 ᪠), 蠥 ࠡ ணࠬ

	 if(status) {
		printf("\n訡  ⥭ BOOT-ᥪ");
		close(handle);
		exit(-1);
	 }

	 buf = malloc(i);

	 printf("\n᮪ ஢ 䠩:\n");

// ⠥ 䠩  ࠬ, 뢮 
// ᫥ ⠭ , 
// ६  ⠡ 䠩

	 for(;;) {

		read(handle, buf, i);
		if(eof(handle)) break;
		printf("%d ",file_dfcb->last_clu);

	 }

	 close(handle);
	 free(boot_rec);
	 free(buf);
	 exit(0);
}

// 㭪  ⮡ࠦ ᮤন ⠡ 䠩

void show(DFCB far *dfcb) {

	int k;

	printf(" 䠩: ");
	for(k=0;k<11;k++) {
		putchar(dfcb->filename[k]);
	}

	printf("\n⢮ file handles:       %d\n"
		" 㯠:                 %d\n"
			" reserv1:                  %04X\n"
			"ଠ  ன⢥:      %04X\n"
			" ࠩ:                %Fp\n"
			"砫 :             %d\n"
			"६:                         %04X\n"
			":                          %04X\n"
			" 䠩  :         %ld\n"
			"饥 ᬥ饭  䠩:      %ld\n"
			" reserv2:                  %04X\n"
			"᫥ ⠭ : %d\n"
			" PSP  䠩:   %04X\n"
			" reserv7:                  %d\n"
			"--------------------------------------\n\n",
			dfcb->handl_num,
			dfcb->access_mode,
			dfcb->reserv1,
			dfcb->dev_info,
			dfcb->driver,
			dfcb->first_clu,
			dfcb->time,
			dfcb->date,
			dfcb->fl_size,
			dfcb->offset,
			dfcb->reserv2,
			dfcb->last_clu,
			dfcb->ownr_psp,
			dfcb->reserv7);
}
