#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include "tsrdemo.h"

int write_buf(void);

extern unsigned keycode;
int name_counter = 0;

// ========================================
// application(void)
// 뢠  ⨢樨 TSR.  ⮩
// 㭪樨  뢠 뢠 MS-DOS
// ========================================
void application(void)
{
  if(keycode == HotKeyRecording)
  {
      write_buf();
      Beep();
  }
}

// ========================================
// Beep
// 뤠 㪮 ᨣ.
// ========================================
void Beep(void)
{
  union REGS regs;
  regs.x.ax = 0x0e07;
  regs.x.bx = 0x0000;
  int86(0x10, &regs, &regs);
}

// ========================================
// get_vmode
// 㭪 頥 
// ⥪饣 ०
// ========================================
int get_vmode(void)
{
  char far *ptr;

  // 砥 㪠⥫  , ᮤঠ騩
  //  ⥪饣 ०
  ptr = (char far*)MK_FP(0x40, 0x49);
  return(*ptr);
}

// ========================================
// get_vbuf
// 㭪 頥 ᥣ 
// . 뢠 ᮤন
// ॣ஢ ᬥ饭  .
// ========================================
int get_vbuf(int vmode)
{
  unsigned vbase;
  unsigned adr_6845;
  unsigned high;
  unsigned low;
  unsigned offs;

  //  ᨬ  ०  
  //    0xb000  0xb800
  vbase = (vmode == 7) ? 0xb000 : 0xb800;

  // 砥   ஫
  adr_6845 = *(unsigned far*)(MK_FP(0x40, 0x63));

  // 뢠 ᮤন ॣ஢ 12  13
  // ஫
  outp(adr_6845, 0xc);
  high = inp(adr_6845 + 1);

  outp(adr_6845, 0xd);
  low = inp(adr_6845 + 1);

  offs = ((high << 8) + low) >> 4;

  // 塞    
  // ᬥ饭, ⮥  ॣ஢ ஫
  vbase += offs;

  return(vbase);
}

// ========================================
// get_column
// 㭪 頥 ⢮ ᨬ  ப
//  ⥪饣 ०
// ========================================
int get_column(void)
{
  return(*(int _far *)(MK_FP(0x40, 0x4a)));
}

// ========================================
// get_row
// 㭪 頥 ⢮ ப
//  ⥪饣 ०
// ========================================
int get_row(void)
{
  unsigned char ega_info;
  ega_info =
    *(unsigned char far*)(MK_FP(0x40, 0x87));

  // ᫨ ⨯ ஫  EGA,  ࠧ
  // ࠭  ⨪ ⠢ 25 ப.
  // ᫨ ⠭ ஫ EGA, ᫮
  // ப 室   
  // BIOS   0040:0084.

  if(ega_info == 0 || ( (ega_info & 8) != 0) )
  {
    return(25);
  }
  else
  {
    return((*(unsigned char far *)
      (MK_FP(0x40, 0x84))) + 1);
  }
}

// ========================================
// write_buf
// 㭪  ᮤন  
// 䠩
// ========================================
int write_buf(void)
{
  //  ⮨  ⮢ ᨬ  ⮢
  // ਡ⮢.  㦭  ᨬ chr.
  typedef struct _VIDEOBUF_
  {
    unsigned char chr;
    unsigned char attr;
  } VIDEOBUF;

  VIDEOBUF far *vbuf;
  int i, j, k, max_col, max_row;
  FILE *out_file;
  char fname[20], ext[8];

  // ।塞 ०
  i = get_vmode();

  //  ᪮ ० 祣  뢠
  if(i > 3 && i != 7) return(-1);

  // ⠭ 㪠⥫ vbuf  
  vbuf = (VIDEOBUF far *)MK_FP(get_vbuf(i), 0);

  // ।塞 ࠧ ࠭
  max_col = get_column();
  max_row = get_row();

  // ନ㥬  䠩   ࠧ ࠭

  itoa(name_counter++, ext, 10);
  strcpy(fname,"!grab");
  strcat(fname, ext);
  strcat(fname,".scr");

  out_file = fopen(fname,"wb+");

  // 뢠 ᮤন   䠩
  for(i = 0; i < max_row; i++)
  {
    for(j = 0; j < max_col; j++)
    {
      fputc(vbuf->chr, out_file);
      vbuf++;
    }

    //    ப 塞
    // ᨬ ॢ ப 
    //  ⪨
    fputc(0xd, out_file);
    fputc(0xa, out_file);
  }
  fclose(out_file);
  return(0);
}
