#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include "vesa.h"
#include "sysp.h"

// ᠭ 㭪権
int	main( int argc, char * argv[] );
int	GetVESAModeInfo(unsigned, VESAINFO *, VESAMODEINFO	* );
int	AnalyseResult(union REGS);
int	SetSVGAMode(unsigned);
void	WritePixel(VESAMODEINFO*, unsigned, unsigned, unsigned char);

//  㭪
int main( int argc, char * argv[] )
{
	//   祭 ଠ樨  VBE
	VESAINFO			vesaInfo;
	VESAMODEINFO	modeInfo;
	unsigned			modeVESA;

	FILE	*fileVesaReport;
	int   iResult,x,y;

	// ஢ઠ  ப ணࠬ
	if( argc != 2 )
	{
		printf("\nଠ 맮: VESATEST <०>"
			 "\n  <०>: ० ");

		return -1;
	}

	sscanf(argv[1],"%x", &modeVESA);

	// 뢠   vesaInfo  modeInfo
	// ଠ  VBE  
	iResult = GetVESAModeInfo(modeVESA, &vesaInfo, &modeInfo);

	if(iResult != 0) {
		printf("\n࠭  ०  ন");
		return -1;
	}

	if(
		// ਡ  A - 㯭  
		((modeInfo.ucWinAAttr & 5) != 5) ||
		// ⢮ ᫮  - 
		(modeInfo.ucNumPlanes != 1) ||
		// ⢮   ᥫ - ᥬ (256 梥⮢)
		(modeInfo.ucNumPixelBits != 8) ||
		//    (᪠, ᫥⥫쭠)
		(modeInfo.ucTypeMemModel != 4))
	{

		printf("\nணࠬ  c⠭   ०");
		return -1;
	}

	iResult = SetSVGAMode(modeVESA);
	if(iResult != 0) {
		printf("\n訡  ⠭ ० ");
		return -1;
	}

	// ⮡ࠦ , 室   孥 㣫
	//   㣫 45 ࠤᮢ
	for(x = 0; x<600;x++ )
		WritePixel(&modeInfo, x, x, x%256);

	// ,  짮⥫   
	getch();

	// 頥  ⠭ ⥪⮢ ०
	_asm mov	ax,3
	_asm int	10h

	return 0;
}

//=================================================
// 㭪 GetVESAModeInfo
//   ⨯ VESAINFO  VESAMODEINFO
// ᢥﬨ  VBE  ० modeVESA
//=================================================
int
GetVESAModeInfo(unsigned modeVESA, VESAINFO *ptrVesaInfo,
											  VESAMODEINFO	*ptrModeInfo)
{
	union REGS regs;
	struct SREGS segregs;
	int	iResult, i;

	// ⠢   VBE ᨨ 2.0
	strcpy( ptrVesaInfo->cSignature, "VBE2" );

	// 砥   ॠ樨 VBE  
	regs.h.ah = 0x4f;
	regs.h.al = 0x00;
	segregs.es = FP_SEG((void far *) ptrVesaInfo);
	regs.x.di = FP_OFF((void far *) ptrVesaInfo);
	int86x(0x10, &regs, &regs, &segregs);

	// ஢塞 १ 맮 㭪樨 VBE
	if((regs.h.al != 0x4f) || (regs.h.ah != 0)) return -1;

	//  砥 ଠ  ࠭ ० VESA
	for( i=0; i<50; i++ )	 {

		// 砥 ।  ० VESA
		if(ptrVesaInfo->fpModeTable[i] == 0xFFFF)		break;
		if(ptrVesaInfo->fpModeTable[i] != modeVESA)	continue;

		// 砥 ଠ  ० vesaInfo.fpModeTable[i]
		regs.h.ah = 0x4f;
		regs.h.al = 0x01;
		regs.x.cx = ptrVesaInfo->fpModeTable[i];
		segregs.es = FP_SEG((void far *) ptrModeInfo);
		regs.x.di = FP_OFF((void far *) ptrModeInfo);
		int86x(0x10, &regs, &regs, &segregs);

		// ஢塞 १ 맮 㭪樨 VBE
		if((regs.h.al != 0x4f) || (regs.h.ah != 0)) return -1;
		else return 0;
	}
	return iResult;
}

//=================================================
// 㭪 SetSVGAMode
// ⠭ ० vmode
//=================================================
int
SetSVGAMode(unsigned vmode)
{
	union REGS regs;
	int	iResult;

	regs.h.ah = 0x4f;
	regs.h.al = 0x02;
	regs.x.bx = vmode;

	int86(0x10, &regs, &regs);

	if((regs.h.al == 0x4f) && (regs.h.ah == 0))	return 0;
	else return -1;
}

//=================================================
// 㭪 SetSVGAMode
// ⮡ࠦ  ࠭ ᥫ (x,y) 梥⮬ color
// ६ ptrModeInfo  ᮤঠ 㪠⥫
//    VESAMODEINFO
//=================================================
void WritePixel(VESAMODEINFO	*ptrModeInfo,
					unsigned x, unsigned y, unsigned char color) {

	unsigned char	_far *ptr_vbuf;
	unsigned long	ulWinPos, ulOffset, ulWinOffset;
	unsigned 		uWinPos;

	// 塞 ᬥ饭 ᥫ  砫 
	ulOffset = (unsigned long) y *
		(unsigned long) ptrModeInfo->usBytesPerScanLine + (unsigned long) x;

	// 塞   㯠  ⮡ࠦ ᥫ (x,y)
	uWinPos = ((unsigned long) ulOffset /
					(unsigned long) (ptrModeInfo->usWinGranularity)) / 1024;

	// ६頥  A   uWinPos
	_asm {
		mov	ax,4F05h
		mov	bh,0
		mov	bl,0
		mov	dx,uWinPos
		int	10h
	}

	// ।塞   㯠 A
	ptr_vbuf =	(unsigned char _far *) FP_MAKE(ptrModeInfo->usBegSegA,0);

	// ।塞 ᬥ饭 ᥫ (x,y) ⭮⥫쭮  㯠
	ulWinOffset = ulOffset %
		((unsigned long)(ptrModeInfo->usWinGranularity)*1024);

	// ⠭  梥 ᥫ
	*(ptr_vbuf + ulWinOffset) = color;
}
