// ======================================================
//  WAST
// ------------------------------------------------------
//   Windows 
//   MS-DOS
//
//     
// wastdrv.dll  VxD- VXDSRV.386  1.1.
//     Windows.
//    , 
//   WASTDRVR   
// Control Panel
// ------------------------------------------------------
// Copyright (C) 1995  ,  
// ======================================================
#define STRICT
#include <windows.h>
#include <dir.h>

#include "wast.hpp"

BOOL InitApp(HINSTANCE);

static char szDriverName[] = "wastdrv.dll";

struct LOADPARMS
{
  WORD   segEnv;      // 
  LPSTR  lpszCmdLine; //  
  LPWORD lpwShow;     //  
  LPWORD lpwReserved; // 
};
struct LOADPARMS parms;

WORD  awShow[2] = { 2, SW_SHOW };
LPSTR lpszCmd, lpszParm;
char  szCurPath[128];
char  szBuf[256];
// char  szTempBuf[256];

// ======================================================
//  WinMain
// ======================================================
#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpszCmdLine, int nCmdShow)
{
  if(hPrevInstance) //    
    return FALSE;

  //  
  HDRVR hDriver = OpenDriver(szDriverName, NULL, NULL);

  HTASK hTask;

  if(hDriver)
  {
    //     
    hTask = GetCurrentTask();

    //     
    BOOL rc = (BOOL)SendDriverMessage(
          hDriver, UDRV_REGISTERTASK, (LPARAM)hTask, NULL);

    //     ,
    //   vxdsrv.386  
    if(!rc)
    {
      MessageBox(NULL, "Error Loading WAST\n"
       "Driver vxdsrv.386 not found",
       "Windows Application Starter", MB_OK | MB_ICONHAND);
      return FALSE;
    }
  }

  //      ,
  //    
  else
  {
    MessageBox(NULL, "Error Loading WAST\n"
     "Driver wastdrv.dll not found",
     "Windows Application Starter", MB_OK | MB_ICONHAND);
    return FALSE;
  }

  MSG  msg;

  while(GetMessage(&msg, NULL, 0, 0))
  {
    //      wastdrv.dll,
    //  VxD-    
    //   MS-DOS
    if (msg.message == WM_STARTWINAPP)
    {
      //      ,   
      //      
      //    
      HWND hDummyWnd = CreateWindow("static", "", WS_POPUP,
            0, 0, 0, 0, HWND_DESKTOP, NULL, hInstance, NULL);

      ShowWindow(hDummyWnd, SW_SHOW);
      DestroyWindow(hDummyWnd);

      //   
      lpszCmd  = (LPSTR)msg.lParam + 65;

      //   
      lpszParm  = (LPSTR)msg.lParam + 65 + 128;

      //   
      setdisk(*LPSTR(msg.lParam));
      szBuf[0] = *LPSTR(msg.lParam) + 'A';
      szBuf[1] = ':';
      szBuf[2] = '\\';
      lstrcpy(szBuf + 3, LPSTR(msg.lParam) + 1);
      chdir(szBuf);

      //    LoadModule
      lstrcpy(szBuf, (LPCSTR)" ");
      lstrcat(szBuf, (LPCSTR)lpszParm);
      *szBuf = (BYTE)lstrlen(lpszParm);

      if(lstrlen(lpszParm) != 0)
        parms.lpszCmdLine = (LPSTR)szBuf;
      else
        parms.lpszCmdLine = (LPSTR)"";

      parms.segEnv = 0;
      parms.lpwShow = (LPWORD) awShow;
      parms.lpwReserved = (LPWORD) NULL;

      //     
//      lstrcpy(szTempBuf, (LPSTR)msg.lParam + 65);
//      lstrcat(szTempBuf, (LPSTR)msg.lParam + 65 + 128);

      //   Windows
      LoadModule(lpszCmd, &parms);

//      WinExec(szTempBuf, SW_SHOW);
    }

    //      
    //   ,   
    // Control Panel
    else if (msg.message == WM_UNLOADWAST)
      PostQuitMessage(0);
    else
      DispatchMessage(&msg);
  }

  //    
  SendDriverMessage(hDriver, UDRV_UNREGISTERTASK,
     (LPARAM)hTask, NULL);

  //  
  CloseDriver(hDriver, NULL, NULL);

  return msg.wParam;
}
