// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

//    
#define MAIN_MODULE

#include <windows.h>
#include <mem.h>
#include <bwcc.h>
#include "tele.h"

//     
char	szClassName[] = "WMODEM";

//    
char	szWindowTitle[] = "";

//===============================================
//  WinMain
//===============================================
#pragma argsused

int PASCAL
WinMain(	HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPSTR     lpszCmdLine,
			int       nCmdShow)
{
	MSG  msg;   //     
	HWND hwnd;  //    

	// ,      
	if(!hPrevInstance)
	{
		//     hInst  
		hInst = hInstance;

		//   ,   InitApp
		if(!InitApp(hInstance))
			return FALSE;
	}
	else
	{
		MessageBeep(MB_ICONASTERISK);

		BWCCMessageBox( NULL,
			"     ",
			"", MB_OK | MB_ICONSTOP);

		return FALSE;
	}

	//    
	hwnd = CreateWindow(
		szClassName, 
		szWindowTitle,
		WS_OVERLAPPED | WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL,
		hInstance,
		NULL);    

	//     ,  
	if(!hwnd)
	{
		MessageBeep(MB_ICONASTERISK);

		BWCCMessageBox( NULL,
			"     ",
			"", MB_OK | MB_ICONSTOP);

		return FALSE;
	}

	//  
	ShowWindow(hwnd, nCmdShow);

   //     WM_PAINT
	UpdateWindow(hwnd);

	//    
	while (GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}



// =====================================
//  InitApp
// =====================================
BOOL
InitApp(HINSTANCE hInstance)
{
	ATOM aWndClass;		//    
	WNDCLASS wndclass;	//   
								//  

	//       
	memset(&wndclass, 0, sizeof(wndclass));

	wndclass.style				= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc		= (WNDPROC) WndProc;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon				= LoadIcon(hInstance, "PHONE");
	wndclass.hCursor			= LoadCursor( NULL, IDC_ARROW );
	wndclass.hbrBackground	= GetStockObject( WHITE_BRUSH );
	wndclass.lpszMenuName	= (LPSTR) "APP_MENU";
	wndclass.lpszClassName	= (LPSTR) szClassName;

	//    szClassName
	aWndClass = RegisterClass(&wndclass);

	//    
	return(aWndClass != 0);
}

// =====================================
//   WndProc
// =====================================
LRESULT CALLBACK _export
WndProc( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message ) 
	{
		case WM_CREATE:
      {
			//   
			InitTTY( hwnd );

			//   WM_CONNECT
			PostMessage( hwnd,WM_CONNECT,0,0L );
			return 0;
      }

		case WM_CONNECT:
      {
			//    COM-
			idOpenCommPort = InitCommPort(hwnd);

			//        
			if (idOpenCommPort < 0)
			{
				MessageBeep(MB_ICONASTERISK);
				BWCCMessageBox(hwnd,"COM-  ","",
					MB_ICONSTOP | MB_OK);

				PostMessage(hwnd,WM_CLOSE,0,0L);
			}
			return 0;
      }

		case WM_COMMNOTIFY:
      {
			//    WM_COMMNOTIFY
			ProcessCommNotify( hwnd, wParam, LOWORD( lParam ));
			return 0;
      }

		case WM_SETFOCUS:
      {
			//    
			SetFocusTTY(hwnd);
			return 0;
      }

		case WM_KILLFOCUS:
      {
			//    
			KillFocusTTY(hwnd);
			return 0;
      }

		case WM_CHAR:
		{
      	//     
			UserChat(hwnd, message, wParam, lParam);
			return 0;
      }

		case WM_COMMAND:
      {
			switch ( wParam )
			{
				case CM_EXIT:
            {
					PostMessage( hwnd, WM_CLOSE, 0, 0L );
					break;
            }

				case CM_ABOUT:
            {
					About(hwnd);
					break;
            }
			}
			return 0;
      }

		case WM_CLOSE:
		{
      	//  COM-    
			CloseCommPort(idOpenCommPort);

			DestroyWindow( hwnd );
			PostQuitMessage( 0 );
			return 0;
      }

		default:
			return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}
}

// =====================================
//  About
// =====================================
void About(HWND hwnd)
{
	BWCCMessageBox(hwnd,
			" \n\n"
			"(C)  .., 1994",
			"",
			MB_OK | MB_ICONINFORMATION);

   return;
}
